#  (gH)   --  galg2cpp.pm  ;  TimeStamp (unix) : 21 Septembre 01 16:12
#
##########################################################################
#
# Premire version : Benot LAURENT & Emmanuel LONG
#
##########################################################################
#
# Dclarations du package
#

package galg2cpp ;

require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_cpp',
	 'Commentaire_cpp',
	 'Affecter_cpp',
	 'Ecrire_cpp',
	 'Ecrire__cpp',
	 'Ecrire_sur_cpp',
	 'Ouvrir_lec_cpp',
	 'Ouvrir_ecr_cpp',
	 'Fermer_cpp',
	 'Lire_cpp',
	 'Lire_sur_cpp',
	 'Appeler_cpp',
	 'Pour_cpp',
	 'Fin_Pour_cpp',
	 'Si_cpp',
	 'Alors_cpp',
	 'Sinon_cpp',
	 'Fin_Si_cpp',
	 'Tant_Que_cpp',
	 'Fin_Tant_Que_cpp',
	 'Quitter_cpp',
	 'GereOperateur_cpp',
	 'GereFonction_cpp',
	 'GereVarSimple_cpp',
	 'GereVarTableau_cpp',
	 'GereChaine_cpp',
	 'GereCstNum_cpp',
	 'FinProgramme_cpp'
	);

##########################################################################
##########################################################################

# Module utilis

use galgfncs ;

##########################################################################
##########################################################################


##########################################################################
#                                                                        #
#  Gestion de DEBUT et FIN de programme                                  #
#                                                                        #
##########################################################################

#  %TVarType : Tableau contenant les VARiables et leur TYPE dans le langage
#  %TTabType : Tableau contenant les TABleaux et leur TYPE dans le langage

##########################################################################

sub DebutProgramme_cpp {

  print $::SymbFLang "\n";
  print $::SymbFLang "#include <iostream>\n";
  print $::SymbFLang "#include <string>\n" ;
  print $::SymbFLang "#include <fstream>\n";
  print $::SymbFLang "\n typedef char chaine[250] ;\n";

} ; # FIN sub DebutProgramme_cpp

##########################################################################

sub FinProgramme_cpp {

  print $::SymbFLang "return(0);\n} /* fin de main */\n";

} ; # FIN sub FinProgramme_cpp

##########################################################################
###############################################################

##########################################################################
###############################################################
##
## sous-programmes INSTRUCTION
##
## Ecriture dans le fichier
##
##########################################################################

##########################################################################

sub Commentaire_cpp {

  print $::SymbFLang "// ".$_[0];

} ; # FIN sub Commentaire_cpp

##########################################################################

sub Affecter_cpp {

  my $expAff = $_[1] ;
  print $::SymbFLang $_[0]." = ".&convertitExpression_cpp( $expAff )." ;" ;

} ; # FIN sub Affecter_cpp

##########################################################################

sub Ecrire_cpp {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/ << /g;
  print $::SymbFLang "cout << $Phraz << endl ; " ;

} ; # FIN sub Ecrire_cpp

##########################################################################

sub Ecrire__cpp {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/ << /g;
  print $::SymbFLang "cout << $Phraz ; " ;

} ; # FIN sub Ecrire__cpp

##########################################################################

sub Ecrire_sur_cpp {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/ << /g;
  print $::SymbFLang "$_[1] << $Phraz << endl ; " ;


} ; # FIN sub Ecrire__cpp

 ##########################################################################

sub Lire_cpp {

     print $::SymbFLang "cin >> ".$_[0]." ; ";

} ; # FIN sub Lire_cpp

##########################################################################

sub Lire_sur_cpp {

   print $::SymbFLang "$_[1].getline($_[0],250) ;";


} ; # FIN sub Lire_cpp

##########################################################################

sub Ouvrir_lec_cpp {

   print $::SymbFLang "ifstream $_[1]($_[0]) ;";

} ; # FIN sub Ouvrir_lec_cpp

##########################################################################

sub Ouvrir_ecr_cpp {

   print $::SymbFLang "ofstream $_[1]($_[0]) ;";

} ; # FIN sub Ouvrir_ecr_cpp

##########################################################################

sub Fermer_cpp {

   print $::SymbFLang "$_[1].close() ;";

} ; # FIN sub Fermer_cpp

##########################################################################

sub Appeler_cpp {

  print $::SymbFLang $_[0]." ; ";

} ; # FIN sub Appeler_cpp

##########################################################################

sub Pour_cpp {

  print $::SymbFLang "for(".$_[0]."=".$_[1]."; ".$_[0]."<=".$_[2]."; ".$_[0]."++) { ";

} ; # FIN sub Fin_Pour_cpp

##########################################################################

sub Fin_Pour_cpp {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Pour_cpp

##########################################################################

sub Si_cpp {

  print $::SymbFLang "if (".$_[0].") { ";

} ; # FIN sub Si_cpp

##########################################################################

sub Alors_cpp {

} ; # FIN sub Si_cpp

##########################################################################

sub Sinon_cpp {

  print $::SymbFLang "} else { ";

} ; # FIN sub Si_cpp

##########################################################################

sub Fin_Si_cpp {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Si_cpp

##########################################################################

sub Tant_Que_cpp {

  print $::SymbFLang "while (".$_[0].") { ";

} ; # FIN sub Tant_Que_cpp

##########################################################################

sub Fin_Tant_Que_cpp {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Tant_Que_cpp

##########################################################################

sub Quitter_cpp {

  print $::SymbFLang "exit( $_[0] ) ; \n";

} ; # FIN sub Jusqu'a_c

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_cpp {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}="||";
  $TCoresOp{"_ET_"}="&&";
  $TCoresOp{"_NON_"}="!";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="!=";
  $TCoresOp{"_EGAL_"}="==";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_cpp

##########################################################################

# Non gr  ce jour : suivant le type retourn par la fonction(s'il y en a un), il faut la faire prcder d'un "&", "*"...

sub GereFonction_cpp {

  my  $Param;
  my  $nomF ;
  $nomF =$_[0];
  $Param=$_[1];

  # on traite  part fin_de_fichier

  if ($nomF ne "fin_de_fichier") {
      $Param=~s/$::SeparDon/, /g;
      return($_[0]."(".$Param.")");
  } else {
     $retour = $Param.".eof() " ;
  } ; # fin de si

  return($retour) ;

} ; # FIN sub GereFonction_cpp

##########################################################################

sub GereVarSimple_cpp {

  return($_[0]);

} ; # FIN sub GereVarSimple_cpp

##########################################################################

sub GereVarTableau_cpp {
  my $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/, /g;


  return($_[0]."[".$Param."]");

} ; # FIN sub GereVarTableau_cpp

##########################################################################

sub GereChaine_cpp {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_cpp

##########################################################################

sub GereCstNum_cpp {

  return($_[0]);

} ; # FIN sub GereCstNum_cpp

##########################################################################

sub  convertitExpression_cpp  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ || /g ;
  $l_expression =~ s/_ET_/  && /g ;
  $l_expression =~ s/_NON_/  ! /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ != /g ;
  $l_expression =~ s/_EGAL_/ == /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_cpp

##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1;
