#  (gH)   --  galg2rex.pm  ;  TimeStamp (unix) : 12 Juillet 01 19:15
#
#########################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2rex.pm : Module de traduction d'ALGorithme en Rexx
# Date : 07/06/2001
#
#########################################################################

# Dclarations du package

package galg2dbase;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_dbase',
	 'Commentaire_dbase',
	 'Affecter_dbase',
	 'Ecrire_dbase',
	 'Ecrire__dbase',
	 'Lire_dbase',
	 'Appeler_dbase',
	 'Pour_dbase',
	 'Fin_Pour_dbase',
	 'Si_dbase',
	 'Alors_dbase',
	 'Sinon_dbase',
	 'Fin_Si_dbase',
	 'Tant_Que_dbase',
	 'Fin_Tant_Que_dbase',
	 'Repeter_dbase',
	 'Jusqu\'a_dbase',
	 'Quitter_dbase',
	 'GereOperateur_dbase',
	 'GereFonction_dbase',
	 'GereVarSimple_dbase',
	 'GereVarTableau_dbase',
	 'GereChaine_dbase',
	 'GereCstNum_dbase',
	 'FinProgramme_dbase'
	);

#########################################################################

# Modules utiliss

use galgfncs ;


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub DebutProgramme_dbase {

  # il n'y a rien d'obligatoire en Dbase pour indiquer
  # le dbut d'un programme

  print $::SymbFLang "" ;

} ; # FIN sub DebutProgramme_dbase


###########################################################################


sub FinProgramme_dbase {

  # il n'y a rien d'obligatoire en Dbase pour indiquer
  # la fin d'un programme ; mais QUIT peut etre utilis

  print $::SymbFLang "" ;

} ; # FIN sub FinProgramme


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_dbase {

  print $::SymbFLang "// #".$_[0];

}; # FIN sub Commentaire_dbase

#########################################################################

sub Affecter_dbase {

  print $::SymbFLang "store ".&convertitExpression_dbase( $_[1] )." to $_[0] " ;

}; # FIN sub Affecter_dbase

#########################################################################

sub Ecrire_dbase {

  my $Phraz;

  $Phraz=$_[0];

  $Phraz=~s/$::SeparDon/,/g;

  print $::SymbFLang "print $Phraz ";

}; # FIN sub Ecrire_dbase

#########################################################################

sub Ecrire__dbase {

  my $Phraz;

  $Phraz=$_[0];

  $Phraz=~s/$::SeparDon/,/g;

  print $::SymbFLang "print $Phraz ";

}; # FIN sub Ecrire_dbase

#########################################################################

sub Lire_dbase {

  print $::SymbFLang "input to $_[0] ";

}; # FIN sub Lire_dbase

#########################################################################

sub Appeler_dbase {

  print $::SymbFLang $_[0]." ";

}; # FIN sub Appeler_dbase

#########################################################################

sub Pour_dbase {

  print $::SymbFLang "for ".$_[0]." := ".$_[1]." to ".$_[2]." ";

}; # FIN sub Fin_Pour_dbase

#########################################################################

sub Fin_Pour_dbase {

  print $::SymbFLang "next ";

}; # FIN sub Fin_Pour_dbase

#########################################################################

sub Si_dbase {

  print $::SymbFLang "if ".$_[0]." ";

}; # FIN sub Si_dbase

#########################################################################

sub Alors_dbase {

  print $::SymbFLang " ".$_[0]." ";

}; # FIN sub Si_dbase

#########################################################################

sub Sinon_dbase {

  print $::SymbFLang " else  ";

}; # FIN sub Si_dbase

#########################################################################

sub Fin_Si_dbase {

  print $::SymbFLang "endif ";

}; # FIN sub Fin_Si_dbase

#########################################################################

sub Tant_Que_dbase {

  print $::SymbFLang "do while ".$_[0]." ";

}; # FIN sub Tant_Que_dbase

#########################################################################

sub Fin_Tant_Que_dbase {

  print $::SymbFLang "enddo ";

}; # FIN sub Fin_Tant_Que_dbase

#########################################################################

sub Repeter_dbase {

  print $::SymbFLang "do ";

}; # FIN sub Fin_Tant_Que_dbase

#########################################################################

sub Jusqu'a_dbase {

  print $::SymbFLang " while ".$_[0]." ; ";

}; # FIN sub Fin_Tant_Que_dbase

#########################################################################

sub Quitter_dbase {

  print $::SymbFLang " quit  " ;

}; # FIN sub Fin_Tant_Que_dbase

#########################################################################

#########################################################################
##
##  Fonctions de gestion des paramtres
##
#########################################################################

#########################################################################

sub GereOperateur_dbase {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}=" .or. ";
  $TCoresOp{"_ET_"}=" .and.  ";
  $TCoresOp{"_NON_"}=" .not. ";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="<>";
  $TCoresOp{"_EGAL_"}="=";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Rexx
  $Op=$TCoresOp{$Op};

  return($ExprD.$Op.$ExprG);

}; # FIN sub GereOperateur_dbase

#########################################################################

sub GereFonction_dbase {
  my  $Param;

  $Param=$_[1];
  ## on garde le style avec les virgules $Param=~s/$::SeparDon/ /g;
  $Param=~s/$::SeparDon/ ,  /g;
  # old : Pi ==>  return("call ".$_[0]." ".$Param." ");

  return(" ".$_[0]."(".$Param.")");

}; # FIN sub GereFonction_dbase

#########################################################################

sub GereVarSimple_dbase {

  return($_[0]);

}; # FIN sub GereVarSimple_dbase

#########################################################################

sub GereVarTableau_dbase {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/ , /g;
  $Param=~s/\"//g; # Pour les tableaux associatifs, il ne faut pas de guillemets autour de la chaine de caractre

  return($_[0]."\[ ".$Param." \]");

}; # FIN sub GereVarTableau_dbase

#########################################################################

sub GereChaine_dbase {

  return("\"".$_[0]."\"");

}; # FIN sub GereChaine_dbase

#########################################################################

sub GereCstNum_dbase {

  return($_[0]);

}; # FIN sub GereCstNum_dbase

#########################################################################


sub  convertitExpression_dbase  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ .OR. /g ;
  $l_expression =~ s/_ET_/  .AND. /g ;
  $l_expression =~ s/_NON_/  .NOT. /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ <> /g ;
  $l_expression =~ s/_EGAL_/ = /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_dbase


#########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
