#  (gH)   --  galg2pascal.pm  ;  TimeStamp (unix) : 12 Septembre 01 15:03
#
#########################################################################

# Dclarations du package

package galg2pascal ;

require Exporter;
@ISA=('Exporter');
@EXPORT=(
'DebutProgramme_pascal',
'Commentaire_pascal',
'Affecter_pascal',
'Ecrire_pascal',
'Ecrire__pascal',
'Ecrire_sur_pascal',
'Lire_pascal',
'Lire_sur_pascal',
'Ouvrir_lec_pascal',
'Ouvrir_ecr_pascal',
'Fermer_pascal',
'Appeler_pascal',
'Pour_pascal',
'Fin_Pour_pascal',
'Si_pascal',
'Alors_pascal',
'Sinon_pascal',
'Fin_Si_pascal',
'Tant_Que_pascal',
'Fin_Tant_Que_pascal',
'Repeter_pascal',
'Jusqu\'a_pascal',
'Quitter_pascal',
'GereOperateur_pascal',
'GereFonction_pascal',
'GereVarSimple_pascal',
'GereVarTableau_pascal',
'GereChaine_pascal',
'GereCstNum_pascal',
'FinProgramme_pascal'
);

#########################################################################

# Modules utiliss

use galgfncs ;

###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub DebutProgramme_pascal {

  # il n'y a rien d'obligatoire en Rexx pour indiquer
  # le dbut d'un programme

  print $::SymbFLang "\nPROGRAM $main::baseNomFichier ; \n\n" ;

} ; # FIN sub DebutModule


#########################################################################


sub FinProgramme_pascal {

  # il n'y a rien d'obligatoire en Rexx pour indiquer
  # la fin d'un programme ; mais EXIT peut etre utilis

  print $::SymbFLang "\nEND.\n" ;

} ; # FIN sub FinProgramme


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_pascal {

  print $::SymbFLang "(* #".$_[0]." *)";

} ; # FIN sub Commentaire_pascal


#########################################################################


sub Affecter_pascal {

  my $expAff = $_[1] ;

  if ( (substr($expAff,0,1) eq "\"") and substr($expAff,0,1) eq "\"") {
     substr($expAff,0,1)  = "'" ;
     substr($expAff,-1,1) = "'" ;
  } ; # fin de si

  print $::SymbFLang $_[0]." := ".&convertitExpression_pascal( $expAff )." ;";

} ; # FIN sub Affecter_pascal


#########################################################################


sub Ecrire_pascal {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/,/g;

  print $::SymbFLang "writeln( ".$Phraz." ) ; ";

} ; # FIN sub Ecrire_pascal


#########################################################################


sub Ecrire__pascal {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/,/g;
  print $::SymbFLang "write( ".$Phraz." ) ; ";

} ; # FIN sub Ecrire_pascal


#########################################################################


sub Ecrire_sur_pascal {


  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/,/g;
  print $::SymbFLang "writeln( $_[1] , $Phraz ) ; ";

} ; # FIN sub Ecrire_sur_pascal


#########################################################################


sub Lire_pascal {

  print $::SymbFLang "readln( ".$_[0]." ) ; ";

} ; # FIN sub Lire_pascal


#########################################################################

sub Lire_sur_pascal {

  print $::SymbFLang "readln( ".$_[1]." , ".$_[0]." ) ; ";

} ; # FIN sub Lire_sur_pascal


#########################################################################


sub Ouvrir_lec_pascal {

  print $::SymbFLang "assign( $_[1] , $_[0] ) ; reset( $_[1] ) ; ";

} ; # FIN sub Ouvrir_lec_pascal


#########################################################################


sub Ouvrir_ecr_pascal {

  print $::SymbFLang "assign( $_[1] ,  $_[0] ) ; ";
  print $::SymbFLang "rewrite( $_[1] ) ; ";

} ; # FIN sub Ouvrir_ecr_pascal


#########################################################################


sub Fermer_pascal {

  print $::SymbFLang "close( $_[1] ) ; ";

} ; # FIN sub Fermer_pascal


#########################################################################


sub Appeler_pascal {

  print $::SymbFLang &convertitExpression_pascal( $_[0] )." ; ";

} ; # FIN sub Appeler_pascal


#########################################################################


sub Pour_pascal {

  print $::SymbFLang "for ".$_[0]." := ".$_[1]." to ".$_[2]." do begin ";

} ; # FIN sub Fin_Pour_pascal


#########################################################################


sub Fin_Pour_pascal {

  print $::SymbFLang "end ; ";

} ; # FIN sub Fin_Pour_pascal


#########################################################################


sub Si_pascal {

  print $::SymbFLang "if ".&convertitExpression_pascal( $_[0] )." ";

} ; # FIN sub Si_pascal


#########################################################################

sub Alors_pascal {

  print $::SymbFLang "then begin ".&convertitExpression_pascal( $_[0] )." ";

} ; # FIN sub Si_pascal

#########################################################################

sub Sinon_pascal {

  print $::SymbFLang "end else begin ";

} ; # FIN sub Si_pascal

#########################################################################

sub Fin_Si_pascal {

  print $::SymbFLang "end ; ";

} ; # FIN sub Fin_Si_pascal

#########################################################################

sub Tant_Que_pascal {

  print $::SymbFLang "while ( ".&convertitExpression_pascal( $_[0] )." ) do begin ";

} ; # FIN sub Tant_Que_pascal

#########################################################################

sub Fin_Tant_Que_pascal {

  print $::SymbFLang "end ; ";

} ; # FIN sub Fin_Tant_Que_pascal

#########################################################################

sub Repeter_pascal {

  print $::SymbFLang "repeat " ;

} ; # FIN sub Repeter_pascal

#########################################################################

sub Jusqu'a_pascal {

  print $::SymbFLang "until ".&convertitExpression_pascal($_[0])." ; " ;

} ; # FIN sub Jusqu'a_pascal

#########################################################################

sub Quitter_pascal {

  print $::SymbFLang "halt ; " ;

} ; # FIN sub Quitter_pascal

#########################################################################

#########################################################################
##
##  Fonctions de gestion des paramtres
##
#########################################################################

#########################################################################

sub GereOperateur_pascal {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs

  $TCoresOp{"_OU_"}      = " or " ;
  $TCoresOp{"_ET_"}      = " and " ;
  $TCoresOp{"_NON_"}     = " not " ;
  $TCoresOp{"_INFEGAL_"} = " <= "  ;
  $TCoresOp{"_SUPEGAL_"} = " >= "  ;
  $TCoresOp{"_DIFF_"}    = " <> " ;
  $TCoresOp{"_EGAL_"}    = " = "   ;
  $TCoresOp{"_INF_"}     = " < "   ;
  $TCoresOp{"_SUP_"}     = " > "   ;
  $TCoresOp{"_PLUS_"}    = " + "   ;
  $TCoresOp{"_MOINS_"}   = " - "   ;
  $TCoresOp{"_MULT_"}    = " * "   ;
  $TCoresOp{"_DIV_"}     = " / "   ;

  # Traduction de l'oprateur en Rexx
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_pascal

#########################################################################

sub GereFonction_pascal {
  my  $Param;

  $Param=$_[1];
  ## on garde le style avec les virgules $Param=~s/$::SeparDon/ /g;
  $Param=~s/$::SeparDon/ ,  /g;
  # old : Pi ==>  return("call ".$_[0]." ".$Param." ");

  return(" ".$_[0]."(".$Param.") ");

} ; # FIN sub GereFonction_pascal

#########################################################################

sub GereVarSimple_pascal {

  return($_[0]);

} ; # FIN sub GereVarSimple_pascal

#########################################################################

sub GereVarTableau_pascal {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/,/g;
  $Param=~s/\"//g; # Pour les tableaux associatifs, il ne faut pas de guillemets autour de la chaine de caractre

  return($_[0]."[ ".$Param." ]");

} ; # FIN sub GereVarTableau_pascal

#########################################################################

sub GereChaine_pascal {

  return("'".$_[0]."'");

} ; # FIN sub GereChaine_pascal

#########################################################################

sub GereCstNum_pascal {

  return($_[0]);

} ; # FIN sub GereCstNum_pascal

#########################################################################


sub  convertitExpression_pascal  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ or /g ;
  $l_expression =~ s/_ET_/  and /g ;
  $l_expression =~ s/_NON_/  not /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ <> /g ;
  $l_expression =~ s/_EGAL_/ = /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_pascal

#########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
