#  (gH)   --  galg2pl.pm  ;  TimeStamp (unix) : 11 Juillet 01 21:58
################################################################################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2prl.pm : Module de traduction d'ALGorithme en PERL
# Date : 07/06/2001
#
################################################################################################################################

# Dclarations du package

package galg2pl;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_pl',
	 'Commentaire_pl',
	 'Affecter_pl',
	 'Ecrire_pl',
	 'Lire_pl',
	 'Appeler_pl',
	 'Pour_pl',
	 'Fin_Pour_pl',
	 'Si_pl',
	 'Alors_pl',
	 'Sinon_pl',
	 'Fin_Si_pl',
	 'Tant_Que_pl',
	 'Fin_Tant_Que_pl',
	 'Repeter_pl',
	 'Jusqu\'a_pl',
	 'GereOperateur_pl',
	 'GereFonction_pl',
	 'GereVarSimple_pl',
	 'GereVarTableau_pl',
	 'GereChaine_pl',
	 'GereCstNum_pl',
	 'FinProgramme_pl'
	);

##########################################################################

# Modules utiliss

# use strfuncs ('sansEspaceDebutEtFin', 'PosMotDsPhraz');
use strFuncs ;

##########################################################################
##
## Dbut du module
##
##########################################################################

##########################################################################

sub DebutProgramme_pl {

}; # FIN sub DebutModule

##########################################################################

##########################################################################
##
## sous-programmes INSTRUCTION
##
## Ecriture dans le fichier
##
##########################################################################

##########################################################################

sub Commentaire_pl {

  print $::SymbFLang "#".$_[0];

}; # FIN sub Commentaire_pl

##########################################################################

sub Affecter_pl {

  print $::SymbFLang $_[0]."=".$_[1]."; ";

}; # FIN sub Affecter_pl

##########################################################################

sub Ecrire_pl {
  my $Phraz;

  $Phraz=$_[0];

  $Phraz=~s/$::SeparDon/. /g;

  print $::SymbFLang "print ".$Phraz.".\"\\n\"; ";

}; # FIN sub Ecrire_pl

##########################################################################

sub Lire_pl {

  print $::SymbFLang "chomp(".$_[0]."=<STDIN>); ";

}; # FIN sub Lire_pl

##########################################################################

sub Appeler_pl {

  print $::SymbFLang $_[0]."; ";

}; # FIN sub Appeler_pl

##########################################################################

sub Pour_pl {

  print $::SymbFLang "for(".$_[0]."=".$_[1]."; ".$_[0]."<=".$_[2]."; ".$_[0]."++) { ";

}; # FIN sub Fin_Pour_pl

##########################################################################

sub Fin_Pour_pl {

  print $::SymbFLang "\}; ";

}; # FIN sub Fin_Pour_pl

##########################################################################

sub Si_pl {

  print $::SymbFLang "if (".$_[0].") { ";

}; # FIN sub Si_pl

##########################################################################

sub Alors_pl {

}; # FIN sub Alors_pl

##########################################################################

sub Sinon_pl {

  print $::SymbFLang "}\nelse\n{ ";

}; # FIN sub Sinon_pl

##########################################################################

sub Fin_Si_pl {

  print $::SymbFLang "\}; ";

}; # FIN sub Fin_Si_pl

##########################################################################

sub Tant_Que_pl {

  print $::SymbFLang "while (".$_[0].") { ";

}; # FIN sub Tant_Que_pl

##########################################################################

sub Fin_Tant_Que_pl {

  print $::SymbFLang "\}; ";

}; # FIN sub Fin_Tant_Que_pl

##########################################################################

sub Repeter_pl {

  print $::SymbFLang "do \{; ";

}; # FIN sub Fin_Tant_Que_pl

##########################################################################


sub Jusqu'a_pl {

  print $::SymbFLang "\} until ".$_[0]."; ";

}; # FIN sub Fin_Tant_Que_pl

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_pl {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}="or";
  $TCoresOp{"_ET_"}="and";
  $TCoresOp{"_NON_"}="not";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="!=";
  $TCoresOp{"_EGAL_"}="==";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op};

  return($ExprD.$Op.$ExprG);

}; # FIN sub GereOperateur_pl

##########################################################################

sub GereFonction_pl {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/, /g;

  return("&".$_[0]."(".$Param.")");

}; # FIN sub GereFonction_pl

##########################################################################

sub GereVarSimple_pl {

  return("\$".$_[0]);

}; # FIN sub GereVarSimple_pl

##########################################################################

sub GereVarTableau_pl {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/, /g;


  return("\$".$_[0]."[".$Param."]");

}; # FIN sub GereVarTableau_pl

##########################################################################

sub GereChaine_pl {

  return("\"".$_[0]."\"");

}; # FIN sub GereChaine_pl

##########################################################################

sub GereCstNum_pl {

  return($_[0]);

}; # FIN sub GereCstNum_pl

##########################################################################
##
## Fin de programme
##
##########################################################################

##########################################################################

sub FinProgramme_pl {

   print $::SymbFLang "" ;

}; # FIN sub FinProgramme_pl

##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :
1;
