#  (gH)   --  galg2rex.pm  ;  TimeStamp (unix) : 12 Juillet 01 19:15
#
#########################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2rex.pm : Module de traduction d'ALGorithme en Rexx
# Date : 07/06/2001
#
#########################################################################

# Dclarations du package

package galg2rex;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_rex',
	 'Commentaire_rex',
	 'Affecter_rex',
	 'Ecrire_rex',
	 'Lire_rex',
	 'Appeler_rex',
	 'Pour_rex',
	 'Fin_Pour_rex',
	 'Si_rex',
	 'Alors_rex',
	 'Sinon_rex',
	 'Fin_Si_rex',
	 'Tant_Que_rex',
	 'Fin_Tant_Que_rex',
	 'Repeter_rex',
	 'Jusqu\'a_rex',
	 'Quitter_rex',
	 'GereOperateur_rex',
	 'GereFonction_rex',
	 'GereVarSimple_rex',
	 'GereVarTableau_rex',
	 'GereChaine_rex',
	 'GereCstNum_rex',
	 'FinProgramme_rex'
	);

#########################################################################

# Modules utiliss

use galgfncs ;

#########################################################################
##
## Dbut de programme
##
#########################################################################

#########################################################################

sub DebutProgramme_rex {

}; # FIN sub DebutModule

#########################################################################

#########################################################################
##
## sous-programmes INSTRUCTION
##
## Ecriture dans le fichier
##
#########################################################################

#########################################################################

sub Commentaire_rex {

  print $::SymbFLang "/* #".$_[0]." */";

}; # FIN sub Commentaire_rex

#########################################################################

sub Affecter_rex {

  print $::SymbFLang $_[0]." = ".$_[1]." ";

}; # FIN sub Affecter_rex

#########################################################################

sub Ecrire_rex {

  my $Phraz;

  $Phraz=$_[0];

  $Phraz=~s/$::SeparDon/ /g;

  print $::SymbFLang "say ".$Phraz." ";

}; # FIN sub Ecrire_rex

#########################################################################

sub Lire_rex {

  print $::SymbFLang "pull ".$_[0]." ";

}; # FIN sub Lire_rex

#########################################################################

sub Appeler_rex {

  print $::SymbFLang $_[0]." ";

}; # FIN sub Appeler_rex

#########################################################################

sub Pour_rex {

  print $::SymbFLang "do ".$_[0]."=".$_[1]." to ".$_[2]." ";

}; # FIN sub Fin_Pour_rex

#########################################################################

sub Fin_Pour_rex {

  print $::SymbFLang "end ";

}; # FIN sub Fin_Pour_rex

#########################################################################

sub Si_rex {

  print $::SymbFLang "if ".$_[0]." ";

}; # FIN sub Si_rex

#########################################################################

sub Alors_rex {

  print $::SymbFLang "then ; do ; ".$_[0]." ";

}; # FIN sub Si_rex

#########################################################################

sub Sinon_rex {

  print $::SymbFLang "end ; else ; do ; ";

}; # FIN sub Si_rex

#########################################################################

sub Fin_Si_rex {

  print $::SymbFLang "end ";

}; # FIN sub Fin_Si_rex

#########################################################################

sub Tant_Que_rex {

  print $::SymbFLang "do while ".$_[0]." ";

}; # FIN sub Tant_Que_rex

#########################################################################

sub Fin_Tant_Que_rex {

  print $::SymbFLang "end ";

}; # FIN sub Fin_Tant_Que_rex

#########################################################################

sub Repeter_rex {

  my $lacond = "???" ;
  $lacond = $main::globRep[$main::NbRep] ;
  $main::NbRep-- ;
  print $::SymbFLang "do until ".$lacond." ";

}; # FIN sub Fin_Tant_Que_rex

#########################################################################

sub Jusqu'a_rex {

  print $::SymbFLang "end ";

}; # FIN sub Fin_Tant_Que_rex

#########################################################################

sub Quitter_rex {

  print $::SymbFLang "exit ".$_[0] ;

}; # FIN sub Fin_Tant_Que_rex

#########################################################################

#########################################################################
##
##  Fonctions de gestion des paramtres
##
#########################################################################

#########################################################################

sub GereOperateur_rex {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}="|";
  $TCoresOp{"_ET_"}="&";
  $TCoresOp{"_NON_"}="\\";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="\\=";
  $TCoresOp{"_EGAL_"}="=";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Rexx
  $Op=$TCoresOp{$Op};

  return($ExprD.$Op.$ExprG);

}; # FIN sub GereOperateur_rex

#########################################################################

sub GereFonction_rex {
  my  $Param;

  $Param=$_[1];
print " GEREFONCTION : $_[0] ( $_[1] ) \n" ;
  ## on garde le style avec les virgules $Param=~s/$::SeparDon/ /g;
  $Param=~s/$::SeparDon/ ,  /g;
print " PARAMETRES : $Param \n" ;

# old : Pi ==>  return("call ".$_[0]." ".$Param." ");
print "  ON RENVOIE $_[0]( $Param ) \n" ;
  return(" ".$_[0]."(".$Param.")");

}; # FIN sub GereFonction_rex

#########################################################################

sub GereVarSimple_rex {

  return($_[0]);

}; # FIN sub GereVarSimple_rex

#########################################################################

sub GereVarTableau_rex {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/./g;
  $Param=~s/\"//g; # Pour les tableaux associatifs, il ne faut pas de guillemets autour de la chaine de caractre

  return($_[0].".".$Param." ");

}; # FIN sub GereVarTableau_rex

#########################################################################

sub GereChaine_rex {

  return("\"".$_[0]."\"");

}; # FIN sub GereChaine_rex

#########################################################################

sub GereCstNum_rex {

  return($_[0]);

}; # FIN sub GereCstNum_rex

#########################################################################


#########################################################################
##
## Fin de programme
##
#########################################################################

#########################################################################

sub FinProgramme_rex {

  print $::SymbFLang "";

}; # FIN sub FinProgramme

#########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :
1;
