#  (gH)   --  galg2rexx.pm  ;  TimeStamp (unix) : 20 Juillet 01 22:39
#
#########################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2rex.pm : Module de traduction d'ALGorithme en Rexx
# Date : 07/06/2001
#
#########################################################################

# Dclarations du package

package galg2rexx ;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
'DebutProgramme_rexx',
'Commentaire_rexx',
'Affecter_rexx',
'Ecrire_rexx',
'Ecrire__rexx',
'Ecrire_sur_rexx',
'Lire_rexx',
'Lire_sur_rexx',
'Ouvrir_lec_rexx',
'Ouvrir_ecr_rexx',
'Fermer_rexx',
'Appeler_rexx',
'Pour_rexx',
'Fin_Pour_rexx',
'Si_rexx',
'Alors_rexx',
'Sinon_rexx',
'Fin_Si_rexx',
'Tant_Que_rexx',
'Fin_Tant_Que_rexx',
'Repeter_rexx',
'Jusqu\'a_rexx',
'Quitter_rexx',
'GereOperateur_rexx',
'GereFonction_rexx',
'GereVarSimple_rexx',
'GereVarTableau_rexx',
'GereChaine_rexx',
'GereCstNum_rexx',
'FinProgramme_rexx'
);

#########################################################################

# Modules utiliss

use galgfncs ;

###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub DebutProgramme_rexx {

  # il n'y a rien d'obligatoire en Rexx pour indiquer
  # le dbut d'un programme

  print $::SymbFLang "" ;

} ; # FIN sub DebutModule


#########################################################################


sub FinProgramme_rexx {

  # il n'y a rien d'obligatoire en Rexx pour indiquer
  # la fin d'un programme ; mais EXIT peut etre utilis

  print $::SymbFLang "" ;

} ; # FIN sub FinProgramme


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_rexx {

  print $::SymbFLang "/* #".$_[0]." */";

} ; # FIN sub Commentaire_rexx


#########################################################################


sub Affecter_rexx {

  my $lavar = $_[0] ;
  my $Phraz = $_[1] ;

  print $::SymbFLang $lavar." = ".&convertitExpression_rexx( $Phraz )." ";

} ; # FIN sub Affecter_rexx


#########################################################################


sub Ecrire_rexx {

  my $Phraz ;
  $Phraz=$_[0] ;
  $Phraz=~s/$::SeparDon/ /g ;

  print $::SymbFLang "say ".&convertitExpression_rexx($Phraz)." ";

} ; # FIN sub Ecrire_rexx


#########################################################################


sub Ecrire__rexx {

  my $Phraz ;
  $Phraz=$_[0] ;
  $Phraz=~s/$::SeparDon/ /g ;

  print $::SymbFLang "call charout , ".&convertitExpression_rexx($Phraz)." " ;

} ; # FIN sub Ecrire_rexx


#########################################################################


sub Ecrire_sur_rexx {

  my $Phraz ;
  $Phraz=$_[0] ;
  $Phraz=~s/$::SeparDon/ /g ;

  print $::SymbFLang "call lineout $_[1] , ".&convertitExpression_rexx($Phraz)." " ;

} ; # FIN sub Ecrire_sur_rexx


#########################################################################


sub Lire_rexx {

  print $::SymbFLang "pull ".$_[0]." ";

} ; # FIN sub Lire_rexx


#########################################################################

sub Lire_sur_rexx {

  print $::SymbFLang $_[0]." = linein( $_[1] ) ";

} ; # FIN sub Lire_sur_rexx


#########################################################################


sub Ouvrir_lec_rexx {

  print $::SymbFLang "$_[1] = $_[0] ";

} ; # FIN sub Ouvrir_lec_rexx


#########################################################################


sub Ouvrir_ecr_rexx {

  print $::SymbFLang "$_[1] = $_[0] ";

} ; # FIN sub Ouvrir_ecr_rexx


#########################################################################


sub Fermer_rexx {

  print $::SymbFLang "call lineout $_[1] ";

} ; # FIN sub Fermer_rexx


#########################################################################


sub Appeler_rexx {

  print $::SymbFLang &convertitExpression_rexx( $_[0] )." ";

} ; # FIN sub Appeler_rexx


#########################################################################


sub Pour_rexx {

  print $::SymbFLang "do ".$_[0]."=".$_[1]." to ".$_[2]." ";

} ; # FIN sub Fin_Pour_rexx


#########################################################################


sub Fin_Pour_rexx {

  print $::SymbFLang "end ";

} ; # FIN sub Fin_Pour_rexx


#########################################################################


sub Si_rexx {

  print $::SymbFLang "if ".&convertitExpression_rexx( $_[0] )." ";

} ; # FIN sub Si_rexx


#########################################################################

sub Alors_rexx {

  print $::SymbFLang "then ; do ; ".&convertitExpression_rexx( $_[0] )." ";

} ; # FIN sub Si_rexx

#########################################################################

sub Sinon_rexx {

  print $::SymbFLang "end ; else ; do ; ";

} ; # FIN sub Si_rexx

#########################################################################

sub Fin_Si_rexx {

  print $::SymbFLang "end ";

} ; # FIN sub Fin_Si_rexx

#########################################################################

sub Tant_Que_rexx {

  print $::SymbFLang "do while ".&convertitExpression_rexx( $_[0] )." ";

} ; # FIN sub Tant_Que_rexx

#########################################################################

sub Fin_Tant_Que_rexx {

  print $::SymbFLang "end ";

} ; # FIN sub Fin_Tant_Que_rexx

#########################################################################

sub Repeter_rexx {

  my $lacond = "???" ;
  $lacond = $main::globRep[$main::NbRep] ;
  $lacond = &galgtrad::GereExpression($lacond) ;
  $main::NbRep-- ;
  print $::SymbFLang "do until ".&convertitExpression_rexx( $lacond )." ";

} ; # FIN sub Fin_Tant_Que_rexx

#########################################################################

sub Jusqu'a_rexx {

  print $::SymbFLang "end ";

} ; # FIN sub Fin_Tant_Que_rexx

#########################################################################

sub Quitter_rexx {

  print $::SymbFLang "exit ".$_[0] ;

} ; # FIN sub Fin_Tant_Que_rexx

#########################################################################
#########################################################################

#########################################################################
##
##  Fonctions de gestion des paramtres
##
#########################################################################

#########################################################################
#########################################################################

sub GereOperateur_rexx {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs

  $TCoresOp{"_OU_"}      = " | " ;
  $TCoresOp{"_ET_"}      = " & " ;
  $TCoresOp{"_NON_"}     = " \\" ;
  $TCoresOp{"_INFEGAL_"} = " <= "  ;
  $TCoresOp{"_SUPEGAL_"} = " >= "  ;
  $TCoresOp{"_DIFF_"}    = " \\= " ;
  $TCoresOp{"_EGAL_"}    = " = "   ;
  $TCoresOp{"_INF_"}     = " < "   ;
  $TCoresOp{"_SUP_"}     = " > "   ;
  $TCoresOp{"_PLUS_"}    = " + "   ;
  $TCoresOp{"_MOINS_"}   = " - "   ;
  $TCoresOp{"_MULT_"}    = " * "   ;
  $TCoresOp{"_DIV_"}     = " / "   ;

  # Traduction de l'oprateur en Rexx
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_rexx

#########################################################################

sub GereFonction_rexx {
  my  $Param;

  $Param=$_[1];
  ## on garde le style avec les virgules $Param=~s/$::SeparDon/ /g;
  $Param=~s/$::SeparDon/ ,  /g;
  # old : Pi ==>  return("call ".$_[0]." ".$Param." ");

  return(" ".$_[0]."(".$Param.")");

} ; # FIN sub GereFonction_rexx

#########################################################################

sub GereVarSimple_rexx {

  return($_[0]);

} ; # FIN sub GereVarSimple_rexx

#########################################################################

sub GereVarTableau_rexx {
  my  $Param;

  $Param=$_[1];
  $Param=~s/$::SeparDon/./g;
  $Param=~s/\"//g; # Pour les tableaux associatifs, il ne faut pas de guillemets autour de la chaine de caractre

  return($_[0].".".$Param." ");

} ; # FIN sub GereVarTableau_rexx

#########################################################################

sub GereChaine_rexx {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_rexx

#########################################################################

sub GereCstNum_rexx {

  return($_[0]);

} ; # FIN sub GereCstNum_rexx

#########################################################################


sub  convertitExpression_rexx  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ | /g ;
  $l_expression =~ s/_ET_/  & /g ;
  $l_expression =~ s/_NON_/  \\/g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ \\= /g ;
  $l_expression =~ s/_EGAL_/ = /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_rexx

#########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
