#  (gH)   --  galg2tcl.pm  ;  TimeStamp (unix) : 22 Juillet 01 19:37
################################################################################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2prl.pm : Module de traduction d'ALGorithme en TCL
# Date : 07/06/2001
#
################################################################################################################################

# Dclarations du package

package galg2tcl ;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_tcl',
	 'Commentaire_tcl',
	 'Affecter_tcl',
	 'Ecrire_tcl',
	 'Ecrire__tcl',
	 'Ecrire_sur_tcl',
	 'Lire_tcl',
	 'Lire_sur_tcl',
	 'Ouvrir_lec_tcl',
	 'Ouvrir_ecr_tcl',
	 'Fermer_tcl',
	 'Appeler_tcl',
	 'Quitter_tcl',
	 'Pour_tcl',
	 'Fin_Pour_tcl',
	 'Si_tcl',
	 'Alors_tcl',
	 'Sinon_tcl',
	 'Fin_Si_tcl',
	 'Tant_Que_tcl',
	 'Fin_Tant_Que_tcl',
	 'Repeter_tcl',
	 'Jusqu\'a_tcl',
	 'GereOperateur_tcl',
	 'GereFonction_tcl',
	 'GereVarSimple_tcl',
	 'GereVarTableau_tcl',
	 'GereChaine_tcl',
	 'GereCstNum_tcl',
	 'FinProgramme_tcl'
	);

##########################################################################

# Modules utiliss

use galgfncs ;


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub DebutProgramme_tcl {

  # il n'y a rien d'obligatoire en tcl pour indiquer
  # le dbut d'un programme

} ; # FIN sub DebutProgramme_tcl


##########################################################################


sub FinProgramme_tcl {

  # il n'y a rien d'obligatoire en tcl pour indiquer
  # la fin d'un programme  mais exit peut etre utilis

} ; # FIN sub FinProgramme_tcl


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_tcl {

  print $::SymbFLang "#".$_[0];

} ; # FIN sub Commentaire_tcl

##########################################################################

sub Affecter_tcl { my $dbg_A_tcl = 0 ; # mettre 1 pour debug, 0 pour mode normal

  my $varAff = $_[0] ; # variable  affecter
  my $expAff = $_[1] ; # expression d'affectation
  my $phrAff = $_[1] ; # phrase finale d'affectation

  # en tcl, quand on affecte dans un tableau, le nom du tableau ne
  # porte pas de $ en dbut ; les indices de tableau se notent avec
  # des parenthses ; comme en principe les variables ont un $ en dbut,
  # on doit l'enlever pour les tableaux seulement

  if ($dbg_A_tcl == 1) {  print "\n Affectation en tcl : $varAff <-- $expAff \n" ; }
  if ($dbg_A_tcl == 1) {  print " varAff EST '$varAff' \n" ; } ;
  if (index($varAff,"(")>-1) {
     $varAff = &convertitExpression_tcl($varAff) ;
     if (substr($varAff,0,1) eq "\$") {
        $varAff = substr($varAff,1) ;
     } ; # fin de si le premier caractre est un dollar
  } ; # fin de si on voit une parenthse ouvrante
  if ($dbg_A_tcl == 1) { print " varAff DEVIENT $varAff \n" ; } ;

  # on ne convertit pas une chaine constante ni un nombre simple
  # ni un appel de fonction

  $expAffcopie = $expAff ;
  my $convAff = 1 ;
  if (substr($expAff,0,1) eq "\"") { $convAff = 0 ; } ;
  if ($expAffcopie =~ /^\d+$/) { $convAff = 0 ; } ;
  if ($convAff == 1) {
     if ($dbg_A_tcl == 1) { print " expAff EST $expAff \n" ; } ;
     $expAff =  &convertitExpression_tcl($expAff) ;
     if ((substr($expAff,0,1) ne "\[") and (&nbMots($expAff)>1) ) {
        $expAff =  "[expr \"".$expAff."\" ]\n" ;
     } ; # finde si
     if ($dbg_A_tcl == 1) { print " expAff DEVIENT $expAff \n" ; } ;
  } ; # fin de si

  $phrAff = "set $varAff $expAff " ;
  if ($dbg_A_tcl == 1) { print " FINALEMENT : $phrAff \n" ; } ;
  if ($dbg_A_tcl == 1) { &attends() ; } ;
  print $::SymbFLang "$phrAff "  ;

} ; # FIN sub Affecter_tcl

##########################################################################

sub Ecrire {

  my $Phraz;
  $Phraz=$_[0];

  # on convertit chaque expression qui n'est pas une chaine constante
  # en ce qu'il faut avec un $ ventuel en dbut de nom de variable

  my $newExpr = "" ;
  my $subExp = "" ;

  foreach $subExp (split($::SeparDon,$Phraz)) {
    my $cntExp = index($main::lstVars,$subExp) ;
    # pas de substitution pour une chaine constante
    if (substr($subExp,0,1) ne "\"" ) {
        $newExpr .=  &convertitExpression_tcl($subExp)." " ;
    } else {  $newExpr .= $subExp." " ;
    } ; # fin de si
  } ; # fin pour chaque sous-expression

  $Phraz = $newExpr ;
  $Phraz =~ s/"//g ;

  return $Phraz ;

} ; # FIN sub Ecrire

##########################################################################

sub Ecrire_tcl { my $dbg_E_tcl = 0 ; # mettre 1 pour debug, 0 pour normal

  print $::SymbFLang "puts \"".&Ecrire($_[0])."\"" ;

} ; # FIN sub Ecrire_tcl

##########################################################################

sub Ecrire__tcl {

  print $::SymbFLang "puts -nonewline \"".&Ecrire($_[0])."\"" ;

} ; # FIN sub Ecrire_tcl

##########################################################################

sub Ecrire_sur_tcl {

    print $::SymbFLang "puts  ".&convertitExpression_tcl($_[1])." \"".&Ecrire($_[0])."\"" ;

} ; # FIN sub Ecrire_sur_tcl

##########################################################################

sub Lire_tcl {

  print $::SymbFLang "set ".$_[0]. " [gets stdin ] ";

} ; # FIN sub Lire_tcl

##########################################################################

sub Lire_sur_tcl {

  print $::SymbFLang "gets ".&convertitExpression_tcl($_[1])." ".$_[0]." ";

} ; # FIN sub Lire_tcl

##########################################################################


sub Ouvrir_lec_tcl {

  print  $::SymbFLang " set ".$_[1]." [open ".&convertitExpression_tcl($_[0])." r ] " ;

} ; # fin Ouvrir_lec_tcl

##########################################################################


sub Ouvrir_ecr_tcl {

  print  $::SymbFLang " set ".$_[1]." [open ".&convertitExpression_tcl($_[0])." w ] " ;

} ; # fin Ouvrir_lec_tcl

##########################################################################

sub Fermer_tcl {

  print $::SymbFLang " close ".&convertitExpression_tcl($_[1])." ";

} ; # FIN sub Appeler_tcl

##########################################################################

sub Appeler_tcl {

  print $::SymbFLang $_[0]." ; ";

} ; # FIN sub Appeler_tcl

##########################################################################

sub Quitter_tcl {

  print $::SymbFLang "exit $_[0]  ";

} ; # FIN sub Appeler_tcl

##########################################################################

sub Pour_tcl {
  my $debPour =  " \{ set $_[0] ".&convertitExpression_tcl($_[1])." \} " ;
  my $milPour =  " \{ ".&convertitExpression_tcl($_[0])." <= ".&convertitExpression_tcl($_[2])." \} " ;
  my $finPour =  " \{ set $_[0] \[ incr $_[0] \] \} " ;
  print $::SymbFLang "for $debPour  $milPour $finPour \{ ";

} ; # FIN sub Fin_Pour_tcl

##########################################################################

sub Fin_Pour_tcl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Pour_tcl

##########################################################################

sub Si_tcl {

  print $::SymbFLang "if \{ ".convertitExpression_tcl($_[0])." \} \{ ";

} ; # FIN sub Si_tcl

##########################################################################

sub Alors_tcl {

} ; # FIN sub Alors_tcl

##########################################################################

sub Sinon_tcl {

  print $::SymbFLang "\} else \{ ";

} ; # FIN sub Sinon_tcl

##########################################################################

sub Fin_Si_tcl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Si_tcl

##########################################################################

sub Tant_Que_tcl {

  print $::SymbFLang "while \{ ".convertitExpression_tcl($_[0])."\}  \{ ";

} ; # FIN sub Tant_Que_tcl

##########################################################################

sub Fin_Tant_Que_tcl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Tant_Que_tcl

##########################################################################

sub Repeter_tcl {

  print $::SymbFLang " ###################################################################\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###   Instruction algorithmique : REPETER non traduite :          #\n" ;
  &pasDeRepeterTcl() ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###################################################################\n" ;

} ; # FIN sub Fin_Tant_Que_tcl

##########################################################################

sub  pasDeRepeterTcl  {

  print $::SymbFLang " ###   le langage Tcl ne connait pas la boucle REPETER.            #\n" ;
  print $::SymbFLang " ###   Essayez avec la boucle TANT QUE.                            #\n" ;

} ; # fin sub pasDeRepeter


##########################################################################


sub Jusqu'a_tcl {

  print $::SymbFLang " ###################################################################\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###    Instruction algorithmique : JUSQU'A non traduite :         #\n" ;
  &pasDeRepeterTcl() ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###################################################################\n" ;

} ; # FIN sub Jusqu'a_tcl

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_tcl {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs

  $TCoresOp{"_OU_"}="||";
  $TCoresOp{"_ET_"}="&&";
  $TCoresOp{"_NON_"}="!";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="!=";
  $TCoresOp{"_EGAL_"}="==";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_tcl

##########################################################################

sub GereFonction_tcl {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/  /g;

  return("\[$_[0] $Param \]");

} ; # FIN sub GereFonction_tcl

##########################################################################

sub GereVarSimple_tcl {

  return($_[0]);

} ; # FIN sub GereVarSimple_tcl

##########################################################################

sub GereVarTableau_tcl {
  my  $Param;

  $Param=$_[1];
  $Param=~s/$::SeparDon/,/g;

  return("\$".$_[0]."(".&sansEspaceDebutEtFin($Param).")");

} ; # FIN sub GereVarTableau_tcl

##########################################################################

sub GereChaine_tcl {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_tcl

##########################################################################

sub GereCstNum_tcl {

  return($_[0]);

} ; # FIN sub GereCstNum_tcl

##########################################################################

sub  convertitExpression_tcl  {

  # ce sous-programme convertit les oprateurs internes
  # en oprateurs du langage

  my $l_expression = $_[0] ;
# print " entree $l_expression \n" ;
  $l_expression =~ s/_OU_/ || /g ;
  $l_expression =~ s/_ET_/  && /g ;
  $l_expression =~ s/_NON_/  not /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ != /g ;
  $l_expression =~ s/_EGAL_/ == /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  #  cause des tableaux

  $l_expression =~ s!\(!\( !g   ;
  $l_expression =~ s!\)! \)!g   ;
  $l_expression =~ s!,! , !g   ;

  # il reste  rajouter le symbole $ devant chaque variable connue

  my $newExpr = "" ;
  my $subExp = "" ;
  foreach $subExp (split(" ",$l_expression)) {
   if ($subExp !~ /^\d+$/) {
      my $cntExp = index($main::lstVars,$subExp) ;
      # pas de substitution pour une chaine constante
      if (substr($subExp,0,1) ne "\"" ) {
         if ($cntExp>-1) { $newExpr .= "\$".$subExp." "  } else { $newExpr .= $subExp." " } ;
      } ; # fin de si
   } else { # pas de $ pour un nombre
      $newExpr .= $subExp." "
   } ; # fin de si
  } ; # fin pour chaque sous-expression

  #  cause des tableaux

  $newExpr =~ s!\( !\(!g   ;
  $newExpr =~ s! \)!\)!g   ;
  $newExpr =~ s! , !,!g   ;

  #  cause des tableaux

  $l_expression =~ s!\( !\(!g   ;
  $l_expression =~ s! \)!\)!g   ;
  $l_expression =~ s! , !,!g   ;

  return( $newExpr ) ;

} ; # fin sub convertitExpression_tcl

##########################################################################
##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
