#  (gH)   --  galgamng.pm  ;  TimeStamp (unix) : 07 Aot 01 18:40
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2c.pm : Module de traduction d'ALGorithme en C
# Date : 21/06/2001


###########################################################################


# Dclarations du package


package galgamng ;
require Exporter;
@ISA=('Exporter');
@EXPORT=('amenageTexte') ;


# Chargement des sous-programmes mis dans des modules
# Il est conseill de regrouper tous les modules personnels dans un meme
# rpertoire et de mettre le nom de ce rpertoire dans
# la variable d'environnement PERL_MACROS ce qui permet
# d'utiliser la ligne suivante pour les localiser


  use lib $ENV{"PERL_MACROS"} ; # /* rpertoire des modules perl personnels */use

  use galgfncs ; # Bibliothque de fonctions utiles
  use galgtrad ; # Bibliothque


###########################################################################
###########################################################################


###########################################################################
##                                                                        #
##      sous-programmes pour Amenagement                                  #
##                                                                        #
###########################################################################


###########################################################################
###########################################################################


sub amenageTexte  { my $dbg_Amng = 0 ; # mettre 0 en mode normal, 1 en mode debug

  $nomFichierTexte = $_[0] ;
  $nomFichierAlg   = $_[1] ;

  if ( $dbg_Amng == 1 ) { print " ===> Amnagement de '$nomFichierTexte' en '$nomFichierAlg' \n\n" ; } ;

  open(FTXT,"<$nomFichierTexte") or die ("          Erreur ! Impossible de lire dans $nomFichierTexte\n\n") ;
  open(FALG,">$nomFichierAlg")   or die ("          Erreur ! Impossible d'crire dans $nomFichierAlg\n\n") ;

  # on crit en dbut de fichier-algorithme qu'il s'agit d'un amnagement via galg

  my $ligdeb = " Fichier $nomFichierAlg issu de galg -t $nomFichierTexte" ;
  print FALG "#-#  $ligdeb\n" ;
  print FALG "#-#  ".("=" x length($ligdeb))."\n" ;
  print FALG "#-#      ".&gereLeTemps()."\n" ;

  # comme on aura besoin des listes de mots-clefs, on initialise les listes correspondantes

  &galganl::initListes() ;

  # on passe en revue chacune des lignes du texte
  # 1 - on ajoute ventuellement le mot affecter ou le mot appeler
  #     en bonne position
  # 2 - on amnage l'criture des mots-clefs


  while (<FTXT>) {
    chop($nLigne=$_) ;
    if ( $dbg_Amng == 1 ) { print "   LIGNE LUE : $nLigne\n" ; } ;
    $nLigne = &ajoutEventuel_Affecter($nLigne) ;
    $nLigne = &ajoutEventuel_Appeler($nLigne) ;
    $nLigne = &amenageMotsClefs($nLigne) ;
    if ( $dbg_Amng == 1 ) { print "   LIGNE ECRITE : $nLigne\n\n" ; } ;
    print FALG "$nLigne\n" ;
    if ( $dbg_Amng == 1 ) { &attends() ; } ;
  } ; # fin tant que on lit sur le fichier-texte

  close(FTXT) ;
  close(FALG) ;

  if ( $dbg_Amng == 1 ) { print " ===> Fin d'amnagement de '$nomFichierTexte' en '$nomFichierAlg' \n\n" ; } ;

} ; # fin sub amenageTexte


#########################################################################################


sub ajoutEventuel_Affecter { my $dbg_ajeAff = 0 ; # mettre 0 en mode normal, 1 en mode debug

 my $entre = $_[0] ;

 # s'il y a le symbole d'affectation, on rajoute "affecter" en mot Un

 my $lins  = &sansCmt($entre) ;
 my $idla = index($lins,"<--") ;

 if ( $dbg_ajeAff == 1 ) { print " ajeAFF avant : $entre \n" ; } ;

 if ($idla>-1) {
      $idpcnb = 0 ;
      while (substr($entre,$idpcnb,1) eq " ") { $idpcnb++ } ;
      $entre = (" " x $idpcnb)."affecter ".substr($entre,$idpcnb) ;
 } ; # fin de si on a vu le symbole <--

 if ( $dbg_ajeAff == 1 ) { print " ajeAFF puis : $entre \n" ; } ;

 $entre = &permuteMotsUnEtDeuxPourAlorsSinon($entre,$idpcnb) ;

 if ( $dbg_ajeAff == 1 ) { print " ajeAFF aprs : $entre \n" ; } ;

 return $entre ;

} ; # fin sub ajoutEventuel_Affecter


#########################################################################################


sub ajoutEventuel_Appeler { my $dbg_ajeApp = 0 ; # mettre 0 en mode normal, 1 en mode debug

 my $entre = $_[0] ;

 if ( $dbg_ajeApp == 1 ) { print " ajeAPP avant : $entre \n" ; } ;

 # si le mot un contient une parenthse ouvrante,
 # on rajoute "appeler" en mot Un

 my $mun = &premierMot($entre) ;
 my $idla = index($mun,"(") ;
 if ($idla>-1) {
      my $nomModule = substr($mun,0,$idla) ;
      $idla = index($ligA,"(") ;
      $idpcnb = 0 ;
      while (substr($entre,$idpcnb,1) eq " ") { $idpcnb++ } ;
      $entre = (" " x $idpcnb)."appeler ".substr($entre,$idpcnb) ;
 } ; # fin de si on n'a pas vu de parenthse ouvrante

 if ( $dbg_ajeApp == 1 ) { print " ajeAPP puis : $entre \n" ; } ;

 $entre = &permuteMotsUnEtDeuxPourAlorsSinon($entre,$idpcnb) ;

 if ( $dbg_ajeApp == 1 ) { print " ajeAPP aprs : $entre \n" ; } ;

 return $entre ;

} ; # fin sub ajoutEventuel_Appeler


#########################################################################################


sub amenageMotsClefs  {

$vLigne = $_[0] ;

    $vLigne =~ s/fin si/fin_si/ ;
    $vLigne =~ s/finsi/fin_si/ ;
    $vLigne =~ s/Finsi/Fin_si/ ;
    $vLigne =~ s/FinSi/Fin_Si/ ;
    $vLigne =~ s/FINSI/FIN_SI/ ;
    $vLigne =~ s/Fin si/Fin_si/ ;
    $vLigne =~ s/Fin Si/Fin_Si/ ;
    $vLigne =~ s/FIN SI/FIN_SI/ ;

    $vLigne =~ s/fin pour/fin_pour/ ;
    $vLigne =~ s/finpour/fin_pour/ ;
    $vLigne =~ s/Finpour/Fin_pour/ ;
    $vLigne =~ s/FinPour/Fin_Pour/ ;
    $vLigne =~ s/FINPOUR/FIN_POUR/ ;
    $vLigne =~ s/Fin pour/Fin_pour/ ;
    $vLigne =~ s/Fin Pour/Fin_Pour/ ;
    $vLigne =~ s/FIN POUR/FIN_POUR/ ;

    $vLigne =~ s/fin tant que/fin_tant_que/ ;
    $vLigne =~ s/fintantque/fin_tant_que/ ;
    $vLigne =~ s/Fintantque/Fin_tant_que/ ;
    $vLigne =~ s/FinTantQue/Fin_Tant_Que/ ;
    $vLigne =~ s/FINTANTQUE/FIN_TANT_QUE/ ;
    $vLigne =~ s/Fin tant que/Fin_tant_que/ ;
    $vLigne =~ s/Fin Tant Que/Fin_Tant_Que/ ;
    $vLigne =~ s/FIN TANT QUE/FIN_TANT_QUE/ ;

return $vLigne ;

} ; # fin sub amenageMotsClefs


#########################################################################################


sub permuteMotsUnEtDeuxPourAlorsSinon  { my $dbg_Perm = 0 ; # mettre 0 en mode normal, 1 en mode debug

my $avant = $_[0] ;  # chaine originale
my $ndbad = $_[1] ;  # nombre d'espaces blancs au dbut
my $apres = $avant ; # chaine finale, renvoye

if ( $dbg_Perm == 1 ) { print " PERM au dbut de : $avant avec $ndbad espaces en dbut\n" ; } ;
   ($un,$reste)  = &premierEtReste($avant) ;
   ($deux,$fin)  = &premierEtReste($reste) ;
   if ( $dbg_Perm == 1 ) { print " mot un   : $un   \n" ; } ;
   if ( $dbg_Perm == 1 ) { print " mot deux : $deux  \n" ; } ;
   if ( $dbg_Perm == 1 ) { print " reste    : $fin   \n" ; } ;

   if (index($main::ldmI,uc(" $deux "))>-1) {
      $apres = (" " x $ndbad)."$deux $un $fin" ;
   } ; # fin si le mot deux est alors ou sinon

if ( $dbg_Perm == 1 ) { print " PERM en fin : $apres \n" ; } ;

return $apres ;

} ; # fin sub permuteMotsUnEtDeuxPourAlorsSinon

###################################################################################################
#
# si alors en fin de ligne, le mettre seul sur une autre ligne ?
# grer KEYB et SCRN plutot que lire et crire ?
#
###################################################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
