#  TimeStamp  (dos) : 25 Juillet 03 20:26  --  x:\galg\galganl.pm
# galganl.pm

package galganl  ;

###########################################################################


  use lib $ENV{"PERL_MACROS"} ; # rpertoire des modules perl personnels


###########################################################################

  use galgfncs ; # Bibliothque de fonctions utiles sur chaines
  use galgvars ; # Bibliothque de fonctions pour identificateurs et listes (variables, tableaux, modules)


###########################################################################
###########################################################################


###########################################################################
##                                                                        #
##       sous-programmes principaux pour l'Analyse des Algorithmes        #
##                                                                        #
###########################################################################


###########################################################################
###########################################################################


sub initListes {

    # le sous-programme initListes dfinit les liste (variables globales)
    # des mots-cls des algorithmes ; pour que les mots soient reconnus en
    # tant que tels, il faut que les listes commencent et finissent
    # par des espaces

 # liste des dbuts d'instruction qui n'imbriquent pas

 $lddI = &maju(" affecter appeler crire crire_ crire_sur fermer lire lire_sur ouvrir ouvrir_lec ouvrir_ecr quitter") ;

 # liste des dbuts d'instruction  profondeur (ou "qui imbriquent")

 $lddP = &maju(" pour rpter repeter rpeter repter si tant_que ") ;

 # liste des milieux d'instruction

 $main::ldmI = &maju(" alors sinon ") ;

 # liste des fins d'instruction

 $ldfI = &maju(" fin_si fin_pour fin_tant_que jusqu' jusqu'a ") ;

 # liste des premiers mots invalides aprs ALORS/SINON

 $ldpmI = uc("$lddP $main::ldmI $ldfI") ;

 # expression rgulire de construction des identificateurs

 $main::masqI = "^[_a-zA-Z]+[a-zA-Z_0-9]*\$" ;

 # liste des mots de condition

 $ldmdC  = " < = > <= >= <> ET OU NON " ;

 # convertie en interne en

 $ldmdCo  = " < = > {  }  !  ;  :  ~   " ;

 # soit les oprateurs mono-caractres

 $ldmdCop = "<=>{}!;:~" ;

 # liste des premiers mots valides

 $ldpmV = uc("$lddI $lddP $main::ldmI $ldfI $ldmdC $ldmdCo ") ;

} ; # fin sub initListes


###########################################################################
###########################################################################


sub analyseAlgorithme { my $dbg_Analyse = 0 ; # mettre 1 pour debug, 0 en mode normal

 my $nomFichierAlg = $_[0] ;

 if ($dbg_Analyse == 1) { print " (re :) Analyse du fichier-algorithme \"$nomFichierAlg\"\n\n" ; } ;

 &initListes()                     ;  # initialisation des listes des mots-cls
 &galgerr::codesErreur()           ;  # initialisation du tableau des erreurs

 # mise en mmoire des lignes du fichier

 open(FALG,"<$nomFichierAlg") or die ("Impossible d'ouvrir le fichier $nomFichierAlg\n\n") ;

 my $nblignesAlg = 0 ; # nombre de lignes dans le fichier algorithme

 while (<FALG>) {
    $nblignesAlg++;
    if ($dbg_Analyse == 1) { print  $nblignesAlg." : ".$_ ; } ;
    chop($lignesAlg[$nblignesAlg]=$_) ;
    # on remplace de suite les tabulations par un espace
    $lignesAlg[$nblignesAlg] =~ s/\t/ /g ;
 } ; # fin tant que on lit sur le fichier-algorithme
 close(FALG) ;

 if ($dbg_Analyse == 1) {
     print " fin de lecture du fichier-algorithme $nomFichierAlg" ;
     print " avec $nblignesAlg lignes.\n\n" ;
 } ;  # fin de si mode Debug

 # Il arrive que les dernires lignes d'un algorithme soient vides ; on vient donc les
 # liminer par la boucle suivante

 while (length($lignesAlg[$nblignesAlg])==0) {
    $nblignesAlg-- ;
 } ; # fin tant que

 if ($dbg_Analyse == 1) {
     print " on retient donc $nblignesAlg lignes  traiter.\n\n" ;
 } ;  # fin de si mode Debug

 if ($dbg_Analyse == 1) { print " fin de lecture du fichier-algorithme \"$nomFichierAlg\"\n\n" ; } ;

 # construction des noms de fichiers associs  l'algorithme

 my $nomLst = substr($nomFichierAlg,0,length($nomFichierAlg)-3)."lst" ;
 my $varLst = substr($nomFichierAlg,0,length($nomFichierAlg)-3)."lvm" ;

 # essai d'ouverture des fichiers correspondant

 open(FLST,">$nomLst") or die ("          Erreur ! Impossible d'crire dans $nomLst\n\n") ;
 open(FLVM,">$varLst") or die ("          Erreur ! Impossible d'crire dans $varLst\n\n") ;

 # prparation et affichage de l'en-tete des lignes de sortie

 my $debFic  = " Fichier $nomLst issu de galg -a  $nomFichierAlg" ;
 my $ligEgal =  "=" x length($debFic) ;

 print FLST "\n$debFic\n" ;
 print FLST " $ligEgal\n" ;
 print FLST "   ".&gereLeTemps()." \n" ;
 print FLST " \n" ;

 $debFic  = " Fichier $varLst issu de galg -a  $nomFichierAlg" ;
 print FLVM "\n$debFic\n" ;
 print FLVM " $ligEgal\n" ;
 print FLVM "   ".&gereLeTemps()." \n" ;
 print FLVM " \n" ;


 $intitule =  "  ERR  LIG  |  INS PRO \n" ;
 print FLST $intitule ;

 $iLigneAlgo   = 1   ;    # numro de la ligne en cours
 $nbIns        = 0   ;    # numro de l'instruction en cours
 $nivPro       = 0   ;    # profondeur d'imbrication
 $insNf        = 0   ;    # instruction(s) non finie(s)
 $nbCmtPurs    = 0   ;    # commentaires "purs"
 $auteurVu     = 0   ;    # pour tester le nom de l'auteur

 $insPrec      = "?" ;    # instruction prcdente
 $insCour      = "?" ;    # instruction courante

 $lstVars      = ""  ;    # liste des variables
 $lstFic       = ""  ;    # liste des variables de fichier
 $lstModules   = ""  ;    # liste des modules
 $lstTableaux  = ""  ;    # liste des tableaux
 $lastSTru     = ""  ;    # chaine des structures utilises
 $mdmP         = ""  ;    # chaine des mots du milieu

 # utilisation de lastStru et mdmP :
 #   POUR ... SI .. ALORS ... SINON SI ... ALORS
 #  correspond lastStru = PSS
 #          et mdmP     = PSA

 $lstVarsgauche   = ""  ;    # liste des variables en partie gauche ;

 #  cause de Rex, il faut garder une trace globale des conditions JUSQU'A
 # dans les structures REPETER... JUSQU'A

 $main::NbRep = 0 ;

 while ( $iLigneAlgo <= $nblignesAlg ) {

   $main::f_err      = "   " ; # symbole d'erreur
   $main::c_err      = "   " ; # code d'erreur
   $laligne          = $lignesAlg[$iLigneAlgo] ;
   $ligneAlgo        = " ".&sansCmt($laligne)." " ;
   $ligneIdent       = "" ;

   if ($dbg_Analyse == 1) { print  "   $main::nbErreurs ANALYSE DE LA LIGNE $iLigneAlgo : $laligne \n" ; } ;

   # il faut un auteur dans les 5 premires lignes du fichier !

   if ($iLigneAlgo<=5) {
         if (index(uc($laligne),uc(" Auteur "))>-1) { $auteurVu = 1 ; } ;
   } ; # fin de si pas d'auteur vu dans les 5 premires lignes du fichier

   # si la ligne ne contient que "  " on a affaire  un commentaire pur
   # on vrifie la prsence du mot auteur

   if ($ligneAlgo eq "  ") {

      $cmtPur = 1 ; $nbCmtPurs++ ;

      # il faut un auteur dans les 5 premieres commentaires purs du fichier !

      if ($cmtPur<=5) {
         if (index(uc($laligne),uc(" Auteur "))>-1) { $auteurVu = 1 ; } ;
      } ; # fin de si moins de 5 commentaires purs

   } else {

       # on traite les instructions comme des mots spars par des
       # espaces et crits en majuscules (ce qui simplifie les tests
       # pour ecrire, crire...)
       # odd :    ($mu,$finIns)  = &premierEtReste($ligneAlgo) ;

       ($mu,$finIns,$varFic)  = &decoupeLigneAlgo($ligneAlgo) ;

       # on dtecte un certain nombre d'erreurs via le mot Un de la ligne
       # ce mot un est mis dans la variable $mu

       $insCour = "" ; # pour l'instruction courante

       # le mot un n'est pas forcment le nom de l'instruction en cours
       # par exemple dans ALORS ECRIRE x le mot un est ALORS
       # mais l'instruction est ECRIRE

       if (length($mu)>0) { $insCour = $mu ; } ;

       if ($dbg_Analyse == 1) { print  "    VALIDATION DU MOT UN QUI EST               : $mu\n" ; } ;

       &gereMotUn($mu) ;

       # vrifions maintenant si le reste de l'instruction est correct

       if ($dbg_Analyse == 1) { print  "    VALIDATION DE LA FIN D'INSTRUCTION QUI EST : $finIns\n" ; } ;
       if ($dbg_Analyse == 1) { print  "    VARIABLE DE FICHIER                        : $varFic\n" ; } ;

       &valideInstruction($mu,$finIns,$varFic) ;
       if (length($varFic)>0) { &ajouteVarFic($varFic,$iLigneAlgo) ; } ;

   } ; # fin de si ce n'est pas un commentaire pur

   if ($dbg_Analyse == 1) { print  "    FORMATAGE DE LA LIGNE \n" ; } ;

   # si pas de nom d'auteur dans les 5 premires lignes, on met une erreur
   # en dernire ligne de l'algorithme

   if ( ($iLigneAlgo == $nblignesAlg) and ($auteurVu==0) ) {
      &galgerr::erreur("057") ;
   } ; # fin de si on n'a pas vu d'auteur

   # n'avoir aucune instruction dans un algorithme est une erreur

   if  ( ($iLigneAlgo == $nblignesAlg) and ($nbIns==0) ) {
      &galgerr::erreur("059") ;
   } ; # fin de si il n'y a pas d'instruction

   # on affiche la ligne bien prsente en grant une erreur ventuelle

   &formateLigne() ;

   # on dcrmente le compteur en cas de fin d'instruction

   if (index($ldfI,$mu)>-1) { # c'est la fin d'une instruction
      if ($insNf>1) { $nivPro-- ; }
      $insNf-- ;
   } ; # fin de si

   # si les instructions emboitantes ne sont pas finies,
   # on met une erreur en dernire ligne de l'algorithme

   if  ( ($iLigneAlgo == $nblignesAlg) and ($insNf>0) ) {

       &galgerr::erreur("058") ;

       # en principe c'est le sous-programme formateLigne qui met la ligne d'erreur
       # dans le tableau $main::tabErr
       # mais comme on teste ici aprs formateLigne ( cause de la
       # dcrmentation de $insNf) il faut refaire :

        $ligErr  = "" ;
        $ligErr .= "    Ligne $f_ili : ".&sansEspaceAuDebut($laligne)."\n" ;
        $ligErr .= (" " x 15)." CODE ERREUR ".$main::c_err." --".&maju($main::ce[$main::c_err])."\n" ;

       $main::tabErr[$main::nbErreurs] = $ligErr ;

       # par contre il faut rajouter " la main" la sortie dans le LST

       $ligneErr = "     ERREUR $main::c_err ligne *** $f_ili : ".&maju($main::ce[$main::c_err]) ;
       print FLST "$ligneErr\n" ;


   } ; # fin de si instruction non finie

   if ($dbg_Analyse == 1) { print  "    -- FIN DE L'INSTRUCTION   : '$insCour'\n" ; } ;
   if ($dbg_Analyse == 1) { print  "    -- INSTRUCTION PRECEDENTE : '$insPrec'\n" ; } ;

   # sauvegarde du code de l'instruction pour valider un LIRE aprs un ECRIRE

   $insPrec = " ".&sansEspaceDebutEtFin($insCour)." " ;

   # puis on passe  la ligne suivante

   $iLigneAlgo++ ;

   if ($dbg_Analyse == 1) { &attends() ; } ;

 } ; # fin tantque ( $iLigneAlgo <= $nblignesAlg )

 # fermeture du fichier-listing

 print FLST  "\n -- Fin du fichier $nomLst issu de galg -a  $nomFichierAlg\n" ;
 close(FLST) ;


 # on ferme le fichier des modules, variables...

 close(FLVM) ;

 # affichage des listes de modules, variables et tableaux

 &galgvars::afficheListeVariables($varLst) ;
 &galgvars::afficheListeVarFic($varLst) ;
 &galgvars::afficheListeTableaux($varLst) ;
 &galgvars::afficheListeModules($varLst) ;
 &galgvars::testeHomonymie($varLst) ;

 # criture de fin pour le fichier des modules, tableaux et variables

 open(FLVM,">>$varLst") or die ("          Erreur ! Impossible d'crire dans $varLst\n\n") ;
 print FLVM  "\n -- Fin du fichier $varLst issu de galg -a  $nomFichierAlg\n" ;
 close(FLVM) ;

 return ($nomLst,$varLst,@lignesAlg) ;

} ; # fin sub analyseAlgorithme


###########################################################################


sub  decoupeLigneAlgo  { my $debg_Decoupe = 0 ; # mettre 0 en mode normal, 1 pour debug

  # on essaie de dcomposer la ligne en un mot d'instruction et
  # les reste de la ligne ; il y a des cas particuliers  grer :
  # ECRIRE ... SUR, LIRE ... SUR, OUVRIR et FERMER

  # dcoupage primaire en mot un et reste de la ligne :

  my ($motUn,$resteDeLaLigne) = &premierEtReste($_[0]) ;
  my $varF = "" ; # variable de fichier ventuelle

  # traitement comme mot encadr par des espaces et en majuscules

  $motUn = &maju(" $motUn ") ;

  my $nbmr = &nbMots($resteDeLaLigne) ; # nombre de mots restants

  if ($debg_Decoupe == 1) {  print " DECOUPAGE DE $resteDeLaLigne avec $nbmr MOTS EN : \n" ; } ;

  # le cas le plus simple : FERMER

  if ($motUn eq " FERMER ") {

           $varF = $resteDeLaLigne ;
           $resteDeLaLigne = "" ;

  } ; # fin de si on traite FERMER

  # traitons maintenant OUVRIR dont la syntaxe est
  #      OUVRIR chaine EN_LECTURE  COMME varfic
  #   ou OUVRIR chaine EN_ECRITURE COMME varfic

  my $avdm = "" ; # pour grer l'avant-dernier mot

  if ($motUn eq " OUVRIR ") {

     # s'il y a plus de 2 mots dans le reste de l'instruction
     # on s'intresse  l'avant-dernier mot

     if ($nbmr>1) { $avdm =  " ".uc(&avantDernierMot($resteDeLaLigne))." " ; } ;
     if ($debg_Decoupe == 1) { print " premier mot *$motUn* avant dernier-mot : *$avdm* \n" ; } ;

     # pour OUVRIR, l'avant dernier-mot doit etre COMME, sinon c'est une erreur (numro 55)

     if ($avdm  ne " COMME ") { &galgerr::erreur("055") ; } else {

        # la variable de fichier est le dernier mot de la ligne

        $varF = &dernierMot($resteDeLaLigne) ;

        # calcul de la dernire occurence de COMME dans la phrase

        my $lastPosCom = rindex(uc($resteDeLaLigne)," COMME ") ;
        if ($debg_Decoupe == 1) { print " comme vu en $lastPosCom \n" ; } ;
        $resteDeLaLigne = substr($resteDeLaLigne,0,$lastPosCom) ;

        # faut-il ouvrir en lecture ou en criture ?

        my $dmp = &maju( &dernierMot($resteDeLaLigne) ) ;
        if ($debg_Decoupe == 1) { print " dernier mot : *$dmp* \n" ; } ;
        if    (&maju($dmp) eq "EN_LECTURE")  { $motUn = " OUVRIR_LEC " ; }
        elsif (&maju($dmp) eq "EN_ECRITURE") { $motUn = " OUVRIR_ECR " ; }
        else { &galgerr::erreur("056") ; } ;

        $resteDeLaLigne = &premierMot($resteDeLaLigne) ;

     } ; # fin de si OUVRIR / COMME corerct

  } ; # fin de si on traite OUVRIR

  # enfin, on traite les cas ECRIRE et LIRE
  # qu'il faut peut-etre amnager en ECRIRE_SUR et LIRE_SUR

  $avdm = "" ; # pour grer l'avant-dernier mot

  if ( ($motUn eq " ECRIRE ") or ($motUn eq " LIRE ")) {

     # s'il y a plus de 2 mots dans le reste de l'instruction
     # on s'intresse  l'avant-dernier mot

     if ($nbmr>1) { $avdm =  " ".uc(&avantDernierMot($resteDeLaLigne))." " ; } ;

     # si l'avant-dernier mot est " SUR " alors les instructions ECRIRE et LIRE
     # doivent etre renommes en ECRIRE_SUR et LIRE_SUR

     if ($avdm  eq " SUR ") {

        # la variable de fichier est le dernier mot de la ligne

        $varF = &dernierMot($resteDeLaLigne) ;
        if (length($varF)>0) { &ajouteVar($varF,$iLigneAlgo) ; } ;
        if (length($varF)>0) { &ajouteVarFic($varF,$iLigneAlgo) ; } ;

        # calcul de la dernire occurence de SUR dans la phrase

        my $lastPosSur = rindex(uc($resteDeLaLigne)," SUR ") ;
        if ($debg_Decoupe == 1) { print " sur vu en $lastPosSur \n" ; } ;
        $resteDeLaLigne = substr($resteDeLaLigne,0,$lastPosSur) ;

        # et donc l'instruction devient instruction_sur

        $motUn = " ".&sansEspaceDebutEtFin($motUn)."_SUR " ;

     } ; # fin de si ECRIRE ou LIRE / SUR corerct

  } ; # fin de si on traite ECRIRE OU LIRE


  if ($debg_Decoupe == 1) {
       print " DECOUPAGE EN : \n" ;
       print "      - mot Un           : $motUn \n" ;
       print "      - instruction      : $resteDeLaLigne \n" ;
       print "      - variable fichier : $varF \n";
  } ; # fin de debug

  return ($motUn,$resteDeLaLigne,$varF) ;

} ; # fin sub decoupeLigneAlgo


###########################################################################


sub gereMotUn  { my $dbg_Gmu = 0 ; # mettre 1 pour debug, 0 en mode normal

   # le mot un doit etre valide : c'est un mot-clef
   # plutot que d'utiliser un automate pour valider la succession
   # des instructions, on effectue les rares tests qui valident
   # l'enchainement des instructions, ce qui permet de
   # numroter les erreurs correspondantes

   if ($dbg_Gmu == 1) { print " test du mot un = '$mu' instruction '$insCour' \n" ; } ;

   $cmtPur = 0 ;

   # si le mot un est invalide, on a l'erreur de code 2 mais on n'arrte pas tout

   if (index($ldpmV,$mu)==-1) { &galgerr::erreur("002") ; } ;

   # un mot cl de structure indique une instruction qui commence
   # (donc la variable pour instructions(s) non finie(s) est incrmente )

   if (index($lddP,$mu)>-1) {

      $insNf++ ;

      # dpasser 3 niveaux de structures est considr comme une erreur

      if ($insNf>3) { &galgerr::erreur("017") ; } ;

      # un mot cl de structure indique le dbut
      # d'une instruction s'il n'est pas dja dans une structure

      if ($insNf<=1) {
         $nbIns++ ;
      } ; # fin de si sur insNf

      # on met en mmoire le type de structure

      $curStru   = substr($mu,1,1) ;
      $lastStru .= $curStru ;
      if ($mu ne " SI ") { $mdmP .= $curStru ; } ;

   } ; # fin de si sur mu

   # si le premier mot fait partie de la liste des
   # dbuts d'instructions, on a une instruction  traiter

   if ( (index($lddI,$mu)>-1) and ($insNf==0) ) {
      $nbIns++ ; # nouvelle instruction
   } ; # fin de si

   # finir une structure alors qu'une structure plus interne n'est pas finie
   # est une erreur ; le nom de structure est en principe apres FIN_ sauf pour
   # jusqu' qui demande un traitement particulier

   $nomIns = substr($mu,5,1) ;
   if ($mu eq " JUSQU'A ") { $nomIns = "R" ; } ;
   if ( (length($mu)>7) and (index(" $ldfI ",$mu)>-1) ) {
      if ($nomIns ne substr($lastStru,-1,1)) { &galgerr::erreur("016") } ;
      $lastStru = substr($lastStru,0,length($lastStru)-1) ;
      $mdmP = substr($mdmP,0,length($mdmP)-1) ;
   } ; # fin si sur fin de structure

   # pour alors et sinon, on commence par tester si
   # on a le droit d'etre la

    if (index($main::ldmI,$mu)>-1) {
       if ($mu eq " ALORS ") { $mdmP .= substr($mu,1,1) ; } ;
       if ($mu eq " SINON ") { substr($mdmP,length($lastStru)-1,1) = "S" ; } ;

       if (substr($lastStru,-1,1) ne "S") { &galgerr::erreur("024") ; } else {
## les deux lignes suivantes sont-elles vraiment utiles ?
## si oui, pourquoi ?
          if ($mu eq " ALORS ") { if (substr($mdmP,length($lastStru)-1,1) ne "A") { &galgerr::erreur("060") ; } } ;
          if ($mu eq " SINON ") { if (substr($mdmP,length($lastStru)-1,1) ne "S") { &galgerr::erreur("0242") ; } } ;

       } ; # fin de si on est bien dans le si

    } ; # fin de si on est dans alors/sinon

   # ne pas mettre de alors apres un si est une erreur

   if ($insPrec eq " SI ") { if ($mu ne " ALORS ") { &galgerr::erreur("021") ; } ; } ;

   # le mot-cl ALORS ne doit pas apparaitre aprs le mot ALORS

   if ( ($mu eq " ALORS ") and ($mup eq " ALORS ") ) { &galgerr::erreur("045") ; } ;

   # le mot-cl SINON ne doit pas apparaitre aprs le mot SINON

   if ( ($mu eq " SINON ") and ($mup eq " SINON ") ) { &galgerr::erreur("046") ; } ;

######## quelques fautes de gout

   # si la premire instruction a lieu en ligne 1, il n'y a pas
   # de commentaire en dbut, c'est donc une erreur

   if ( ($nbIns==1) and ($iLigneAlgo==1) ) { &galgerr::erreur("001") ; } ;

   # pour ALORS ET SINON, $mu n'est pas le nom de l'instruction

   if ( ($mu eq " ALORS ") or ($mu eq " SINON ") ) {
      my $pmu = &maju( premierMot($finIns) ) ; # premier mot aprs mot un
      my $pdl = index($lddI,$pmu) ;            # position de pmu dans liste de debut d'instruction
      if ($pdl>-1) { $insCour = $pmu ; } else { $insCour = " SI " ; } ;
   } ; # fin de si on traite alors ou sinon

   # une instruction ECRIRE doit prcder une instruction LIRE

   if ($insCour eq " LIRE ") {
        if ( ($insPrec ne " ECRIRE " ) and ($insPrec ne " ECRIRE_ ")  ) { &galgerr::erreur("003") ; } ;
   } ;  # fin de si LIRE n'est pas prcd de ECRIRE ou ECRIRE_

   # test sur fin de structure

   if ( (length($mu)>7) and (index(" $ldfI ",$mu)>-1) ) {

      # une fin de structure non commente est considre
      # comme une erreur

      $finlig = &phraseSansPremierMot($laligne) ;
      $finlig = &sansEspaceDebutEtFin($finlig) ;
      if (length($finlig)==0) {
         if ($nomIns eq "P") { &galgerr::erreur("012") } ;
         if ($nomIns eq "S") { &galgerr::erreur("013") } ;
         if ($nomIns eq "T") { &galgerr::erreur("014") } ;
      } ; # fin si

   } ; # fin si sur fin de structure

   # on sauvegarde le mot Un (pas le nom de l'instruction)
   # pour pouvoir tester redondance de alors et sinon

   $mup = $mu ; # mup : mot un prcdent

   return ;

} ; # fin sub gereMotUn

###########################################################################

sub valideInstruction  {  my $dbg_Vi = 0 ; # mettre 1 pour debug, 0 en mode normal

 # le plus simple est de tester dans cet ordre :

 #     - quilibrage des expressions
 #     - fins   de structure : rien aprs (cmt dja vu)
 #     - milieu de structure : pas d'inst. structurante puis (re)valideInstruction
 #     - lire     : un et un seul identificateur
 #     - ecrire   : une liste non vide d'expressions
 #     - appeler  : identificateur ( liste d'expressions v. vide )
 #     - affecter : un identicateur <-- une et une seule expression
 #     - pour
 #     - si et tant_que


 my $lins      = $_[0] ;  # nom de l'instruction
 my $corpsIns  = $_[1] ;  # corps de l'instruction
 my $varDeFic  = $_[2] ;  # variable de fichier

 if ($dbg_Vi==1) {
    print "\n" ;
    print " validation de l'instruction ' $laligne '\n " ;
    print " nature de l'instruction :   ' $lins '\n " ;
    print " corps de l'instruction  :   ' $corpsIns '\n " ;
    print " variable de fichier     :   ' $varDeFic '\n " ;
 } ; # fin de debug

 # un peu de mnage pour $lins ne fait pas de mal

 $lins  = &sansEspaceDebutEtFin($lins) ;

 # on remet ensuite des espaces avant et aprs pour normalisation

 $lins  = " $lins " ;

 # un peu de mnage pour $corpsIns ne fait pas de mal

 $rdp   = &sansEspaceDebutEtFin($corpsIns) ;

 # si le dernier caractre de l'instruction est un point-virgule,
 # c'est l'erreur 048

 if (substr($corpsIns,-1,1) eq ";") {
    &galgerr::erreur("048") ;
    return(-1) ;
 } ; # fin si

 # le premier test  faire est celui de l'quilibrage des formules

 my $tg1 = &testeGuillemets($rdp) ;

 # pour viter de mauvaises surprises, on remplace les chaines
 # de caractres constantes par la valeur 0 (si les guillemets sont corrects)
 # car sinon ecrire " test des ( " provoquerait une erreur

 $rdp = &oteChainesCst($rdp) ;

 my $tg2 = &testeParenthesage($rdp) ;
 my $tg3 = &testeCrochetage($rdp) ;

 if ($tg1+$tg2+$tg3==0) {

    # on peut alors calculer le nombre de mots de rdp

    $nbm = &nbMots($rdp) ;

    if ($dbg_Vi==1) {
        print " DONC l'EXPRESSION A $nbm MOT(S) \n" ;
    } ; # fin de debug

    # pour les fins de structures, rien aprs le mot (car commentaire obligatoire)

    if ( ($lins eq " FIN_SI ")
    or   ($lins eq " FIN_POUR ")
    or   ($lins eq " FIN_TANT_QUE ") ) {
         $rdp = &sansEspaceDebutEtFin($rdp) ;
         if (length($rdp)>0) { &galgerr::erreur("036") ; } ;
    } ; # fin de si on gere une fin de structure

    # pour les mots du mileu, pas d'instruction structurante sur la meme ligne
    # et obligation de mot cl d'instruction

    if ( ($lins eq " ALORS ") or ($lins eq " SINON ") ) {
      ($smu,$rebelote) = &premierEtReste($rdp) ;
      my $smu = " ".&maju($smu)." " ;
      if ( (length($smu)>2) and (index($ldpmI,$smu)>-1) )  { &galgerr::erreur("019") ; $smu = "" ; } ;
      if ( (length($smu)>2) and (index($lddI,$smu)==-1) )  { &galgerr::erreur("050") ; $smu = "" ; } ;
      if (length($smu)>2) { &valideInstruction($smu,$rebelote) ; } ;

    } ; # fin de si on gere alors ou sinon

    # pour l'instruction LIRE on teste le nombre de variables  lire
    # on ajoute ventuellement la variable  la liste des variables
    # en partie gauche car LIRE quivaut  une affectation
    # la validit de l'identificateur de la variable est teste
    # par le sous-programme ajouteVarEnpartiegauche

    if ( ($lins eq " LIRE ") or ($lins eq " LIRE_SUR ") ) {
       $rdp = &aereVirgules($rdp) ;
       $nbm = &nbMots($rdp) ;
       if ($nbm<1) { &galgerr::erreur("005") ; }                  # au moins 1 mot
       elsif (index($rdp,"[")>-1) { &galgerr::erreur("025") ; }   # pas de tableau
       elsif (index($rdp,"(")>-1) { &galgerr::erreur("020") ; }   # pas de fonction
       else { if ($nbm>1) { &galgerr::erreur("006") ; }           # pas plus d'un mot
              if ($nbm == 1) { &galgvars::ajouteVarEnpartiegauche($rdp,$iLigneAlgo) ;
              } ; # fin si on lit bien une seule variable
       } ; # fin si on a pas assez de mots
    } ; # fin de si on gere LIRE

    # pour l'instruction ECRIRE
    # on vrifie qu'il y a bien quelquechose  crire
    # puis on teste la validit de chaque expression
    # (deux expressions sont spares par une virgule)

    if ( ($lins eq " ECRIRE ") or ($lins eq " ECRIRE_ ") ) {
       $rdp = &aereVirgules($rdp) ;
       $rdp = &aereCrochets($rdp) ;
       $nbm = &nbMots($rdp) ;
       if ($nbm<1) { &galgerr::erreur("004") ; }  # au moins 1 mot
       &gereListeExpressions($rdp) ;
    } ; # fin de si on gere ECRIRE

    # pour l'instruction POUR
    # on vrifie qu'il n'y a qu'une variable comme indice de boucle
    # et on teste la validit de l'expression de dbut et de fin

    if ($lins eq " POUR ") {
       $rdp =~ s/de1a/ de 1 a /i ;
       $rdp =~ s/de1/ de 1 a /i ;
       $rdp =~ s/de0a/ de 0 a /i ;
       $rdp =~ s/de0/ de 0 a /i ;
       $rdp =~ s/DE0A/ DE 0 A /i ;
       $rdp =~ s/DE1A/ DE 1 A /i ;
       ($indb,$pdP) = &premierEtReste($rdp) ;
       if ($dbg_Vi==1) {
          print "\n" ;
          print "   PREMIER MOT : $indb \n " ;
       } ; # fin de debug
       $vidb = &testeIdentificateur($indb) ;
       if ($vidb==0) {
          ($avA,$apA) = &decoupePour($pdP) ;
          if ($dbg_Vi==1) {
             print "   avant : $avA \n " ;
             print "   apres : $apA \n " ;
          } ; # fin de debug
          &testeUneSeuleExpression($avA) ;
          &testeUneSeuleExpression($apA) ;
       } ; # fin de si indice de boucle invalide
    } ; # fin de si on gere pour

    # pour les instructions SI, TANT_QUE et REPETER
    # on teste si l'expression est bien une condition
    # en principe, chaque variable utilise est dja
    # affecte  gauche

    if ( ($lins eq " SI ") or ($lins eq " TANT_QUE ") or ($lins eq " JUSQU'A ") ) {
       if ($dbg_Vi==1) { print " CONDITION A GERER : $rdp \n" ; } ;
       $rcond = &testeCondition($corpsIns) ;

       # il faut traiter  part le cas REPETER / JUSQU'A pour le langage Rexx
       if ($mu eq " JUSQU'A ") {
           $main::NbRep++ ;
           $main::globRep[$main::NbRep] = $corpsIns ;
           if ($dbg_Vi==1) {
              print " donc : REPETER/ JUSQU'A ".$main::NbRep." vaut ".$main::globRep[$main::NbRep]."\n" ;
           } ; # fin de debug
       } ; # fin de si on traite jusqu'a

    } ; # fin de si on gere Si ou tant_que

    # pour l'instruction APPELER on utilise un sous-programme spcifique

    if ($lins eq " APPELER ") { &valideAppeler($rdp) ;  } ;

    # pour l'instruction AFFECTER aussi

    if ($lins eq " AFFECTER ") { &valideAffecter($rdp) ;  } ;

 } ; # fin de si test des guillemets, parenthses et crochets

 return 0 ;

} ; # fin sub valideInstruction

###########################################################################

sub valideAppeler  {  my $dbg_Vap = 0 ; # mettre 1 pour debug, 0 en mode normal

 my $rdp = $_[0] ;

 # pour l'instruction APPELER on vrifie que
 # l'expression est quilibre
 # on ajoute ventuellement au passgae
 # le nom du module  la liste des modules
 # puis on traite les paramtres comme avec ECRIRE

 if ($dbg_Vap==1) { print " appel : $rdp \n" ;  } ;

    $rdp = &sansEspaceDebutEtFin($rdp) ;

    # pas d'appel de module sans parenthse ouvrante

    if ( (length($rdp)>0) and (index($rdp,"(")==-1) ) {
       &galgerr::erreur("032") ; $rdp = "" ;
    } ; # fin de si on n'a pas vu de parenthse ouvrante ;

    # si le dernier caractre n'est pas une parenthse fermante, c'est aussi une erreur

    if ( (length($rdp)>0) and (substr($rdp,-1,1) ne ")") ) {
       &galgerr::erreur("033") ;
       $rdp = "" ;
    } else { # rcupration du nom de module

       my $idpo  = index($rdp,"(") ;
       my $nem   = substr($rdp,0,$idpo) ;
       my $lap   = substr($rdp,$idpo+1) ;
       substr($lap,-1,1) = " " ;

       if ($dbg_Vap==1) { print " module : $nem \n" ;  } ;

       # ajout ventuel du nom du module

       if (&nbMots($nem)>1) {
          if ($dbg_Vap==1) { print " nom du module incorrect : $nem \n" ;  } ;
          &galgerr::erreur("034") ; $rdp = "" ;
       } ; # fin de si incorrect car on a plus d'un mot

       my $nv = &galgvars::ajouteModule($nem,$iLigneAlgo) ;
       if ($nv>0) { $rdp= "" ; } ;

       # finalement, on gre les paramtres d'appel

       if (&chaineVide($lap)==0)  {
          $lap =~ s/\(/\( / ;
          if ($dbg_Vap==1) { print " paramtres d'appel : $lap \n" ;  } ;
          $nbParmAp = &gereListeExpressions($lap,1) ;
          if ($dbg_Vap==1) { print " DONC POUR  $nem ON PROPOSE ARITE $nbParmAp \n" ;  } ;

          &galgvars::proposeArite($nem,$nbParmAp) ;
       } else { &galgvars::proposeArite($nem,0) ;
       } ; # fin de si il faut grer lap

    } ; # fin de si on n'a pas vu de parenthse fermante

    return 12 ;

} ; # fin sub valideAppeler

###########################################################################

sub valideAffecter  { my $dbg_Vaf = 0 ; # mettre 1 pour debug, 0 en mode normal

 # pour l'instruction AFFECTER
 # on vrifie qu'il n'y qu'une variable  gauche du symbole <--
 # qu'il n'y a pas d'affectation multiple et que
 # l'expression pour le calcul est correcte
 # on ajoute ventuellement au passgae
 # la variable  la liste des variables et les
 # noms de modules  la liste des modules

 if ($dbg_Vaf==1) { print " affectation : $rdp \n" ;  } ;

    $idla  = index($rdp,"<--") ;
    if (($idla==-1) or (index($rdp,"<---")>-1)) { # pas de signe <-- ou un - de trop
        &galgerr::erreur("039") ; $rdp = "" ;
    } else {

    # la partie variable est  gauche du symbole <--

    $lavar = substr($rdp,0,$idla) ;

    if ($dbg_Vaf==1) { print " la variable : ! $lavar !\n" ;  } ;

    # et la partie restante  droite

    $pra = substr($rdp,$idla+3) ;

    if ($dbg_Vaf==1) { print " l'expression : | $pra | \n" ; } ;

    # une variable est non vide, ne contient ni tableau ni fonction
    # (dtect par testeIdentificateur dans ajouteVar)

    if (&chaineVide($lavar)==1) { &galgerr::erreur("007") ; $rdp = "" } ;

    # s'il n'y a de symbole de tableau, on peut ajouter la variable
    #  la liste des variables

    if (index($lavar,"[")==-1) { &ajouteVarEnpartiegauche($lavar,$iLigneAlgo) ; } else {

       &gereTableau($lavar) ;

    } ; # fin de si on teste si symbole de tableau

    # on teste alors l'expression aprs le symbole <--

    if (&chaineVide($pra)==1) { &galgerr::erreur("047") ; # il faut au moins 1 mot
    } else {

          $idsa  = index($pra,"<--") ;
          $rdp   = $pra ;

          # on ne veut pas d'affectation multiple

          if ($idsa>-1) { &galgerr::erreur("037") ; } else {
                &testeUneSeuleExpression($rdp) ;
          } ; # fin de si affectation multiple

    } ; # fin de si le reste de l'expression est non vide

 } ; # fin de si symbole <-- non vu

} ; # fin sub valideAffecter

##########################################################
#
#  mettre dans galgfncs ?
#
##########################################################

###########################################################################
##                                                                                      #
##      sous-programmes pour gestion des Expressions                                    #
##                                                                                      #
###########################################################################


###########################################################################
###########################################################################

sub nbExpression  {  my $dbg_Nbe = 0 ; # mettre 1 pour debug, 0 en mode normal

  # donne le nombre d'expressions de la chaine fournie en paramtre
  # la valeur -1 indique une erreur qui empeche de compter le nombre d'expressions


  my $leeat  = $_[0] ;
  my $leeavt = $_[0] ;
  my $ned    = -1 ;

  if ($dbg_Nbe==1) { print "\n\n nb d'expressions dans : $leeat \n " ; } ;

  # une chaine vide n'a pas d'expression

  if(&chaineVide($leeat)==1) { $ned = 0 ; } else {

  # soyons prudents : testons l'quilibrage de la chaine d'abord

     my $tg1 = &testeGuillemets($rdp) ;

     # pour viter de mauvaises surprises, on remplace les chaines
     # de caractres constantes par la valeur 0 (si les guillemets sont corrects)

     if ($tg1>0) { $ned = -1 } else {

        $rdp = &oteChainesCst($rdp) ;

        my $tg2 = &testeParenthesage($rdp) ;
        my $tg3 = &testeCrochetage($rdp) ;

        if ($tg2+$tg3==0) { if ($dbgNbe==1) { print " expression quilibre : $leeat \n " ; } ;

        } ; # fin de si test des parenthses et crochets

        # ensuite, on remplace les constantes entre chaines par 0,

        $leeat = &oteChainesCst($leeat) ;
        if ($dbg_Nbe==1) { print " sans chaine constante : $leeat \n " ; } ;

        # les appels de fonctions f(...) par f12 et les expr (...) par 12

        $leeat = &oteFonctions($leeat) ;
        if ($dbg_Nbe==1) { print " sans fonction : $leeat \n " ; } ;

        # les rfrences de tableau t[...] par t3

        $leeat = &oteTableaux($leeat) ;
        if ($dbg_Nbe==1) { print " sans tableau : $leeat \n " ; } ;

        # il ne devrait rester  tester que des paquets simples d'expressions arithmtiques
        # ventuellement invalides, mais c'est volontaire car on ne teste pas
        # encore la validit  ce niveau

        # des erreurs faciles  viter :
        #     . des points-virgules au lieu de virgules
        #     . un oprateur en fin de ligne
        #     . des oprateurs comme * / en dbut de ligne
        #     . deux virgules qui se suivent
        #     . autrechose que expr. arithm. sur variable

        $leeat =~ s/ //g ;
        if    ( index($leeat,";")>-1)                         {  &galgerr::erreur("048") ; }
        elsif ( index("+-*/=<>,",substr($leeat,-1,1))>-1)     {  &galgerr::erreur("031") ; }
        elsif ( index("*/=<>,",substr($leeat,0,1))>-1)        {  &galgerr::erreur("015") ; }
        elsif ( index($leeat,",,")>-1)                        {  &galgerr::erreur("040") ; }
        elsif ( index($leeat,"<--")>-1)                       {  &galgerr::erreur("028") ; }
        elsif ( ($leeat =~ m/[=<>]/) and ($mu eq " ECRIRE ")) {  &galgerr::erreur("029") ; }
        elsif ( $leeat !~ m/^[ \-A-Za-z_\+\*\/0-9.,()]*$/)    {  &galgerr::erreur("049") ; }
        else  {

        if ($dbg_Nbe==1) { print " allez, on teste : !$leeat! \n " ; } ;
            # avec n virgules, on a n+1 expressions
            $ned = 1 + ($leeat =~ s/,//g) ;

        } ; # fin de si on a vu des points-virgules

     } ; # fin de si guillemets incorrects

  } ; # fin de si la chaine n'est pas vide

  if ($dbg_Nbe==1) {
    print "\n donc  dans : $leeavt \n " ;
    print " il y a sans doute $ned expression(s) \n " ;
  } ; # fin de debug

  return $ned ;

} ; # fin sub nbExpression

###########################################################################

sub testeUneSeuleExpression  {

  my $eat  = $_[0] ;
  my $nepa = &nbExpression($eat) ;

  if ($nepa==1)  {  &gereListeExpressions($eat) ;
          } else {  if ($nepa>-1) { &galgerr::erreur("008") ; } ;
  } ; # fin de si on a une seule instruction

} ; # fin sub testeUneSeuleExpression

###########################################################################

sub gereListeExpressions { my $dbg_Gl = 0 ; # mettre 1 pour debug, 0 en mode normal

  my  $ld    = $_[0] ;
  if ($dbg_Gl==1) { print "\n GERELISTEEXPRESSIONS  : liste d'expressions : $ld \n" ; } ;

  my $nepa = &nbExpression($ld) ;
  if ($dbg_Gl==1) { print " avec (gH) $nepa expressions.\n" ; } ;

  if ($nepa>-1) { # expression valide

  $ld = &sansEspaceDebutEtFin($ld) ;

  # on gre une liste non vide qui finit bien

     if (&chaineVide($ld)==0)  {
        if    (index($ld,";")>-1)                       {  &galgerr::erreur("048") ; $ld = "" ; }
        elsif (index("+-*/=<>,",substr($ld,-1,1))>-1)   {  &galgerr::erreur("031") ; $ld = "" ; }
        elsif (index("*/=<>,",substr($ld,0,1))>-1)      {  &galgerr::erreur("015") ; $ld = "" ; } ;
  } ; # fin de si chaine non vide et bien finie

  if (&chaineVide($ld)==0) {

     # on dcoupe vraiment en un tableau d'expression et on analyse chaque
     # expression rcursivement

     my $vne = 1 ;              # nb d'expressions
     my $cde = 0 ;              # indice de caractre
     my $kde = "?" ;            # caractre courant
     my $lde = length($ld) ;    # longueur de la liste en tout
     my $nbp = 0 ;              # parenthses
     my $nbc = 0 ;              # crochets
     my $sex = "" ;             # sous-expression courante
     my @tdx ;

     while ($cde<=$lde) {
       $kde = substr($ld,$cde,1) ;
       if ($kde eq "[") { $nbc++ ; } ;
       if ($kde eq "]") { $nbc-- ; } ;
       if ($kde eq "(") { $nbp++ ; } ;
       if ($kde eq ")") { $nbp-- ; } ;
       if (($kde eq ",") and ($nbp == 0) and ($nbc==0)) {
         $tdx[ $vne ] = $sex ;
         $vne++ ; $sex = "" ;
       } else { $sex .= $kde ;
       } ; # fin de si on a fini une expression
       $cde++ ;
     } ; # fin tant que
     $tdx[ $vne ] = $sex ;

    if ($dbg_Gl==1) { # affichage de debug des sous-expressions

        my $idne = 1 ;
        while ($idne<=$vne) {
          $eat = $tdx[ $idne ] ;
          print " sous-Expression $idne : $eat\n" ;
          $idne++ ;
        } ; # fin tant que sur $idne
    } ; # fin de debug

     # passage en revue des expressions

     my $idne = 1 ;
     while ($idne<=$vne) {
       $eat = $tdx[ $idne ] ;
       if ($dbg_Gl==1) { print " test de la sous-Expression $idne / $vne : $eat\n" ; } ;
       &testeExpression($eat) ;
       $idne++ ;
     } ; # fin tant que sur $idne

  } ; # fin de si chaine non vide

  } ; # fin de si nb d'expression valide

##  if ($dbg_Gl==1) { &attends() ; } ;

  return $nepa ;

} ; # fin sub  gereListeExpressions

###########################################################################

sub testeExpression { my $dbg_Te = 0 ; # mettre 1 pour debug, 0 en mode normal

  my $unex  = $_[0] ;
  if ($dbg_Te==1) { print "\n\nTEST DE L'EXPRESSION : $unex \n" ; } ;

  $unex = &sansEspaceDebutEtFin($unex) ;

  # ignorons les constantes entires et relles

  if ($unex =~ m/^[0-9]*.?[0-9]+$/) { $unex = "" ; } ;

  # et les variables

   my $var = ($unex =~ $main::masqI) ;

   if ($var>0) {
       if ($dbg_Te==1) { print "\n\n  AJOUT DE LA VARIABLE : $unex \n" ; } ;
       &galgvars::ajouteVar($unex,$iLigneAlgo) ; $unex = "" ;
   } ; # fin de si variable  ajouter

  if ($dbg_Te==1) { &attends() ; } ;

  # on gre une liste non vide qui finit bien

     if (&chaineVide($unex)==0)  {
        if    (index($unex,";")>-1)                       {  &galgerr::erreur("048") ; $unex = "" ; }
        elsif (index("+-*/=<>,",substr($unex,-1,1))>-1)   {  &galgerr::erreur("031") ; $unex = "" ; }
        elsif (index("*/=<>,",substr($unex,0,1))>-1)      {  &galgerr::erreur("015") ; $unex = "" ; } ;
  } ; # fin de si chaine non vide et bien finie

  # il faut aussi de bons caractres pour une belle expression

  if ($unex !~  m/^[ \-A-Za-z_\+\*\/0-9.,()\[\]]*$/) { &galgerr::erreur("049") ; $unex = "" ; } ;

  # finalement, on analyse les caractres et on dclenche des appels rcursifs

  if (&chaineVide($unex)==0) {

     # pour + expr et - expr on se ramne  un modle normal en rajoutant 0 en dbut d'expression

     if (index("+-,",substr($unex,0,1))>-1)      {  $unex = "0$unex" ; } ;

     # en principe, maintenant on peut tester

     my $ldl = length($unex) ; # longueur de l'expression
     my $ndc = 0 ;             # numro de caractres courant
     my $prt = 0 ;             # nb de parenthses
     my $cro = 0 ;             # nb de crochets
     my $lek = "?" ;           # caractre courant
     my $pge = "" ;            # partie gauche de l'expression
     my $pde = "" ;            # partie droite de l'expression
     my $opv = 0  ;            # oprateur vu pour choisir $pge ou $pde

     # recherche de l'oprateur principal

     while ($ndc<$ldl) {

         $lek = substr($unex,$ndc,1) ;
         if ($lek eq "(") { $prt++ ; } ;
         if ($lek eq ")") { $prt-- ; } ;
         if ($lek eq "[") { $cro++ ; } ;
         if ($lek eq "]") { $cro-- ; } ;
         if ( ($lek =~ m/^[\+\*\-\/]*$/) and ($prt==0) and ($cro==0) ) {
           $opv  = 1 ;
           $pge  = substr($unex,0,$ndc) ;
           $pde  = substr($unex,$ndc+1) ;
           if ($dbg_Te==1) {
              print "   PARTIE GAUCHE : $pge\n" ;
              print "   OPERATEUR     : $lek\n" ;
              print "   PARTIE DROITE : $pde\n" ;
           } ; # fin de debug
           $ndc  = $ldl + 1 ;
         } ; # fin de si oprateur principal vu

         $ndc++ ;
     } ; # fin tant que sur $ndc

     # donc on peut soit tester la partie sans oprateur externe
     #              soit tester les sous-expressions gauche et droite

     if ($opv==0) {
           if ($dbg_Te==1) { print "   PARTIE SANS OPERATEUR EXTERNE : $unex\n" ; } ;
           # on spare les appels de fonctions de rfrence de tableau
           # dans les crochets, pas d'expression vide (test par gereTableau)
           my $idecg = index($unex,"[") ;
           my $idepg = index($unex,"(") ;
           if ($dbg_Te==1) {
               print "  idecg $idecg \n" ;
               print "  idepg $idepg \n" ;
           } ; # fin de debug

           if ( ($idecg==-1) and ($idepg==-1) ) {
              if ($dbg_Te==1) { print "       EXPRESSION 'normale' : $unex\n" ; } ;
              if (&nbMots($unex)>1) { &galgerr::erreur("030") } else {
                 if (&testeIdentificateur($unex)==1) { &galgerr::erreur("020") ; } else {
                 $unex = &testeExpression($unex) ; }
              } ; # fin de si trop de mots
           } else {
              if ( ($idepg>-1) and ( ($idecg==-1) or ($idepg<$idecg) )) {
                 if ($dbg_Te==1) { print "       EXPRESSION 'module' : $unex\n" ; } ;
                 $unex = &valideAppeler($unex) ;
              } elsif ( ($idecg>-1) and ( ($idepg==-1) or ($idecg<$idepg) )) {
                 if ($dbg_Te==1) { print "       EXPRESSION 'tableau' : $unex\n" ; } ;
                 $unex = &gereTableau($unex) ;
              } ; # fin de si non tableau et non appel de module
           } ; # fin de si non expression normale

     } else {
           # avec un oprateur, une expression ne doit pas etre vide
           &testeExpression($pge) ;
           &testeExpression($pde) ;
     } ; # fin de si pas d'oprateur

  } ; # fin de si chaine non vide

} ; # fin sub testeExpression

###########################################################################

sub testeCondition { my $dbg_Tc = 0 ; # mettre 1 pour debug, 0 en mode normal

  my $unco = $_[0] ;
  if ($dbg_Tc==1) { print "\n\n      TEST DE CONDITION : $unco \n" ; } ;

  $unco = &sansEspaceDebutEtFin($unco) ;

  # si la condition contient un des symboles <, > ou =
  # il faut dcomposer et tester chaque partie
  # on commence par remplacer >= par { etc.
  # de meme, non( c) devient 5 non ( c )
  # voir les variables ldmdC et ldmdCo en dbut de programme

  $unco = preTraiteCond($unco) ;
  if ($dbg_Tc==1) { print "     RETOUR DE PRETRAITEMENT : $unco \n\n" ; } ;

  # limination ventuelle des parenthses externes

  $unco = &sansEspaceDebutEtFin( $unco ) ;
  if ($dbg_Tc==1) { print "     AVEC PAR : '$unco' \n" ; } ;
  if ( (substr($unco,0,1) eq "(")  and (substr($unco,-1,1) eq ")") )  {
    my $ndsdp = 0 ;            # nb de symboles de parenthses
    my $ldl  = length($unco) ; # longueur de l'expression
    my $ndc  = 1 ;             # numro de caractres courant
    my $ndpo = 0 ;             # nb d'oprateurs de comparaison
    while ($ndc<$ldl-1) {
      $lek = substr($unco,$ndc,1) ;
      ## if ($dbg_Tc==1) { print "       CAR '$lek' \n" ; } ;
      if ($lek eq "(") { $ndsdp++ ; } ;
      if ($lek eq ")") { $ndsdp-- ; } ;
      if (index($ldmdCop,$lek)>-1) { $ndpo++ ; } ;
      $ndc++ ;
    } ; # fin tant que sur $ndc
    if ($dbg_Tc==1)                 { print "   ndsdp $ndsdp ET ndpo $ndpo \n" ; } ;
    if (($ndsdp==0) and ($ndpo==1)) { $unco = substr($unco,1,$ldl-2) ; } ;
    if ($dbg_Tc==1)                 { print "     SANS PAR : '$unco' \n\n" ; } ;
  } ; # fin d'limination ventuelle des parenthses externes

  my $pgc = "" ;            # partie gauche de condition
  my $pdc = "" ;            # partie droite de condition
  my $ldl = length($unco) ; # longueur de l'expression
  my $ndc = 0 ;             # numro de caractres courant
  my $prt = 0 ;             # nb de parenthses
  my $cro = 0 ;             # nb de crochets
  my $lek = "?" ;           # caractre courant
  my $opv = 0  ;            # oprateur vu pour choisir $pge ou $pde

  # recherche de l'oprateur principal

  while ($ndc<$ldl) {
      $lek = substr($unco,$ndc,1) ;
      if ($lek eq "(") { $prt++ ; } ;
      if ($lek eq ")") { $prt-- ; } ;
      if ($lek eq "[") { $cro++ ; } ;
      if ($lek eq "]") { $cro-- ; } ;
      if ( ($lek ne " " ) and (index($ldmdCo," $lek ")>-1) and ($prt==0) and ($crt==0) ) {
        # bornes ndc et ndc+2 adaptes  " $lek " et non pas $lek
        $opv  = 1 ;
        $pgc  = substr($unco,0,$ndc) ;
        $pdc  = substr($unco,$ndc+2) ;
        $pmc  = $lek ;
        if ($dbg_Tc==1) {
           print "   PARTIE GAUCHE : $pgc\n" ;
           print "   OPERATEUR     : $lek en position $ndc\n" ;
           print "   PARTIE DROITE : $pdc\n" ;
        } ; # fin de debug
        $ndc  = $ldl + 1 ;
      } ; # fin de si oprateur principal vu
      $ndc++ ;
  } ; # fin tant que sur $ndc

  $pgc = &sansEspaceDebutEtFin($pgc) ;
  $pdc = &sansEspaceDebutEtFin($pdc) ;

  if ($pmc eq "~") { $pgc = "1" ; } ;
  if ($dbg_Tc==1)  { print "     CONDITION Gauche : '$pgc'\n" ; } ;
  if ($dbg_Tc==1)  { print "     OPERATEUR        : '$pmc'\n" ; } ;
  if ($dbg_Tc==1)  { print "     CONDITION Droite : '$pdc'\n" ; } ;
  if ($dbg_Tc==1)  { &attends() ; } ;

  if (&chaineVide($pgc)==1)  { &galgerr::erreur("010") ; return ; } ;
  if (&chaineVide($pdc)==1)  { &galgerr::erreur("011") ; return ; } ;

  # ignorons les constantes pour pgc

  if ($pgc =~ m/^[0-9]+$/) { $pgc = 0 ; } ;

  # et les variables

  my $var = ($pgc  =~ $main::masqI) ;
  if ($var>0) {
       if ($dbg_Tc==1) { print "\n\n  AJOUT  DE LA VARIABLE : $pgc \n" ; } ;
       &ajouteVar($pgc,$iLigneAlgo) ; $pgc  = 0 ;
  } ; # fin de si variable  ajouter

  if ($dbg_Tc==1)  { print " relance gauche : '$pgc' \n" ; } ;

  if ($pgc =~ m/[$ldmdCop]/) { &testeCondition($pgc) ; } else { &testeUneSeuleExpression($pgc) ; }  ;

  # ignorons les constantes pour pdc

  if ($pdc =~ m/^[0-9]+$/) { $pdc = 0 ; } ;

  # et les variables

  $var = ($pdc  =~ $main::masqI) ;
  if ($var>0) {
       if ($dbg_Tc==1) { print "\n\n  AJOUT  DE LA VARIABLE : $pdc \n" ; } ;
       &ajouteVar($pdc,$iLigneAlgo) ; $pdc  = "" ; return ;
  } ; # fin de si variable  ajouter

  if ($dbg_Tc==1)  { print " relance droite : '$pdc' \n" ; } ;

  if ($pdc =~  m/[$ldmdCop]/) { &testeCondition($pdc) ; } else { &testeUneSeuleExpression($pdc) ; } ;

} ; # fin sub testeCondition

###########################################################################

sub preTraiteCond  {   my $dbg_Pret = 0 ; # mettre 1 pour debug, 0 en mode normal

  my $coat  = $_[0] ;


  if ($dbg_Pret==1) { print "pr-traitement de '$coat' \n" ; } ;

  $coat =~ s/ ou / : /g ;  # 'ou' ar
  $coat =~ s/\)ou/\):/g ;  # 'ou' avec parenthse  gauche
  $coat =~ s/ou\(/:\(/g ;  # 'ou' avec parenthse  droite

  $coat =~ s/ et / ; /g ;
  $coat =~ s/\)et/\);/g ;
  $coat =~ s/et\(/;\(/g ;

  $coat =~ s/non / ~ /g  ;
  $coat =~ s/non / ~ /g  ;
  $coat =~ s/\(non/\(~/g ;
  $coat =~ s/non\(/~\(/g ;

  $coat =~ s/<=/ { /g ;
  $coat =~ s/>=/ } /g ;
  $coat =~ s/<>/ ! /g ;

  # maintenant, on peut arer

  $coat =~ s/=/ = /g ;
  $coat =~ s/>/ > /g ;
  $coat =~ s/</ < /g ;
  $coat =~ s/:/ : /g ;
  $coat =~ s/;/ ; /g ;
  $coat =~ s/!/ ! /g ;
  $coat =~ s/{/ { /g ;
  $coat =~ s/}/ } /g ;

  if ($dbg_Pret==1) { print "fin de pr-traitement : '$coat' \n" ; } ;

  return $coat ;

} ; # fin sub preTraiteCond

###########################################################################

sub decoupePour  { my $dbg_Decp = 0 ; # mettre 1 pour debug, 0 en mode normal

  $expP  = $_[0] ;

  if ($dbg_Decp==1) { print " dcoupe de '$expP' \n" ; } ;
  ($pmP,$rdpP) = &premierEtReste($expP) ;
  if ($dbg_Decp==1) { print " mot un : $pmP\n" ; } ;
  if (" ".uc($pmP)." " ne " DE ") { &galgerr::erreur("051") ; return (0,0) ; } else {
     $rdpP = " ".$rdpP." " ;
     if ($dbg_Decp==1) { print " aprs mot un : '".uc($rdpP)."'\n" ; } ;
     $idea = index(maju($rdpP)," A ") ;
     if ($idea==-1) { &galgerr::erreur("052") ; return (0,0) ; } else {
        #  cause de " A " et non pas "A" indices $idea et $idea+2
        $pavA = &sansEspaceDebutEtFin(substr($rdpP,0,$idea)) ;
        $papA = &sansEspaceDebutEtFin(substr($rdpP,$idea+2)) ;
        if ($dbg_Decp==1) { print " avant A : $pavA\n" ; } ;
        if ($dbg_Decp==1) { print " aprs A : $papA\n" ; } ;
        if    (&chaineVide($pavA)==1) { &galgerr::erreur("022") ; return (0,0) ; }
        elsif (&chaineVide($papA)==1) { &galgerr::erreur("023") ; return (0,0) ; } else {
              return ($pavA,$papA) ;
        } ; # fin de si mot avant ou apres vide
     } ; # fin de si mot A non vu
  } ; # fin de si mot DE non vu

  return (0,0) ;

} ; # fin sub decoupePour

###########################################################################

sub oteFonctions { my $dbg_Otef = 0 ; # mettre 1 pour debug, 0 en mode normal

  # on remplace toute expression (..) par 12, toute f(...) par f12
  # il faut faire attention  l'emboitement des parenthses...

  my $chav  = $_[0] ;
  if ($dbg_Otef==1) { print " oteFonctions de $chav \n" ; } ;
  my $chap  = "" ;
  my $ldk   = length($chav) ;
  my $ldc   = "" ;
  my $karc  = "" ;
  my $nbp   = 0  ;
  my $idk   = 0  ;

  while ($idk<=$ldk) {
          $karc = substr($chav,$idk,1) ;
          if ($dbg_Otef==1) { print " idk $idk karc $karc \n" ; } ;
          if ($karc eq "(") { $nbp++; $chap .= 1 } ;
          if ($nbp==0)  { $chap .= $karc ; } ;
          if ($karc eq ")") { $nbp--;  $chap .= 2 ; } ;
          if ($dbg_Otef==1) { print " soit, pour idk $idk : $chap \n" ; } ;
          $idk++ ;
  } ; # fin tant que

  return $chap ;

} ; # fin sub oteFonctions

###########################################################################

sub oteTableaux { my $dbg_Otet = 0 ; # mettre 1 pour debug, 0 en mode normal

  # on remplace toute expression t[ .. ] par t3

  my $chav  = $_[0] ;
  if ($dbg_Otet==1) { print " oteTableaux  de $chav \n" ; } ;
  my $chap  = "" ;
  my $ldk   = length($chav) ;
  my $ldc   = "" ;
  my $karc  = "" ;
  my $nbp   = 0  ;
  my $idk   = 0  ;

  while ($idk<=$ldk) {
          $karc = substr($chav,$idk,1) ;
  if ($dbg_Otet==1) { print " idk $idk karc $karc \n" ; } ;
          if ($karc eq "[") { $nbp++; $chap .= 1 } ;
          if ($nbp==0)  { $chap .= $karc ; } ;
          if ($karc eq "]") { $nbp--;  $chap .= 2 ; } ;
  if ($dbg_Otet==1) { print " soit, pour idk $idk : $chap \n" ; } ;
          $idk++ ;
  } ; # fin tant que

  return $chap ;


} ; # fin sub oteTableaux

###########################################################################

sub aereParentheses {

 $entre = $_[0] ;
 $entre =~ s/\(/\( /g ;
 $entre =~ s/\)/\) /g ;
 return $entre ;

} ; # fin sub aereParentheses

###########################################################################

sub aereVirgules {

    $entre = $_[0] ;
    $entre =~ s/,/ , /g ;
    return $entre ;

} ; # fin sub aereVirgules

###########################################################################

sub aereCrochets {

    $entre = $_[0] ;
    $entre =~ s/\[/ \[ /g ;
    $entre =~ s/\]/ \] /g ;
    return $entre ;

} ; # fin sub aereCrochets

###########################################################################

sub gereTableau  { my $dbg_Gta = 0 ; # 0 en mode normal, 1 pour debug

  # on remplace t[ i ] par 1 et t[ i ; j ; k ] par 1 ???
  # on ajoute au passage le nom du tableau et des variables
  #

my  $expT = $_[0] ;

if ($dbg_Gta==1) { print " appel de gereTableau, parms =  $expT \n" ; } ;

    # on vrifie qu'on a bien juste qque chose comme t[i]
    # puis on appelle la procdure "gereTableau" qui s'occupe de tout !

     my $lavar = &sansEspaceDebutEtFin($expT) ;
     my $sat   = $lavar ;
     my $alc   = "" ; # avant les crochets
     my $dlc   = "" ; # dans les crochets
     my $plc   = "" ; # apres les crochets

     my $ldl = length($expT) ; # longueur de l'expression
     my $ndc = 0 ;             # numro de caractres courant
     my $prt = 0 ;             # nb de parenthses
     my $cro = 0 ;             # nb de crochets
     my $lek = "?" ;           # caractre courant
     my $pge = "" ;            # partie gauche de l'expression
     my $pde = "" ;            # partie droite de l'expression
     my $opv = 0  ;            # oprateur vu pour choisir $pge ou $pde

     # dcoupage en alc, dlc, plc

     while ($ndc<$ldl) {
         $lek = substr($expT,$ndc,1) ;
         if ($lek eq "[") { $cro++ ; } ;
         if    ( ($cro==0) and ($opv==0) ) { $alc .= $lek ; }
         elsif ( ($cro==0) and ($opv==1) ) { $plc .= $lek ; }
         else  { $dlc .= $lek ; } ;
         if ( ($lek eq "[") and ($prt==0) and ($cro==1) ) {
           $opv  = 1 ;
         } ; # fin de si oprateur principal vu
         if ($lek eq "]") { $cro-- ; } ;
         $ndc++ ;
     } ; # fin tant que sur $ndc

     if ($dbg_Gta==1) {
         print "   AVANT         : $alc\n" ;
         print "   DANS          : $dlc\n" ;
         print "   APRES         : $plc\n" ;
     } ; # fin de debug

     $alc = &sansEspaceDebutEtFin($alc) ;
     $dlc = &sansEspaceDebutEtFin($dlc) ;
     $plc = &sansEspaceDebutEtFin($plc) ;

     &testeCrochetage($dlc) ;

  if ($dbg_Gta==1) { print "     RTC : '$dlc' \n\n" ; } ;

  # limination ventuelle des crochets externes si chaine bien quilibre

  if ($dbg_Gta==1) { print "     AVEC CRO : '$dlc' \n\n" ; } ;
  if ( (substr($dlc,0,1) eq "[")  and (substr($dlc,-1,1) eq "]") )  {
    my $ndsdp = 0 ; # nb de symboles de parenthses
    my $ldl  = length($dlc) ; # longueur de l'expression
    my $ndc  = 0 ;             # numro de caractres courant
    my $ndpo = 0 ;             # nb d'oprateurs de comparaison
    while ($ndc<$ldl) {
      $lek = substr($dlc,$ndc,1) ;
      if ($lek eq "[") { $ndsdp++ ; } ;
      if ($lek eq "]") { $ndsdp++ ; } ;
      if (index($ldmdCop,$lek)>-1) { $ndpo++ ; } ;
      $ndc++ ;
    } ; # fin tant que sur $ndc
    if ( ($ndsdp==2) or ($ndpo<=1) ) { $dlc = substr($dlc,1,$ldl-2) ; } ;
    if ($dbg_Gta==1) { print "     SANS CRO : $dlc \n\n" ; } ;
  } ; # fin d'limination ventuelle des crochets externes

     if ($dbg_Gta==1) {
          print "   avant les crochets  :      $alc  \n" ;
          print "   dans  les crochets  :      $dlc  \n" ;
          print "   apres les crochets  :      $plc  \n" ;
     } ; # fin de debug

     # avant les crochets, un identificateur valide

     if ($alc !~ $main::masqI) { &galgerr::erreur("044") ; $lavar = "" ; $rdp = ""
     } else { &ajouteTableau($alc,$iLigneAlgo) ; } ;

     # dans les crochets, une expression non vide, non parenthse, non crochete

      $dlc = &oteChainesCst($dlc) ;

      if (index($dlc,"[")>-1)                  { &galgerr::erreur("041") ; $lavar = "" ; $rdp = "" ; } ;
      if (index($dlc,"]")>-1)                  { &galgerr::erreur("041") ; $lavar = "" ; $rdp = "" ; } ;
      if ($dlc =~ m/[A-Za-z][A-Za-z_0-9]*\(/)  { &galgerr::erreur("042") ; $lavar = "" ; $rdp = "" ; } ;
      if (&chaineVide($dlc)==1)                { &galgerr::erreur("043") ; $lavar = "" ; $rdp = "" ; } ;

      # tout va bien, il ne reste plus qu' grer la liste d'expressions
      # dans les crochets

      &gereListeExpressions($dlc) ;

      # rien aprs les crochets

      if (&chaineVide($plc)==0)               { &galgerr::erreur("044") ; $lavar = "" ; $rdp = "" } ;

      # finalement, on gre les dimensions du tableau

      my $nbDim = 0 ;
      $nbDim = &gereListeExpressions($dlc) ;
      if ($dbg_Gta==1) { print " DONC POUR  $dlc ON PROPOSE DIMENSIONS $nbDim \n" ;  } ;
      &proposeDimension($alc,$nbDim) ;

      return 34 ;

} ; # fin sub gereTableau

###########################################################################
###########################################################################

sub formateLigne  { my $dbg_FormateLigne = 0 ; # mettre 0 pour mode normal, 1 pour debug

   if ($dbg_FormateLigne == 1) {
       print " on met en forme : $iLigneAlgo -- $nbIns -- $insNf \n" ;
       print "                               -- '$laligne' \n" ;
   } ; # fin de si mode debug

   $f_ili = sprintf("%03d",$iLigneAlgo) ;
   if ($nbIns == 0) { $f_nbi = "   " ; } else { $f_nbi = sprintf("%03d",$nbIns) ; } ;
   $f_npr = sprintf("%03d",$insNf) ;

   # en cas de ligne rduite  un commentaire, pas d'affichage d'instruction

   if (&sansEspaceDebutEtFin( &sansCmt($laligne) ) eq "" ) {
      $f_nbi = "   " ;
      $f_npr = "   " ;
      $mu    = "#" ;
   } ; # fin de si commentaire pur

   # pour rendre plus lisible l'affichage, on omet
   # la valeur 000 pour la profondeur 0

   if ($f_npr eq "000") { $f_npr = "   " ; } ;

   $ligneSor = " $main::f_err  $f_ili  |  $f_nbi $f_npr  $laligne";
   if ($main::c_err ne "   ") { print FLST "\n" ; } ;
   print FLST " $ligneSor\n" ;

   if ($main::c_err ne "   ") { print "\n" ; } ;
   print " $ligneSor\n" ;

   # en cas d'erreur, on affiche le message d'erreur correspondant

   if ($main::c_err ne "   ") {
     $ligneErr = "     ERREUR $main::c_err : ".&maju($main::ce[$main::c_err]) ;
     print FLST "$ligneErr\n" ;
     print " $ligneErr\n" ;
     if ($main::c_err ne "   ") { print "\n" ; } ;
     print FLST "\n" ;

     # prparation de la ligne d'erreur en deux morceaux :
     #  1 - ligne de l'algorithme incrimine
     #  2 - rappel du message d'erreur correspondant

     my $ligErr  = "" ;
        $ligErr .= "    Ligne $f_ili : ".&sansEspaceAuDebut($laligne)."\n" ;
        $ligErr .= (" " x 15)." CODE ERREUR ".$main::c_err." --".&maju($main::ce[$main::c_err])."\n" ;
     $main::tabErr[$main::nbErreurs] = $ligErr ;

   } ; # fin si

} ; # fin sub formateLigne

###########################################################################
###########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :
1 ;
