#  (gH)   --  galgfncs.pm  ;  TimeStamp (unix) : 27 Juillet 01 19:37
#                                                                            #
##############################################################################
#                                                                            #
#                                                                            #
#                                                                            #
#                                 Gilles.HUNAULT@univ-angers.fr              #
#                                 http://www.info.univ-angers.fr/pub/gh/     #
#                                                                            #
#                                                                            #
#                                                                            #
#                                                                            #
# " Quelques fonctions PERL sur chaines de caractres "                      #
# " utiles pour le programme galg.pl "                                       #
#                                                                            #
#                                                                            #
##############################################################################
#                                                                            #
# 1. peut s'utiliser par                                                     #
#                                                                            #
#         use galgfncs ;                                                     #
#                                                                            #
#    si le module est dans le rpertoire courant                             #
#                                                                            #
##############################################################################
#                                                                            #
# 2. peut s'utiliser par                                                     #
#                                                                            #
#         use lib "/usr/local/bin/scriptsPerl/" ;                            #
#         use galgfncs ;                                                     #
#                                                                            #
#    si le module est dans le rpertoire /usr/local/bin/scriptsPerl/         #
#                                                                            #
##############################################################################
#                                                                            #
# 3. peut s'utiliser par                                                     #
#                                                                            #
#         use lib $ENV{"PERL_MACROS"} ;                                      #
#         use galgfncs ;                                                     #
#                                                                            #
#    si le module est dans le rpertoire indiqu par la variable             #
#    d'environnement PERL_MACROS, par exemple :                              #
#                                                                            #
#         export PERL_MACROS=/usr/local/bin/scriptsPerl/                     #
#                (pour bash, sous Linux)                                     #
#         set PERL_MACROS=C:\Scripts\Perl\                                   #
#                (sous Dos/Windows)                                          #
#                                                                            #
#                                                                            #
##############################################################################

 package  galgfncs ;
 require  Exporter ;
 @ISA     = qw(Exporter) ;

@EXPORT  = (<<"FIN_DE_LA_LISTE_DES_FONCTIONS" =~ m/^\s*(.+)/xgm) ;
   attends
   avantDernierMot
   chaineVide
   Cmt
   dernierMot
   galgcpy
   gereLeTemps
   IndentEtReste
   maju
   mot
   nbMots
   nomFichierSansExtension
   oteChainesCst
   phraseSansPremierMot
   PosMotDsPhraz
   premierEtReste
   premierMot
   sansCmt
   sansEspaceAuDebut
   sansEspaceDebutEtFin
   sansEspaceEnFin
   testeCrochetage
   testeGuillemets
   testeParenthesage
FIN_DE_LA_LISTE_DES_FONCTIONS

# la fonction initialeMajuscule n'est pas une erreur
# ( cause de ucfirst, /i et \u en perl) mais une
# volont de "nettoyer" la chaine et de traduire en
# franais les caractres accentus.

################################################################################

sub attends { # affiche ok  l'cran et attends une rponse de l'utilisateur

    print STDERR " ok ? " ;
    chop (my $repgh = <STDIN>);
    if (length($repgh)>0) { exit -1 } ;
    return ;

} ; # fin de sub attends

################################################################################

sub avantDernierMot { # renvoie l'avant-dernier mot d'une chaine
                      # le seul sparateur est l'espace.

    my $phr = $_[0] ;
    my @mt  = split(" ",$phr) ;
    my $adm = "" ;
    if (&nbMots($phr)>2) { $adm  = $mt[ -1 + $#mt ] ; }
    return $adm ;

} ; # sub avantDernierMot {

################################################################################

sub chaineVide { # renvoie 1 si la chaine est vide ou ne contient
                 # que des espaces, 0 sinon

  if (length(&sansEspaceDebutEtFin($_[0]))>0)  { return 0 ;
  } else { return 1 ; } ;

} ; # fin de sub chaineVide

################################################################################


sub Cmt { # retourne le CoMmenTaire d'une ligne passe en paramtre
          # le commentaire est aprs le symbole "#"

  my $LCourante ; # Ligne COURANTE
  my $PosCom    ; # POSition du COMmentaire

  $LCourante=$_[0];
  $PosCom=index($LCourante, "#");
  if ($PosCom != -1) {
    substr($LCourante, 0, $PosCom+1)="";
  } else {
    $LCourante="";
  } ; # Fin_Si il y a un commentaire

  return($LCourante);

} ; # fin de sub Cmt

################################################################################

sub dernierMot { # renvoie le dernier mot d'une chaine
                 # le seul sparateur est l'espace.

    my $phr = $_[0] ;
    my @mt  = split(" ",$phr) ;
    my $mu  = $mt[$#mt] ;
    if ($ghDbg) { print STDERR " mot  x  : -- $mu  -- \n"; } ;
    return $mu ;

} ; # sub dernierMot {

################################################################################

sub galgcpy  {

 print "\n" ;
 print " Copyright  2001  - email : gilles.hunault\@univ-angers.fr \n" ;
 print "                    http://www.info.univ-angers.fr/pub/gh/ \n\n" ;
 print " Documentation      http://www.info.univ-angers.fr/pub/gh/Galg.htm\n" ;
 print "\n" ;

} ; # fin de sub galgcpy

################################################################################

sub gereLeTemps { # prsente proprement la date et l'heure courante

   ($sec,$min,$hour,$mday,$mmon,$year,$jda)=localtime();
   $mmon = $mmon + 1 ;
   $year = $year + 1900 ;
   if (length($sec)<2)  { $sec = "0$sec" } ;
   if (length($mday)<2) { $mday = "0$mday" } ;
   if (length($mmon)<2) { $mmon = "0$mmon" } ;

   return "$mday/$mmon/$year $hour:$min.$sec" ;

} ; # fin de sub gereLeTemps

################################################################################

sub IndentEtReste { # retourne le couple form de l'INDENTation ET du RESTE de la ligne

  my $LCourante; # Ligne COURANTE
  my $Indent; # INDENTation
  my $Reste; # RESTE de la ligne
  my $CarCour; # CARactre COURant
  my $NbEsp; # NomBre d'ESPaces
  my $NbTabu; # NomBre de TABUlations

  $LCourante=$_[0];

  $CarCour=0;
  $NbIndent=0;
  $NbTabu=0;
  while ((substr($LCourante, $CarCour, 1) eq " ") or (substr($LCourante, $CarCour, 1) eq "\t")) {
    if (substr($LCourante, $CarCour, 1) eq " ") {
      $NbEsp++;
    }; # Fin_Si le caractre est un espace
    if (substr($LCourante, $CarCour, 1) eq "\t") {
      $NbTabu++;
    }; # Fin_Si le caractre est une tabulation
    $CarCour++;
  }; # Fin_Tant_Que le caractre courant est un espace ou une tabulation
  $Indent=("\t" x $NbTabu).(" " x $NbEsp); # Important : NbTabu avant NbEsp
  $Reste=substr($LCourante, $NbIndent+$NbTabu);

  return($Indent, $Reste);

} ; # fin de sub IndentEtReste
################################################################################

sub maju {

# le sous-programme maju passe en majuscules  en mode "franais" ;
# contrairement  uc, il gre les accents
# (sans passer par les LOCALE)


  $ligneAvant =  $_[0] ;
  $ligneApres =  uc($ligneAvant) ;
  $ligneApres =~ s//A/g ;
  $ligneApres =~ s//A/g ;
  $ligneApres =~ s//C/g ;
  $ligneApres =~ s//E/g ;
  $ligneApres =~ s//E/g ;
  $ligneApres =~ s//E/g ;
  $ligneApres =~ s//I/g ;
  $ligneApres =~ s//O/g ;
  $ligneApres =~ s//U/g ;

  return $ligneApres ;

} ; # fin de sub maju

################################################################################

sub mot { # Retourne le MOT n dans la PHRAse ; seul sparateur : l'espace

  my @TPhraz;
  @TPhraz=split(" ", $_[0]);
  return $TPhraz[$_[1]-1];

} ; # fin de sub mot

################################################################################

sub nbMots { # renvoie le nombre de mots ; spareteur : espace et virgule

my $nbesp ; # nombre d'espaces

my $entre   =  $_[0]  ;
   $entree  =  $_[0]  ;
   $entree  =~ s/,/ /g ;               # remplaces les virgules par des blancs
   $entree  =~ s/^ //g ;               # supression des blancs de tete
   $entree  =~ s/ $//g ;               # supression des blancs de queue
   while ($entree  =~ s/  / /g) { } ;
   if (length($entree)==0) { $nbesp = 0 ; } else {
      $nbesp  = 1 + ($entree =~ s/ /*/g) ;
   } ; # fin de si
   return $nbesp ;

} ; # fin de sub nbMots

################################################################################

sub nomFichierSansExtension {

# le sous-programme nomFichierSansExtension renvoie le dbut de la
# chaine jusqu'au dernier point rencontr ;
# ainsi pour le nom de fichier essai.quatre.alg on renvoie essai.quatre.

my $nomF    =  $_[0] ;
my $dpdp    =  rindex($nomF,".") ;
my $nNom    =  substr($nomF,0,$dpdp) ;
   return $nNom ;

} ; # sub nomFichierSansExtension

################################################################################

sub oteChainesCst  { # on remplace les expressions entre guillements par 0

  $chen  = $_[0] ;

  my $idc = 0 ;
  my $ldc = length($chen) ;
  my $gui = 0 ;
  my $nChen = "" ;
  while ($idc<=$ldc) {
    $carc = substr($chen,$idc,1) ;
    if    ( ($carc eq "\"") and ($gui==0) ) { $gui++ ; }
    elsif ( ($carc eq "\"") and ($gui==1) ) { $carc = " 0 " ; $gui-- ; } ;
    if ($gui==0) { $nChen .= $carc ; } ;
    $idc++ ;
  } ; # fin de tant que non fin de chaine

  return $nChen ;

} ; # fin de sub oteChainesCst

###########################################################################

sub phraseSansPremierMot {

    my $phr = $_[0] ;
    my @mt  = split(" ",$phr) ;
    $mt[0] = "" ;
    my $mu  = join(" ",@mt) ;
    if ($ghDbg) { print STDERR " sans 1  : -- $mu  -- \n"; } ;
    return $mu ;

} ; # fin de sub phraseSansPremierMot

################################################################################

sub PosMotDsPhraz {

# retourne la POSition d'un MOT DanS une PHRAse
# si le MOT n'appartient pas  la PHRAse, la valeur retourne est -1
  my @TPhraz;
  my $Mot;
  my $PosMot;
  my $nbMots ;
  my $indMot ;

  $Mot=$_[0];
  @TPhraz=split(" ", $_[1]);
  $PosMot=-1;
  my $nbMots=$#TPhraz;
  $indMot = 0 ;

  while ($indMot <=$nbMots) {
    if ($Mot eq $TPhraz[$indMot]) {
        $PosMot = 1 + $indMot ;
        $indMot = $nbMots + 1 ;
    } ;
    $indMot++ ;
  }; # Fin_Tant_Que le mot n'est pas prsent

  return $PosMot;

} ; # fin de sub PosMotDsPhraz

################################################################################

sub premierEtReste { # dcompose en premier mot et reste de la phrase
                     # le mot est repr uniquement par le caractre espace
    my $phr = &sansEspaceAuDebut($_[0]) ;
    my $ide = index($phr," ") ;
    if ($ide>-1) { ($pm,$re) = (substr($phr,0,$ide) , substr($phr,$ide+1) ) ; }
           else  { ($pm,$re) = ($phr                , ""                  ) ; }
    return ($pm,$re) ;

} ; # sub premierEtReste

################################################################################

sub premierMot {
    my $phr = $_[0] ;
    my @mt  = split(" ",$phr) ;
    my $mu  = $mt[0] ;
    return $mu ;
} ; # sub premierMot {

################################################################################

sub sansCmt  {

  $ligneAvant = $_[0] ;
  $ligneApres = $ligneAvant ;
  $posDiese = index($ligneAvant,"#") ;
  if ($posDiese>-1) { $ligneApres = substr($ligneAvant,0,$posDiese) ; } ;

  return $ligneApres ;

} ; # fin de sub sansCmt

################################################################################

sub sansEspaceAuDebut {

my $entre   =  $_[0]  ;
   while ($entre   =~ s/^ //g) { }  ;
   return $entre ;

} ; # fin de sub sansEspaceAuDebut

################################################################################

sub sansEspaceDebutEtFin {

my $entre   =  $_[0]  ;
   $entre   =  &sansEspaceAuDebut($entre) ;
   $entre   =  &sansEspaceEnFin($entre) ;
   return $entre ;

} ; # fin de sub sansEspaceDebutEtFin

################################################################################

sub sansEspaceEnFin {

my $entre   =  $_[0]  ;
   while ($entre   =~ s/ $//g) { }  ;
   return $entre ;

} ; # fin de sub sansEspaceEnFin

################################################################################

sub testeCrochetage {

  my $eet = $_[0] ;
  my $rdt = 0 ;
  my $idc = 0 ;
  my $cp  = 0 ; # compte crochets
  my $rdp = 0 ;
  my $rdf = 0 ;
  my $len = length($eet) ;

  while ($idc<$len) {
    $carc = substr($eet,$idc,1) ;
    if ($carc eq "[") { $cp++ ; } ;
    if ($cp>1) { $rdp = 1 } ;
    if ($carc eq "(") { $rdf = 1 ; } ;
    if ($carc eq "]") { $cp-- ; } ;
    if ($cp<0) { # erreur !
       $idc = $len + 1 ;
    } ; # fin de si erreur sur crochets
    $idc++;
  } ; # fin tant que sur idc

  if ($cp==0) { $rdt = 0 ; } else { $rdt = 1 ; } ;
  if ($rdt==1) { &galgerr::erreur("027") ; } ;
  if ($rdp==1) { &galgerr::erreur("041") ; $rdt =1 } ;
  if ( ($rdf==1) and ($cp>0)) { &galgerr::erreur("042") ; $rdt =1 } ;

  return $rdt ;

} ; # fin de sub testeCrochetage

###########################################################################

sub testeGuillemets {

# contrairement aux crochets et aux parenthses, on ne teste que
# la parit du nombre de symboles guillemets

  my  $eet = $_[0] ;
  my  $nbg = ($eet =~ s/"//g ) ;

  if (($nbg %2)==0) { $rdt = 0 ; } else { $rdt = 1 ; } ;
  if ($rdt==1) { &galgerr::erreur("026") } ;

  return $rdt ;

} ; # fin de sub testeGuillemets

###########################################################################

sub testeParenthesage {

  my  $eet = $_[0] ;

  $rdt = 0 ;
  $eet =~ s/[A-Z_a-z0-9 =\+\*-\/]//g ;
  $idc = 0 ;
  $cp  = 0 ; # compte parenthses
  $len = length($eet) ;
  while ($idc<$len) {
    $carc = substr($eet,$idc,1) ;
    if ($carc eq "(") { $cp++ ; } ;
    if ($cp>2) { &galgerr::erreur("038") ; } ;
    if ($carc eq ")") { $cp-- ; } ;
    if ($cp<0) { # erreur !
       $idc = $len + 1 ;
    } ; # fin de si
    $idc++;
  } ; # fin tant que

  if ($cp==0) { $rdt = 0 ; } else { $rdt = 1 ; } ;
  if ($rdt==1) { &galgerr::erreur("018") } ;

  return $rdt ;

} ; # fin de sub testeParenthesage

###########################################################################
###########################################################################


# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;

##################################### fin du fichier galgfncs.pm ##########
