#  (gH)   --  galglang.pm  ;  TimeStamp (unix) : 14 Septembre 01 09:12
#
###########################################################################

# Dclarations du package

package galglang ;

use lib $ENV{"PERL_MACROS"} ; # rpertoire des modules perl personnels

use galgfncs ; # Bibliothque de fonctions utiles sur chaines

require Exporter;
@ISA=('Exporter');
@EXPORT=(postComparaison , postTraduction) ;

#########################################################################################
#########################################################################################


#########################################################################################
##                                                                                      #
##      sous-programmes gnraux pour la configuration des langages                     #
##                                                                                      #
#########################################################################################


sub initNomLangages {

# les tableaux tabLang, cmdLang et extLang sont globaux
#     tabLang donne le nom du langage
#     cmdLang donne la commande  utiliser pour le langage
#     extLang donne l'extension du fichier dans le langage

  $main::tabLang{"c"}        = " C    (norme ansi) " ;
  $main::cmdLang{"c"}        = " pc " ;
  $main::extLang{"c"}        = ".c" ;

  $main::tabLang{"cpp"}      = " C++  " ;
  $main::cmdLang{"cpp"}      = " ppc " ;
  $main::extLang{"cpp"}      = ".cpp" ;

  $main::tabLang{"dbase"}    = " Dbase (version Max20) " ;
  $main::cmdLang{"dbase"}    = " db " ;
  $main::extLang{"dbase"}    = ".prg" ;

  $main::tabLang{"java"}     = " Java " ;
  $main::cmdLang{"java"}     = " ja " ;
  $main::extLang{"java"}     = ".java" ;

  $main::tabLang{"pascal"}   = " Pascal (version ppc386) " ;
  $main::cmdLang{"pascal"}   = " pa " ;
  $main::extLang{"pascal"}   = ".pas" ;

  $main::tabLang{"perl"}     = " Perl 5 " ;
  $main::cmdLang{"perl"}     = " perl -W " ;
  $main::extLang{"perl"}     = ".pl" ;

  $main::tabLang{"rexx"}     = " Rexx (implmentation : regina 2.0) " ;
  $main::cmdLang{"rexx"}     = " regina  " ;
  $main::extLang{"rexx"}     = ".rex" ;

  $main::tabLang{"tcl"}      = " tcl (version 8.0)" ;
  $main::cmdLang{"tcl"}      = " tcl  " ;
  $main::extLang{"tcl"}      = ".tcl" ;

} ; # fin sub initLangages


###################################################################################################


sub listeLangages { # le tableau tabLang est global et dfini par le sous-programme initNomLangages

  print "\n" ;
  print " Valeurs du paramtre de l'option -o, langages et commandes associes \n\n" ;
  my $noml ; # nom courant du langage

  print "   Paramtre           Langage                                      Commande\n" ;
  print "   ---------           -------                                      --------\n" ;
  for $noml (sort keys %main::tabLang) {
    printf("       %-9s",$noml) ;
    printf("       %-41s",$main::tabLang{$noml}) ;
    printf("       %-20s",$main::cmdLang{$noml}) ;
    print "\n" ;
  } ; # fin, pour chaque langage
  print "\n" ;

} ; # fin de sub listeLangages {


###################################################################################################


sub  testeNomLangage  { my $NLang = $_[0] ;

  if ($main::tabLang{$NLang} eq "") {
    print "\n langage '$NLang' inconnu ; utiliser galg -l pour la liste des langages connnus.\n\n" ;
    exit(-1) ;
  } ; # finsi on ne connait pas le langage

} ; # fin sub testeNomLangage


###################################################################################################


sub  fonctionsDuLangage  {

  my $nomDuLangage = $_[0] ;

  if (&nbMots(&sansEspaceDebutEtFin($nomDuLangage)) == 0) {
       print "\n    ERREUR : aprs l'option -f il faut donner le nom d'un langage.\n\n" ;
       &galgcpy() ;
       exit(-1) ;
  } ; # fin si pas de nom de fichier aprs -t

  &testeNomLangage($nomDuLangage) ;
  ($nbLignesTdc,$lignesTdc_Avant,$lignesTdc_Apres)  = &{"InitTdc_".$nomDuLangage}() ;
  print "\n Table des ".sprintf("%2d",$nbLignesTdc)  ;
  print " fonctions algorithmiques reconnues par le langage $nomDuLangage :\n\n" ;


 my @lignesTdcAvant = split("",$lignesTdc_Avant) ;
 my @lignesTdcApres = split("",$lignesTdc_Apres) ;

 my  $indLignesTdc = 1 ;
 print "  " x 8 ;
 print "   ".uc(Algorithmique)."                 |     ".uc(sansEspaceDebutEtFin($nomDuLangage))."\n" ;
 print " " x 48 ;
 print " | \n" ;
# print "         1         2         3         4         5\n" ;
# print "123456789012345678901234567890123456789012345678901234567890\n" ;
 while ($indLignesTdc<=$nbLignesTdc) {
      print "     ".sprintf("%2d",$indLignesTdc)."  / ".sprintf("%2d",$nbLignesTdc)."  :  " ;
      my ($chAvant,$chApres) = ($lignesTdcAvant[$indLignesTdc],$lignesTdcApres[$indLignesTdc]) ;
      $chAvant = &sansEspaceDebutEtFin($chAvant) ;
      $chApres = &sansEspaceDebutEtFin($chApres) ;
#      $chAvant =~ s/\(/\\\(/g ;
#      $chAvant =~ s/\)/\\\)/g ;
      $chAvant =~ s/\[//g ;
      $chAvant =~ s/\\//g ;
      if ((substr($chAvant,-1,1) ne "\(") and (substr($chAvant,-1,1) ne "\)")) { $chAvant .= "\(" ; } ;
      if (substr($chAvant,-1,1) eq "\(") { $chAvant .= "\)" ; } ;
      if (substr($chApres,-1,1) eq "\(") { $chApres .= "\)" ; } ;
      if (substr($chApres,0,1)  eq "[")  { $chApres .= "]" ; } ;
      print " ".sprintf("%-23s",$chAvant) ;
      print "       |     $chApres \n" ;
      $indLignesTdc++ ;
 } ; # fin tant que sur les rgles de correspondance

} ; # fin sub fonctionsDuLangage


###################################################################################################
###################################################################################################

#########################################################################################
##                                                                                      #
##      sous-programme       post-Traduction                                            #
##                                                                                      #
#########################################################################################

sub  postTraduction  {  my $dbg_PostTrad = 0 ; # mettre 0 en mode normal, 1 pour debug

  my $nomFichierProg    = $_[0] ;
  my $nomDuLangage      = $_[1] ;
  open(FPRG,"<$nomFichierProg") or die ("          Erreur ! Impossible de lire dans $nomFichierProg\n\n") ;

  # on met le fichier programme en mmoire dans le tableau local lignesProg

  my @lignesProg ;
  my $nbLignesProg = 0 ;
  while (<FPRG>) {
    $nbLignesProg++ ;
    chop($ligneProg=$_) ;
    if ($dbg_Postc == 1) { print "PRG == $nbLignesProg : $ligneProg\n" ; } ;
    $lignesProg[$nbLignesProg] = $ligneProg ;
  } ; # fin tant que on lit sur le fichier programme
  close(FPRG) ;

  # choix dynamique de la table de correspondance

  ($nbLignesTdc,$lignesTdc_Avant,$lignesTdc_Apres) = &{"galglang::InitTdc_".$nomDuLangage}() ;
  my @lignesTdcAvant = split("",$lignesTdc_Avant) ;
  my @lignesTdcApres = split("",$lignesTdc_Apres) ;

  # on peut donc maitenant modifier chaque ligne du programme
  # terme  terme

  open(FPRG,">$nomFichierProg") or die ("          Erreur ! Impossible d'crire dans $nomFichierProg\n\n") ;

  my $indLignesProg = 1 ;
  while ($indLignesProg<=$nbLignesProg) {
    my $ligneProg = $lignesProg[$indLignesProg] ;
    if ($dbg_PostTrad == 1) { print " avant : $ligneProg\n"   ; }
    $indLignesTdc = 1 ;
    while ($indLignesTdc<=$nbLignesTdc) {
      if ($dbg_PostTrad == 1) { print "       $indLignesTdc / $nbLignesTdc  : " ; } ;
      my ($chAvant,$chApres) = ($lignesTdcAvant[$indLignesTdc],$lignesTdcApres[$indLignesTdc]) ;
      # les caractres ( ),  [ ]  et $ doivent etre "protgs" par un \
      $chAvant =~ s/\(/\\\(/g ;
      $chAvant =~ s/\)/\\\)/g ;
#      $chAvant =~ s/\[/\\\[/g ;
#      $chAvant =~ s/\]/\\\]/g ;
      $chAvant =~ s/\$/\\\$/g ;
      if ($dbg_PostTrad == 1) { print "       $chAvant ==> $chApres \n" ; } ;
      $ligneProg =~ s/$chAvant/$chApres/xg ;
      if ($dbg_PostTrad == 1) { print "       apres $indLignesTdc : $ligneProg\n" ; } ;
      $indLignesTdc++ ;
    } ; # fin tant que sur les rgles de correspondance
    if ($dbg_PostTrad == 1) { print " apres : $ligneProg\n\n" ; } ;
    print FPRG "$ligneProg\n" ;
    $indLignesProg++ ;
  } ; # fin tant que sur les lignes du programme
  close(FPRG) ;

} ; # fin sub postTraduction


#########################################################################################
##                                                                                      #
##      sous-programme       post-Comparaison                                           #
##                                                                                      #
#########################################################################################

sub postComparaison  { my $dbg_Postc = 0 ; # 0 pour normal, 1 pour debug

  my $nomFichierProg    = $_[0] ;
  my $nomFichierTdc     = $_[1] ;

  open(FPRG,"<$nomFichierProg") or die ("          Erreur ! Impossible de lire dans $nomFichierProg\n\n") ;
  open(FTDC,"<$nomFichierTdc")  or die ("          Erreur ! Impossible de lire dans $nomFichierTdc\n\n") ;

  # on met le fichier programme en mmoire dans le tableau local lignesProg

  my @lignesProg ;
  my $nbLignesProg = 0 ;
  while (<FPRG>) {
    $nbLignesProg++ ;
    chop($ligneProg=$_) ;
    if ($dbg_Postc == 1) { print "PRG == $nbLignesProg : $ligneProg\n" ; } ;
    $lignesProg[$nbLignesProg] = $ligneProg ;
  } ; # fin tant que on lit sur le fichier programme
  close(FPRG) ;

  if ($dbg_Postc == 1) { print " \n" ; } ;

  # on met le fichier de correspondance en mmoire dans les tableaux
  # locaux lignesTdcAvant et lignesTdcApres ; format : TdcAvant[num] et TdcApres[num]
  # pour remplacer "avant" par "apres"


  my @lignesTdc ;
  my $nbLignesTdc = 0 ;
  while (<FTDC>) {
    chop($ligneTdc=$_) ;
    # on ne garde ni les lignes qui commencent par #
    # ni les lignes vides
    if (length($ligneTdc)>0) {
        my ($un,$deux) = &premierEtReste($ligneTdc) ;
        # comme la fonction premierEtReste renvoie un tableau construit par join(" ")
        # il y a des espaces en trop en dbut et en fin de $deux, d'o :

        $deux = &sansEspaceDebutEtFin($deux) ;
        if (substr("$un   ",0,1) ne "#") {
           $nbLignesTdc++ ;
           if ($dbg_Postc == 1) { print "TDC == $nbLignesTdc : $ligneTdc soit $un ==> $deux \n" ; } ;
           # les caractres ( ),  [ ]  et $ doivent etre "protgs" par un \
           $un =~ s/\(/\\\(/g ;
           $un =~ s/\)/\\\)/g ;
           $un =~ s/\[/\\\[/g ;
           $un =~ s/\]/\\\]/g ;
           $un =~ s/\$/\\\$/g ;
           $lignesTdcAvant[$nbLignesTdc] = $un ;
           $lignesTdcApres[$nbLignesTdc] = $deux ;
           if ($dbg_Postc == 0) { print "TDC == $nbLignesTdc : $ligneTdc soit *$un* ==> *$deux* \n" ; } ;
        } ; # fin de si ce n'est pas un commentaire
    } ; # fin de si ligne non vide
  } ; # fin tant que on lit sur le fichier programme
  close(FTDC) ;

  # on peut donc maitenant modifier chaque ligne du programme
  # terme  terme

  open(FPRG,">$nomFichierProg") or die ("          Erreur ! Impossible d'crire dans $nomFichierProg\n\n") ;

##  "#-#  Fichier modifi via la table de correspondance $nomFichierTdc"

  my $indLignesProg = 1 ;
  while ($indLignesProg<=$nbLignesProg) {
    my $ligneProg = $lignesProg[$indLignesProg] ;
    if ($dbg_Postc == 1) { print " avant : $ligneProg\n"   ; }
    $indLignesTdc = 1 ;
    while ($indLignesTdc<=$nbLignesTdc) {
      if ($dbg_Postc == 1) { print "       $indLignesTdc / $nbLignesTdc  : " ; } ;
      my ($chAvant,$chApres) = ($lignesTdcAvant[$indLignesTdc],$lignesTdcApres[$indLignesTdc]) ;
      if ($dbg_Postc == 1) { print "       $chAvant ==> $chApres \n" ; } ;
      $ligneProg =~ s/$chAvant/$chApres/xg ;
      if ($dbg_Postc == 1) { print "       apres $indLignesTdc : $ligneProg\n" ; } ;
      $indLignesTdc++ ;
    } ; # fin tant que sur les rgles de correspondance
    if ($dbg_Postc == 1) { print " apres : $ligneProg\n\n" ; } ;
    print FPRG "$ligneProg\n" ;
    $indLignesProg++ ;
  } ; # fin tant que sur les lignes du programme
  close(FPRG) ;

} ; # fin sub postComparaison


###################################################################################################
###################################################################################################


#########################################################################################
##                                                                                      #
##      sous-programmes   Tables de correspondances                                     #
##                                                                                      #
#########################################################################################


# le but de ces sous-programmes est de permettre une correspondance
# terme  terme lorsque'elle existe dans le langage tout en
# conservant le mot algorithmique mais prcd d'un caractre de
# soulignement


###################################################################################################
###################################################################################################


sub  InitTdc_rexx  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_codeAscii("      ;  $lignesApres[$nbCorr]  = "c2d(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_copies("         ;  $lignesApres[$nbCorr]  = "copies(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_date()"          ;  $lignesApres[$nbCorr]  = "date(\"E\")" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_entierAuHasard(" ;  $lignesApres[$nbCorr]  = "random(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_format("         ;  $lignesApres[$nbCorr]  = "format(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_heure()"         ;  $lignesApres[$nbCorr]  = "time()" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_longueur("       ;  $lignesApres[$nbCorr]  = "length(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_maju("           ;  $lignesApres[$nbCorr]  = "translate(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_max("            ;  $lignesApres[$nbCorr]  = "max(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_mot("            ;  $lignesApres[$nbCorr]  = "word(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_mots("           ;  $lignesApres[$nbCorr]  = "words(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_nbParametres("   ;  $lignesApres[$nbCorr]  = "arg(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre("      ;  $lignesApres[$nbCorr]  = "arg(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_partieEntiere("  ;  $lignesApres[$nbCorr]  = "trunc(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_sousChaine("     ;  $lignesApres[$nbCorr]  = "substr(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_valeur("         ;  $lignesApres[$nbCorr]  = "(" ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_rexx


###################################################################################################


sub  InitTdc_pascal  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_codeAscii("      ;  $lignesApres[$nbCorr]  = "ord(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_fin_de_fichier(" ;  $lignesApres[$nbCorr]  = "eof(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_longueur("       ;  $lignesApres[$nbCorr]  = "length(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_maju("           ;  $lignesApres[$nbCorr]  = "upper(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_nbParametres()"  ;  $lignesApres[$nbCorr]  = "paramcount" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre("      ;  $lignesApres[$nbCorr]  = "paramstr(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_partieEntiere("  ;  $lignesApres[$nbCorr]  = "trunc(" ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_pascal


###################################################################################################


sub  InitTdc_dbase  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_codeAscii("     ;  $lignesApres[$nbCorr]  = "asc(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_copies("        ;  $lignesApres[$nbCorr]  = "replicate(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_date()"         ;  $lignesApres[$nbCorr]  = "date(\"E\")" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_format("        ;  $lignesApres[$nbCorr]  = "str(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_heure()"        ;  $lignesApres[$nbCorr]  = "time()" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_longueur("      ;  $lignesApres[$nbCorr]  = "len(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_maju("          ;  $lignesApres[$nbCorr]  = "upper(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_nbParametres("  ;  $lignesApres[$nbCorr]  = "pcount(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre( 1 )" ;  $lignesApres[$nbCorr]  = "parametre1" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre( 2 )" ;  $lignesApres[$nbCorr]  = "parametre2" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre( 3 )" ;  $lignesApres[$nbCorr]  = "parametre3" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre( 4 )" ;  $lignesApres[$nbCorr]  = "parametre4" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre( 5 )" ;  $lignesApres[$nbCorr]  = "parametre5" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_partieEntiere(" ;  $lignesApres[$nbCorr]  = "int(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_sousChaine("    ;  $lignesApres[$nbCorr]  = "substr(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_valeur("        ;  $lignesApres[$nbCorr]  = "val(" ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_dbase


###################################################################################################


sub  InitTdc_perl  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_codeAscii("     ;  $lignesApres[$nbCorr]  = "ord(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_longueur("      ;  $lignesApres[$nbCorr]  = "length(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_maju("          ;  $lignesApres[$nbCorr]  = "uc(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_partieEntiere(" ;  $lignesApres[$nbCorr]  = "int(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_valeur("        ;  $lignesApres[$nbCorr]  = "(" ;

#  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_nbParametres("  ;  $lignesApres[$nbCorr]  = "&nbParametres(" ;
#  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_parametre("     ;  $lignesApres[$nbCorr]  = "&parametre(" ;
#  $nbCorr++ ; $lignesAvant[$nbCorr] = "&_sousChaine("    ;  $lignesApres[$nbCorr]  = "&sousChaineZero(" ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_perl

###################################################################################################

sub  InitTdc_tcl  {

  my $nbCorr = 0 ; # nombre de correspondances
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_compareChaine"   ;  $lignesApres[$nbCorr]  = " \[string compare " ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_fin_de_fichier"  ;  $lignesApres[$nbCorr]  = " \[eof " ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_longueur "       ;  $lignesApres[$nbCorr]  = " \[string length " ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_maju "           ;  $lignesApres[$nbCorr]  = " \[string toupper" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_minu "           ;  $lignesApres[$nbCorr]  = " \[string tolower" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "\\\[_nbParametres"    ;  $lignesApres[$nbCorr]  = " \[llength \$argv " ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_tcl

###################################################################################################

sub  InitTdc_c  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_affecterChaine("  ;  $lignesApres[$nbCorr]  = "strcpy(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_codeAscii("       ;  $lignesApres[$nbCorr]  = "(int) (" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_fin_de_fichier("  ;  $lignesApres[$nbCorr]  = "feof(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_formatReel("      ;  $lignesApres[$nbCorr]  = "sprintf(\"%f\"," ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_longueur("        ;  $lignesApres[$nbCorr]  = "strlen(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_nbParametres()"   ;  $lignesApres[$nbCorr]  = "(argc-1)" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre("       ;  $lignesApres[$nbCorr]  = "parametre(argv," ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_valeurEntiere("   ;  $lignesApres[$nbCorr]  = "atoi(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_partieEntiere("   ;  $lignesApres[$nbCorr]  = "floor(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_valeurReelle("    ;  $lignesApres[$nbCorr]  = "atof(" ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_c

###################################################################################################

sub  InitTdc_cpp  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_affecterChaine("  ;  $lignesApres[$nbCorr]  = "strcpy(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_chaineAvant("     ;  $lignesApres[$nbCorr]  = "strcmp(" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_longueur("        ;  $lignesApres[$nbCorr]  = "strlen(" ;
  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_cpp

###################################################################################################

sub  InitTdc_java  {

  my $nbCorr = 0 ; # nombre de correspondances

  $nbCorr++ ; $lignesAvant[$nbCorr] = "_nbParametres()" ;  $lignesApres[$nbCorr]  = "tab_args.length" ;
  $nbCorr++ ; $lignesAvant[$nbCorr] = "_parametre(" ;  $lignesApres[$nbCorr]  = "parametre(tab_args," ;

  return($nbCorr,join("",@lignesAvant),join("",@lignesApres)) ;

} ; # fin sub InitTdc_java


#########################################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
