#  (gH)   --  galgtrad.pm  ;  TimeStamp (unix) : 07 Aot 01 11:23
#
###########################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galgtrad.pm : Module de TRADuction d'ALGorithme
# Date : 07/06/2001
#
###########################################################################

# Dclarations du package

package  galgtrad ;
require  Exporter ;
@ISA=('Exporter') ;
@EXPORT=('TradAlg') ;

###########################################################################

# Modules utiliss

use galgfncs     ; # fonctions utiles
use galgvars     ; # gestion des variables
use galglang     ; # gestion gnrale des langages

use galg2c       ; # Module de traduction d'ALGorithme en C
use galg2cpp     ; # Module de traduction d'ALGorithme en C++
use galg2dbase   ; # Module de traduction d'ALGorithme en DBASE
use galg2java    ; # Module de traduction d'ALGorithme en JAVA
use galg2pascal  ; # Module de traduction d'ALGorithme en PASCAL
use galg2perl    ; # Module de traduction d'ALGorithme en PERL
use galg2rexx    ; # Module de traduction d'ALGorithme en REXX
use galg2tcl     ; # Module de traduction d'ALGorithme en TCL

use FileHandle ; # Module ncessaire pour l'ouverture de fichiers


##########################################################################
##########################################################################


##########################################################################
#                                                                        #
#                                                                        #
#        Programmme principal                                            #
#                                                                        #
#                                                                        #
##########################################################################


##########################################################################


sub TradAlg { my $dbg_Traduction = 0 ; # mettre 1 pour debug, 0 en mode normal

 my @TLigneAlg ;                    # Tableau contenant les LIGNEs de l'ALGorithme  traduire
 my $NomFichSansExt ;               # NOM du FICHier SANS EXTension
 my $IndL ;                         # INDice de Ligne
 my %TableLang ;                    # TABLE des LANGages implmentables  ce jour
 my $Indent ;                       # INDENTation
 my $LCourante ;                    # Ligne COURANTE
 my $LSansCmt ;                     # Ligne SANS CoMmenTaire
 my $Comment ;                      # COMMENTaire
 my $Instruction ;                  # nom de l'INSTRUCTION
 my $ResteL ;                       # RESTE de la Ligne
 my $nbLigAlg ;                     # Nombre de lignes dans l'algorithme
 my $insereDebut ;                  # indique s'il faut insrer les instructions de dbut de programme

 # Rcupration des paramtres :
 # LIGNEs de l'ALGorithme sont en premier
 # Les derniers paramtres sont :
 # le NOM du FICHier SANS EXTension et le LANGage

 ($::LModules,$::LVar,$::LTab,$NomFichSansExt,$Lang,$::modeExec,$::modePostc,$nfpc,@TLigneAlg) = @_ ;

  $::SeparDon="__"; # SEPARateur de DONnes

  # Si le langage est inconnu on affiche un message d'erreur et on quitte

  &galglang::testeNomLangage($Lang) ;

  # Sinon, on ouvre le fichier pour traduction

  if ($dbg_Traduction == 1) {
     print "    ===> parm. $Lang on traduit en ".$main::tabLang{$Lang}." dans le fichier $main::nomDuProgramme \n" ;

  } ; # fin de si

  $::SymbFLang = new FileHandle;
  $::SymbFLang->open(">$main::nomDuProgramme")
      or die ("          Erreur ! Impossible d'crire dans $nomDuProgramme \n\n") ;       ;

  # on crit en dbut de fichier-algorithme qu'il s'agit d'une traduction via galg

  my $ligdeb = " Fichier $main::nomDuProgramme issu de galg -a $NomFichSansExt.alg -o $Lang" ;
  &{"Commentaire_".$Lang}("#-#  $ligdeb") ;
  print $::SymbFLang "\n";
  &{"Commentaire_".$Lang}("#-#  ".("=" x length($ligdeb))) ;
  print $::SymbFLang "\n";
  &{"Commentaire_".$Lang}("#-#      ".&gereLeTemps()) ;
  print $::SymbFLang "\n";

  # on laisse une ligne vide pour mieux voir le programme

  print $::SymbFLang "\n";

  # si le mode postComparaison est actif, on le rappelle en commentaire dans le fichier programme

  if ($::modePostc ==1) {
      &{"Commentaire_".$Lang}("#-#  (fichier post-modifi via la table de correspondance $nfpc)") ;
      print $::SymbFLang "\n";
  } ; # fin de si le mode postComparaison est actif

  # Il arrive que les dernires lignes d'un algorithme soient vides ; on vient donc les
  # liminer par la boucle suivante

  $nbLigAlg =  $#TLigneAlg ;
  while (length($TLigneAlg[$nbLigAlg])==0) {
    $nbLigAlg-- ;
  } ; # fin tant que

  # Traduction ligne  ligne

  $insereDebut   = 0 ;
  my $ligAlgCour = "" ; # ligne courante d'algorithme

  for ($IndL=1; $IndL <= $nbLigAlg ; $IndL++) {

      $ligAlgCour = $TLigneAlg[$IndL] ;
      if ($dbg_Traduction == 1) { print " ligne $IndL lue :  $TLigneAlg[$IndL]\n" ; } ;

      # on ne met la ou les instructions de dbut de programme
      # qu'aprs les commentaires du dbut

      if ( (substr("$ligAlgCour  ",0,1) ne "#") and ($insereDebut == 0) ) {
          &{"DebutProgramme_".$Lang}() ;
          $insereDebut = 1 ;
      } ; # fin de si

      # on garde dans la variable Indent le nombre d'espaces en dbut
      # de ligne avant d'crire l'instruction

      ($Indent, $LCourante)=&IndentEtReste($TLigneAlg[$IndL]) ;
      print $::SymbFLang $Indent;

      if ($dbg_Traduction == 1) { print "\n    ===> LIGNE COURANTE $LCourante\n" ; } ;

      #  partir de galg version 2.10 on autorise des commentaires
      # spciaux d'inclusion reprs par la suite de caractres #> ou par #:
      # il faut les dtecter et les traiter avant les commentaires normaux

        if  (&cmtInclusionFichier($TLigneAlg[$IndL])==1 ) { &inclusionFichier($TLigneAlg[$IndL])  }
      elsif (&cmtInclusionLigne($TLigneAlg[$IndL])==1 )   { &inclusionLigne($TLigneAlg[$IndL])  }
      else {

         # arriv ici, on a affaire  soit  une ligne normale d'instruction ou  un commentaire
         # mais il peut y avoir un commentaire en fin de ligne

         # on rcupre donc l'instruction (ventuellement vide)

         $LSansCmt = &sansCmt($LCourante) ;
         $LSansCmt = &sansEspaceDebutEtFin($LSansCmt) ;

         # et le commentaire ventuel

         $Comment=&Cmt($LCourante) ;

         # s'il y a bien une instruction, on la traite en dcomposant
         # en mot d'instruction et reste de ligne

         if ($LSansCmt ne "") {
# old       ($Instruction, $ResteL)=&premierEtReste($LSansCmt) ;
            ($Instruction, $ResteL,$var_Fi)=&galganl::decoupeLigneAlgo($LSansCmt) ;
            if ($dbg_Traduction == 1) { print "    ===> INSTRUCTION AVANT MAZ *$Instruction*\n" ; } ;
            if ($dbg_Traduction == 1) { print "    ===> RESTE DE LA LIGNE     *$ResteL*\n" ; } ;
            if ($dbg_Traduction == 1) { print "    ===> VARIABLE DE FICHIER   *$var_Fi*\n" ; } ;
            $Instruction=&MizANormInstr($Instruction) ;
            &$Instruction(&sansEspaceDebutEtFin($ResteL),$var_Fi) ;
         } ; # Si la Ligne SANS CoMmenTaire n'est pas vide

         if ($dbg_Traduction == 1) { print "    ==>> DONC parm INSTRUCTION   *$ResteL*\n" ; } ;


         # et s'il y avait un commentaire au bout, on le rajoute

         if ($Comment ne "") {

            # tcl oblige  mettre un point-virgule devant le symbole de commentaire
            # pour une instruction non vide
            if ($Lang eq "tcl") {
               if ($LSansCmt ne "") {
                  print $::SymbFLang ";";
               } ; # fin si
            } ; # fin si

            &{"Commentaire_".$Lang}($Comment) ;
         } ; # Si le COMMENTaire n'est pas vide

         print $::SymbFLang "\n";
         } ; # fin de si commentaire d'inclusion

if ($dbg_Traduction == 1) { &attends() ; } ;

  } ; # fin_pour IndLigne

  # Instruction(s) de fin de programme

  &{"FinProgramme_".$Lang}() ;

  print $::SymbFLang "\n";
  my $ligfin = " Fin de traduction pour $main::nomDuProgramme via de galg -a $NomFichSansExt.alg -o $Lang" ;
  &{"Commentaire_".$Lang}("#-#  $ligfin") ;
  print $::SymbFLang "\n";

  # on ferme le fichier de traduction et on dit qu'il est pret  etre utilis

  $::SymbFLang->close;

  # on n'affiche rien si on doit ensuite passer en mode excution

  if ($::modeExec==0) { print " Vous pouvez consulter $main::nomDuProgramme \n"; } ;

} ; # FIN sub TradAlg

##########################################################################

# MIse A NORMe de l'INSTRuction pour correspondre  notre NORMe de noms de procdures.

sub MizANormInstr {
  my $Instr;

  $Instr=&maju($_[0]) ;
  $Instr=&sansEspaceDebutEtFin($Instr) ;

  # dans cet ordre :

  $Instr =~ s/ECRIRE_SUR/Ecrire_sur/;
  $Instr =~ s/LIRE_SUR/Lire_sur/;

  # puis le reste !

  $Instr =~ s/COMMENTAIRE/Commentaire/;
  $Instr =~ s/AFFECTER/Affecter/;
  $Instr =~ s/ECRIRE/Ecrire/;
  $Instr =~ s/LIRE/Lire/;
  $Instr =~ s/APPELER/Appeler/;
  $Instr =~ s/SI/Si/;
  $Instr =~ s/ALORS/Alors/;
  $Instr =~ s/SiNON/Sinon/;
  $Instr =~ s/POUR/Pour/;
  $Instr =~ s/TANT_QUE/Tant_Que/;
  $Instr =~ s/FIN/Fin/;
  $Instr =~ s/QUITTER/Quitter/;
  $Instr =~ s/REPETER/Repeter/;
  $Instr =~ s/JUSQU'A/Jusqu'a/;
  $Instr =~ s/OUVRIR_LEC/Ouvrir_lec/;
  $Instr =~ s/OUVRIR_ECR/Ouvrir_ecr/;
  $Instr =~ s/FERMER/Fermer/;

  return($Instr) ;

} ; # FIN sub MizANormInstr


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#       sous-programmes pour les INSTRUCTIONS                             #
#                                                                         #
#                                                                         #
###########################################################################
#                                                                         #
#  Dans toutes les fonctions portant un nom d'instruction :               #
#  appel du sous-programme INSTRUCTION dans le langage choisi             #
#  par l'utilisateur traitement du/des paramtres si besoin               #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire {

  &{"Commentaire_".$Lang}($_[0]) ;

} ; # FIN sub Commentaire

##########################################################################

sub Affecter { my $dbg_Aff = 0 ; # mettre 1 pour debug, 0 en mode normal

  my $VarG  ; # VARiable Gauche de l'affectation
  my $ParD  ; # PARtie Droite de l'affectation
  my $Ligne ;
  my $PosAff; # POSition du signe d'AFFectation

  $Ligne=$_[0];
  if ($dbg_Aff==1) { print " Affecter 1 / 3  : $Ligne \n" ; } ;
  $PosAff=index($Ligne, "<--") ;
  $VarG=substr($Ligne, 0, $PosAff) ;
  $ParD=substr($Ligne, $PosAff+3) ;

  $VarG=&sansEspaceDebutEtFin($VarG) ;
  $ParD=&sansEspaceDebutEtFin($ParD) ;

  if ($dbg_Aff==1) { print " Affecter 2a / 3  partie gauche : $VarG \n" ; } ;
  $VarG=&GereTerme($VarG) ;
  if ($dbg_Aff==1) { print " Affecter 2b / 3  partie gauche : $VarG \n" ; } ;
  $ParD=&GereExpression($ParD) ;
  if ($dbg_Aff==1) { print " Affecter 3 / 3  partie droite : $ParD \n" ; } ;
  if ($dbg_Aff==1) { &attends() ; } ;


  &{"Affecter_".$Lang}($VarG, $ParD) ;

} ; # FIN sub Affecter

##########################################################################

# Ecrire (effectue toujours un saut de ligne)

sub Ecrire {
  # print "        ===>   ECRIRE DE $_[0]\n" ;
  my $parmEcrire =  &GerePhrase($_[0]) ;
  # print "        ===>   ECRIRE transmet $parmEcrire \n" ;
  &{"Ecrire_".$Lang}($parmEcrire) ;

} ; # FIN sub Ecrire

##########################################################################

# Ecrire_ (n'effectue pas de un saut de ligne)

sub Ecrire_ {
  # print "        ===>   ECRIRE DE $_[0]\n" ;
  my $parmEcrire =  &GerePhrase($_[0]) ;
  # print "        ===>   ECRIRE transmet $parmEcrire \n" ;
  &{"Ecrire__".$Lang}($parmEcrire) ;

} ; # FIN sub Ecrire_

##########################################################################

sub Ecrire_sur {
  # print "        ===>   ECRIRE SUR DE $_[0]\n" ;
  my $parmEcrire_ =  &GerePhrase($_[0]) ;
  # print "        ===>   ECRIRE transmet $parmEcrire \n" ;
  &{"Ecrire_sur_".$Lang}($parmEcrire_,$_[1]) ;

} ; # FIN sub Ecrire_sur

##########################################################################

sub Lire {
  my $retGv = &GereVariable($_[0]) ;
  &{"Lire_".$Lang}($retGv) ;

} ; # FIN sub Lire

##########################################################################

sub Lire_sur {
  # print " Lire_sur DE $_[0] ET $_[1] \n" ;
  my $retGv = &GereVariable($_[0]) ;
  # print " soit : Lire_sur POUR $retGv ET $_[1] \n" ;
  &{"Lire_sur_".$Lang}($retGv,$_[1]) ;

} ; # FIN sub Lire

##########################################################################

sub Ouvrir_lec {
my $chaineId =  &sansEspaceDebutEtFin($_[0]) ;
my $handleId =  $_[1] ;
#print " 1 - essai d'ouvrir_lec NOM '$chaineId' HANDLE $handleId \n" ;
if (EstChaine($chaineId)) { $chaineId = substr($chaineId,1,length($chaineId)-2) ; } ;
## ??? if (EstVarSimple($chaineId)) { $chaineId = "\$".$chaineId ; } ;
## print " 2 - essai d'ouvrir_lec NOM '$chaineId' HANDLE $handleId \n" ;
#&attends() ;
  &{"Ouvrir_lec_".$Lang}($chaineId,$handleId) ;

} ; # FIN sub Lire

##########################################################################

sub Ouvrir_ecr {

my $chaineId =  &sansEspaceDebutEtFin($_[0]) ;
my $handleId =  $_[1] ;
#print " 1 - essai d'ouvrir_ecr NOM '$chaineId' HANDLE $handleId \n" ;
if (EstChaine($chaineId)) { $chaineId = substr($chaineId,1,length($chaineId)-2) ; } ;
## ??? if (EstVarSimple($chaineId)) { $chaineId = "\$".$chaineId ; } ;
## print " 2 - essai d'ouvrir_lec NOM '$chaineId' HANDLE $handleId \n" ;
#&attends() ;
  &{"Ouvrir_ecr_".$Lang}($chaineId,$handleId) ;

} ; # FIN sub Lire

##########################################################################

sub Fermer {

  &{"Fermer_".$Lang}($_[0],$_[1]) ;

} ; # FIN sub Lire

##########################################################################

sub Appeler {

  my $phrAppel = $_[0] ;
  $phrAppel =  &GereFonction($phrAppel) ;
  &{"Appeler_".$Lang}($phrAppel) ;

} ; # FIN sub Appeler

##########################################################################

sub Pour {
  my $LCourante; # Ligne COURANTE
  my $IndB; # INDice de Boucle
  my $Deb; # DEBut
  my $Fin; # FIN

  $LCourante=$_[0];

  $LCourante =~ s/de1a/ De 1 A /i ;
  $LCourante =~ s/de1/ De 1 A /i ;
  $LCourante =~ s/de0a/ De 0 A /i ;
  $LCourante =~ s/de0/ De 0 A /i ;
  $LCourante =~ s/DE0A/ De 0 A /i ;
  $LCourante =~ s/DE1A/ De 1 A /i ;
  $IndB=&GereVarSimple(&mot($LCourante, 1)) ;
  $Deb=&GereTerme(&mot($LCourante, 3)) ;
  $Fin=&GereTerme(&mot($LCourante, 5)) ;

  &{"Pour_".$Lang}($IndB, $Deb, $Fin) ;

} ; # FIN sub Fin_Pour

##########################################################################

sub Fin_Pour {

  &{"Fin_Pour_".$Lang}() ;

} ; # FIN sub Fin_Pour

##########################################################################

sub Si {

  &{"Si_".$Lang}(&GereExpression($_[0])) ;

} ; # FIN sub Si

##########################################################################

sub Alors {
  my $Instruction; # nom de l'INSTRUCTION
  my $ResteL; # RESTE de la Ligne

  &{"Alors_".$Lang}() ;

  if ($_[0] ne "") {
    ($Instruction, $ResteL)=&premierEtReste($_[0]) ;
    $Instruction=&MizANormInstr($Instruction) ;
    &$Instruction(&sansEspaceDebutEtFin($ResteL)) ;
  } ; # FIN_SI la ligne comporte une instruction suivante

} ; # FIN sub Alors

##########################################################################

sub Sinon {
  my $Instruction; # nom de l'INSTRUCTION
  my $ResteL; # RESTE de la Ligne

  &{"Sinon_".$Lang}() ;

  if ($_[0] ne "") {
    ($Instruction, $ResteL)=&premierEtReste($_[0]) ;
    $Instruction=&MizANormInstr($Instruction) ;
    &$Instruction(&sansEspaceDebutEtFin($ResteL)) ;
  } ; # FIN_SI la ligne comporte une instruction suivante

} ; # FIN sub Sinon

##########################################################################

sub Fin_Si {

  &{"Fin_Si_".$Lang}() ;

} ; # FIN sub Fin_Si

##########################################################################

sub Tant_Que {

  &{"Tant_Que_".$Lang}(&GereExpression($_[0])) ;

} ; # FIN sub Tant_Que

##########################################################################

sub Fin_Tant_Que {

  &{"Fin_Tant_Que_".$Lang}() ;

} ; # FIN sub Fin_Tant_Que

##########################################################################

sub Repeter {

  # rpter pause un cas particulier pour Rexx
  # car Rex vaut la condition ds la ligne rpter
  # on s'en sort avec un tableau global de conditions de
  # "rpter" nomm main::globRep ;
  # la seule chose  savoir est le numro de condition

  &{"Repeter_".$Lang}($_[0]) ;

} ; # FIN sub Fin_Tant_Que

###########################################################################

sub Jusqu'a {

  &{"Jusqu'a_".$Lang}(&GereExpression($_[0])) ;

} ; # FIN sub Fin_Tant_Que

###########################################################################

sub Quitter {

  &{"Quitter_".$Lang}(&GereExpression($_[0])) ;

} ; # FIN sub Fin_Tant_Que


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Fonctions de gestion des paramtres                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


# GERE une PRASE pour tre traite dans chaque langage
# Modle utilis :
# phrase :: chaine | expression | chaine, phrase | expression, phrase
# attention : une expression peut etre f(x,y) ou " comme a,b,c " ou t[ a, b ]
# et donc la virgule
# n'est pas toujours l o on pense

sub GerePhrase { my $dbg_GerePhrase = 0 ; # 0 pour mode normal, 1 pour debug

  my $Phraz;
  my $Param;
  my $PosVirg; # POSition de la VIRGule

  $Phraz=$_[0];
# old :   $PosVirg=&PremVirgHC($Phraz) ; # PREMire VIRGule Hors Chaine
#  $PosVirg=&PremVirgHC($Phraz) ; # PREMire VIRGule Hors Chaine
  $PosVirg=&PremVirgSep($Phraz) ; # PREMire VIRGule SEParatrice d'lments

  if ($dbg_GerePhrase == 1) { print "\n\n ==============================================\n" ; } ;
  if ($dbg_GerePhrase == 1) { print "\n\n 1 - GerePhrase de $Phraz , VIRGULE en $PosVirg\n" ; } ;

  if ($PosVirg != -1) {
    # s'il y a au moins une de virgule de sparation
    # on dcompose en PARAMtre avant la virgule et PHRAse aprs la virgule
    $Param=substr($Phraz, 0, $PosVirg) ;
    $Phraz=substr($Phraz, $PosVirg+1) ;
    $Param=&sansEspaceDebutEtFin($Param) ;
    $Phraz=&sansEspaceDebutEtFin($Phraz) ;
    if ($dbg_GerePhrase == 1) { print " dcompose en $Param -- ET -- $Phraz \n" ; } ;

    # si le paramtre est une chaine simple, on renvoie le contenu de la chaine
    if (&EstChaine($Param)) {
    if ($dbg_GerePhrase == 1) { print " $Param EST UNE CHAINE \n" ; } ;
      $Param=substr($Param, 1, length($Param)-2) ;
       # pour perl et tcl : sparer avec des espaces car il faudra rajouter des $ devant
       # les noms de variables
  if ($dbg_GerePhrase == 1) { print "\n\n 2 - GerePhrase de $Phraz , VIRGULE en $PosVirg\n" ; } ;
       if ( ($Lang eq "perl") or ($Lang eq "tcl") ) {
         return(&{"GereChaine_".$Lang}($Param)." ".$::SeparDon." ".&GerePhrase($Phraz)) ;
       } else {
         return(&{"GereChaine_".$Lang}($Param).$::SeparDon.&GerePhrase($Phraz)) ;
       } ; # fin de si on traite le langage perl  part
    } else {
       # pour perl et tcl : sparer avec des espaces car il faudra rajouter des $ devant
       # les noms de variables
  if ($dbg_GerePhrase == 1) { print "\n\n 3 - GereExpression de $Phraz , VIRGULE en $PosVirg\n" ; } ;
       if ( ($Lang eq "perl") or ($Lang eq "tcl") ) {
          return(&GereExpression($Param)." ".$::SeparDon." ".&GerePhrase($Phraz)) ;
       } else {
          return(&GereExpression($Param).$::SeparDon.&GerePhrase($Phraz)) ;
       } ; # fin de si on traite le langage perl  part
    } ; # Fin_Si le PARAMtre est une chane

  } else {

    $Phraz=&sansEspaceDebutEtFin($Phraz) ;
    if (&EstChaine($Phraz)) {
      $Phraz=substr($Phraz, 1, length($Phraz)-2) ;
      return(&{"GereChaine_".$Lang}($Phraz)) ;
    }
    else {
    if ($dbg_GerePhrase == 1) { print " GerePhrase de $Phraz \n" ; } ;
      return(&GereExpression($Phraz)) ;
    } ; # Fin_Si le PARAMtre est une chane

  } ; # FIN_SI La PHRAse contient une VIRGule

} ; # FIN sub GerePhrase

###########################################################################

# GERE une EXPRESSION pour tre traite dans chaque langage
# Modle utilis :
# Expr :: Terme | op Expr | Expr op Expr

sub GereExpression {  my $dbg_GereExp = 0 ; # 0 pour mode normal, 1 pour debug

  my $Expr ;
  my $SuprParentez ; # indique s'il y a eu SUPpRession des PARENThses INUTILes en Dbut et en Fin
  my $Term ;
  my $Op ; # OPrateur
  my $PosOpPer ; # POSition de l'OPrateur
  my $ExprG ; # EXPRession Gauche
  my $ExprD ; # EXPRession Droite
  my $ExprResu ; # EXPRession RESUltat

  $Expr=$_[0];
  if ($dbg_GereExp==1) { print " GereExpression 0 : $Expr \n" ;  } ;
  $Expr=&ConvOperateur($Expr) ;
  ($Expr, $SuprParentez)=&SuprParentezInutilDF($Expr) ; # SUPpRession des PARENThses INUTILes en Dbut et en Fin
  if ($dbg_GereExp==1) { print " GereExpression 1 : (sans parenth.) $Expr \n" ;  } ;
  ($ExprG, $Op, $ExprD)=HacheExpression($Expr) ;
  if ($dbg_GereExp==1) { print " GereExpression 2 : (gauche)    $ExprG \n" ;  } ;
  if ($dbg_GereExp==1) { print " GereExpression 3 : (operateur) $Op \n" ;  } ;
  if ($dbg_GereExp==1) { print " GereExpression 3 : (droite)    $ExprD \n" ;  } ;

  $ExprG=&sansEspaceDebutEtFin($ExprG) ;
  $Op=&sansEspaceDebutEtFin($Op) ;
  $ExprD=&sansEspaceDebutEtFin($ExprD) ;

  if ($Op eq "") {
    $ExprResu=&GereTerme($Expr) ;
  }
  else {
    $ExprG=&GereExpression($ExprG) ;
    $ExprD=&GereExpression($ExprD) ;
## old :    $ExprResu=&{"GereOperateur_".$Lang}($ExprG, $Op,$ExprD) ;
    $ExprResu=&{"GereOperateur_".$Lang}("$ExprG ", $Op," $ExprD") ;
  } ;

  if ($SuprParentez == 1) {
    $ExprResu="(".$ExprResu.")";
  } ; # FIN_SI il y a eu SUPpRession des PARENThses INUTILes en Dbut et en Fin

  if ($dbg_GereExp==1) { print " GereExpression * : on renvoie $ExprResu \n" ;  } ;
  return($ExprResu) ;

} ; # FIN sub GereExpression

###########################################################################

# GERE un TERME pour tre trait dans chaque langage
# Modle utilis :
# Terme :: Fonction | Variable | CstNum

sub GereTerme {

  my $Terme;
  $Terme=$_[0];
  if    (&EstFonction($Terme)) { return(&GereFonction($Terme)) ;  }
  elsif (&EstVariable($Terme)) { return(&GereVariable($Terme)) ;  }
  else  { return(&{"GereCstNum_".$Lang}($Terme)) ; }

} ; # FIN sub GereTerme

###########################################################################

sub GereFonction { my $dbg_Gf = 0 ; # 0 pour mode normal, 1 pour debug

  my $Expr         ; # EXPRession  grer
  my $PosParenthez ; # POSition de la PARENTHEse ouvrante
  my $NomFct       ; # NOM de la FonCTion
  my @TParam       ; # Tableau des PARAMtres de la fonction
  my $IndP         ; # INDice de Paramtre

  $Expr=$_[0];
  if ($dbg_Gf==1) { print " 1 / 2 GereFonction de $Lang pour $NomFct avec $Expr \n" ; } ;

  $PosParenthez = index($Expr, "(") ;
  $NomFct       = substr($Expr, 0, $PosParenthez) ;
  $Expr         = substr($Expr, $PosParenthez) ;
  $Expr         = substr($Expr, 1, length($Expr)-2) ; # Suppression des parenthses
  $Expr         = &sansEspaceDebutEtFin($Expr) ;

  if ($dbg_Gf==1) { print " 2 / 2 GereFonction de $Lang pour $NomFct et GerePhrase de $Expr \n" ; } ;
  return(&{"GereFonction_".$Lang}($NomFct, &GerePhrase(" $Expr "))) ;

} ; # FIN sub GereFonction

###########################################################################

sub GereVariable {
  my $Var;

  $Var=$_[0];

  if (&EstVarSimple($Var)) {
    return(&GereVarSimple($Var)) ;
  } else {
    if (&EstVarTableau($Var)) {
       return(&GereVarTableau($Var)) ;
    } else {
      print " mais quelle variable ? $_[0]\n" ; &attends() ;
    } ; # fin de si estVarTableau
  } ; # fin de si estVarSimple

} ; # FIN sub GereVariable

###########################################################################

sub GereVarSimple {

  return(&{"GereVarSimple_".$Lang}($_[0])) ;

}

###########################################################################

sub GereVarTableau {

  my $Expr;
  my $PosCrochetOuv ; # POSition du CROCHET ouvrant
  my $NomTab ;     # NOM du TABleau

  $Expr=$_[0];
  $PosCrochetOuv=index($Expr, "[") ;
  $NomTab=substr($Expr, 0, $PosCrochetOuv) ;
  $Expr=substr($Expr, $PosCrochetOuv) ;
  $Expr=substr($Expr, 1, length($Expr)-2) ; # Suppression des crochets

    my $ndsdp = 0 ; # nb de symboles de parenthses
    my $ldl  = length($dlc) ; # longueur de l'expression
    my $ndc  = 0 ;             # numro de caractres courant
    my $ndpo = 0 ;             # nb d'oprateurs de comparaison
    while ($ndc<$ldl) {
      $lek = substr($dlc,$ndc,1) ;
      if ($lek eq "[") { $ndsdp++ ; } ;
      if ($lek eq "]") { $ndsdp++ ; } ;
      if (index($ldmdCop,$lek)>-1) { $ndpo++ ; } ;
      $ndc++ ;
    } ; # fin tant que sur $ndc
    if ( ($ndsdp==2) or ($ndpo<=1) ) { $dlc = substr($dlc,1,$ldl-2) ; } ;
    if ($dbg_Gta==1) { print "     SANS CRO : $dlc \n\n" ; } ;

  $Expr=&sansEspaceDebutEtFin($Expr) ;

  return(&{"GereVarTableau_".$Lang}($NomTab, &GerePhrase($Expr))) ;

} ; # FIN sub GereVarTableau

###########################################################################

# PREMire VIRGule Hors Chaine

sub PremVirgHC {
  my $Phraz;
  my $PosVirg; # POSition de la VIRGule
  my $PosPremGuill; # POSition du PREMier GUILLemet
  my $PosSecGuill; # POSition du SECond GUILLemet

  $Phraz=$_[0];

  $PosVirg=index($Phraz, ",") ;
  $PosPremGuill=index($Phraz, "\"") ;

  if (($PosPremGuill > -1) and ($PosVirg > $PosPremGuill)) {
      $PosSecGuill=index($Phraz, "\"", $PosPremGuill+1) ;
      $PosVirg=index($Phraz, ",", $PosSecGuill) ;
    } ; # FIN_SI un guillemet est trouv avant une virgule

  ## print " ANC la virgule sparatrice est donc en $PosVirg \n"  ;
  return($PosVirg) ;

} ; # fin sub PremVirgHC {

###########################################################################

# PREMire VIRGule SEPAratrice

sub PremVirgSep {
  my $Phraz;
  $Phraz= $_[0] ;

  my $longPhraz = length($Phraz) ;
  my $PosVirg = -1 ; # POSition de la VIRGule

  my $indCar = 0 ; # indice du caractre dans la phrase
  my $sonCar = "" ; # caractre correspondant
  my $paren  = 0  ; # vaut 0 si on n'est pas entre parenthses
  my $guill  = 0  ; # vaut 0 si on n'est pas entre guillemets
  my $croch  = 0  ; # vaut 0 si on n'est pas entre crochets

  while ($indCar<$longPhraz) {
    $sonCar = substr($Phraz,$indCar,1) ;
    if ($sonCar eq "(")  { $paren++ ; } ;
    if ($sonCar eq ")")  { $paren-- ; } ;
    if ($sonCar eq "[")  { $croch++ ; } ;
    if ($sonCar eq "]")  { $croch-- ; } ;
    if ($sonCar eq "\"") { $guill++ ; $guill = $guill % 2 ; } ;
    if (($sonCar eq ",") and ($paren==0) and ($guill==0)){
      $PosVirg = $indCar ;
      $indCar = $longPhraz + 1 ;
    } ; # fin de si on a vu la virgule
    ## print " indCar $indCar caractre $sonCar \n"  ;
    $indCar++ ;
  } ; # fin tant que sur indCar

  ##print " la virgule sparatrice est donc en $PosVirg \n"  ;
  ## &attends() ;

  return($PosVirg) ;

} ; # fin de sub PremVirgSep

###########################################################################

# PREMier GUILLEMET Valide

sub PremGuilValide {
  my $Phraz;
  $Phraz= $_[0] ;

  my $longPhraz = length($Phraz) ;
  my $PosGuil   = -1 ; # POSition de la VIRGule

  my $indCar = 0 ; # indice du caractre dans la phrase
  my $sonCar = "" ; # caractre correspondant
  my $paren  = 0  ; # vaut 0 si on n'est pas entre parenthses
  my $guill  = 0  ; # vaut 0 si on n'est pas entre guillemets
  my $croch  = 0  ; # vaut 0 si on n'est pas entre crochets

  while ($indCar<$longPhraz) {
    $sonCar = substr($Phraz,$indCar,1) ;
    if ($sonCar eq "(")  { $paren++ ; } ;
    if ($sonCar eq ")")  { $paren-- ; } ;
    if ($sonCar eq "[")  { $croch++ ; } ;
    if ($sonCar eq "]")  { $croch-- ; } ;
    if ($sonCar eq "\"") { $guill++ ; $guill = $guill % 2 ; } ;
    if (($sonCar eq "\"") and ($paren==0) and ($guill==0) ){
      $PosGuil = $indCar ;
      $indCar = $longPhraz + 1 ;
    } ; # fin de si on a vu la virgule
    ## print " indCar $indCar caractre $sonCar \n"  ;
    $indCar++ ;
  } ; # fin tant que sur indCar

  ##print " la virgule sparatrice est donc en $PosVirg \n"  ;
  ## &attends() ;

  return($PosGuil) ;

} ; # fin sub PremGuilValide

###########################################################################

# CONVertit les OPERATEURS dans une norme interne

sub ConvOperateur {

  my $Ligne  = $_[0];

  # remplacement du "ou" logique par _OU_ entour de sparateurs
  $Ligne =~ s/ ou / _OU_ /g;
  $Ligne =~ s/\)ou/\) _OU_ /g;
  $Ligne =~ s/ou\(/ _OU_ \(/g;

  # remplacement du "et" logique par _ET_ entour de sparateurs
  $Ligne =~ s/ et / _ET_ /g;
  $Ligne =~ s/\)et/\) _ET_ /g;
  $Ligne =~ s/et\(/ _ET_ \(/g;

  # remplacement du "non" logique par _NON_ entour de sparateurs

  $Ligne =~ s/non / _NON_ /g;
  $Ligne =~ s/\(non/\( _NON_ /g;
  $Ligne =~ s/non\(/ _NON_ \(/g;

  # remplacement des oprateurs de comparaison par leur "quivalent"
  # dans notre norme entour de sparateurs

  $Ligne =~ s/<=/ _INFEGAL_ /g;
  $Ligne =~ s/>=/ _SUPEGAL_ /g;
  $Ligne =~ s/<>/ _DIFF_ /g;
  $Ligne =~ s/=/ _EGAL_ /g;
  $Ligne =~ s/</ _INF_ /g;
  $Ligne =~ s/>/ _SUP_ /g;

  # Insertion de sparateurs entre les mots restants

  $Ligne=~s/[+]/ _PLUS_ /g;
  $Ligne=~s/[-]/ _MOINS_ /g;
  $Ligne=~s/[*]/ _MULT_ /g;
  $Ligne=~s/[\/]/ _DIV_ /g;

  return($Ligne) ;

} ; # FIN sub ConvOperateur

###########################################################################

# SUPpRession des PARENThses INUTILes en Dbut et en Fin
# Base sur la mme ide que HacheExpression

sub SuprParentezInutilDF {
  my $Expr; # EXPRession
  my $ExprW; # EXPRession de travail
  my @TExprW; # Tableau des EXPRessions de travail
  my $Operateurs;
  my $Op; # OPrateur
  my $IndB; # INDice de Boucle
  my $SuprParentez; #indique s'il y a eu SUPpRession des PARENThses INUTILes en Dbut et en Fin

  $Expr=$_[0];
  $ExprW=$Expr;
  $SuprParentez=0;

  if (substr($ExprW, 0, 1) eq "(") {
    $ExprW=~s/[(]/ _PARENTEZOUVR_ /g;
    $ExprW=~s/[)]/ _PARENTEZFERM_ /g;
    @TExprW=split(" ", $ExprW) ;

    $Operateurs=(" _OU_ _ET_ _NON_ _INFEGAL_ _SUPEGAL_ _DIFF_ _EGAL_ _SUP_ _INF_ _PLUS_ _MOINS_ _MULT_ _DIV_ ") ;
    $Op="";
    $IndB=0;
    $NbParenthez = 0;

    while (($IndB <= $#TExprW) and ($Op eq "")) {
      if ($TExprW[$IndB] eq "_PARENTEZOUVR_") {
	$NbParenthez++;
      }
      if ($TExprW[$IndB] eq "_PARENTEZFERM_") {
	$NbParenthez--;
      }
      if (($NbParenthez == 0) and (&PosMotDsPhraz($TExprW[$IndB], $Operateurs) > 0)) {
	$Op=$TExprW[$IndB];
      } ; # fin_si le mot est un oprateur pre
      $IndB++;
    } ; # Fin_Tant_Que l'OPrateur pre est vide et la fin du tableau n'est pas atteinte

    if ($Op eq "") {
      $Expr=substr($Expr, 1, length($Expr)-2) ;
      $SuprParentez=1;
    } ; # Fin_Si l'OPrateur pre est vide
  } ; # FIN_SI le dbut de l'expression est une parenthse ouvrante

  return($Expr, $SuprParentez) ;

} ; # FIN sub SuprParentezInutilDF

###########################################################################


sub HacheExpression { my $dbg_Hache = 0 ; # 0 pour mode normal, 1 pour debug

# Retourne le triplet : EXPRession Gauche, OPrateur, EXPRession Droite
# Dans le cas d'un oprateur unaire, l'EXPRession Gauche est vide
# S'il n'y a pas d'OPrateur, l'OPrateur et l'EXPRession Droite sont vides
# Exemple : puissance(2, -1)


  my $Expr          ; # EXPRession
  my @TExpr         ; # Tableau des EXPRession
  my $Operateurs    ;
  my $ExprG         ; # EXPRession Gauche
  my $Op            ; # OPrateur
  my $ExprD         ; # EXPRession Droite
  my $IndB          ; # INDice de Boucle

  $Expr=$_[0];
  $Expr=~s/[(]/ _PARENTEZOUVR_ /g;
  $Expr=~s/[)]/ _PARENTEZFERM_ /g;
  if ($dbg_Hache==1) { print " Hache 0 : * $Expr *\n" ; } ;
  @TExpr=split(" ", $Expr) ;

  $Operateurs=(" _OU_ _ET_ _NON_ _INFEGAL_ _SUPEGAL_ _DIFF_ _EGAL_ _SUP_ _INF_ _PLUS_ _MOINS_ _MULT_ _DIV_ ") ;
  $ExprG="";
  $Op="";
  $ExprD="";
  $IndB=0;
  $NbParenthez = 0;

  # Si l'EXPRession est un OPERATEUR, PARENThsE OUVRante ou PARENThsE FERMante,
  # il faut ajouter un espace avant et aprs pour un traitement ultrieur.

  # Rcupration de l'EXPRession Gauche et de l'OPrateur

  while (($IndB <= $#TExpr) and ($Op eq "")) {
      $eltb = $TExpr[$IndB] ;
#      if ($eltb eq "_DIV_") { print " c'est DIV ! ".&PosMotDsPhraz($eltb, $Operateurs)." !! "  ; } ;
#      print " pdm de $eltb ".&PosMotDsPhraz($eltb, $Operateurs)." !! "  ;
      if ($eltb eq "_PARENTEZOUVR_") {
          $NbParenthez++;
          $eltb=" ".$eltb." "; # ajout de l'espace avant et aprs
       } ; # Fin_Si l'EXPRession est une PARENThsE OUVRante

       if ($eltb eq "_PARENTEZFERM_") {
          $NbParenthez--;
          $eltb=" ".$eltb." "; # ajout de l'espace avant et aprs
       } ; # Fin_Si l'EXPRession est une PARENThsE FERMante

       if (($NbParenthez == 0) and (&PosMotDsPhraz($eltb, $Operateurs) > 0)) {
           $Op=$eltb ;
          if ($dbg_Hache==1) { print " Hache 0.1 : * $ExprG , $Op, $ExprD *\n" ; } ;
       }  else { if (&PosMotDsPhraz($eltb, $Operateurs) > 0) {
                 $ExprG.=" ".$eltb." ";
               } else {
                   $ExprG.=$eltb;
               } ; # fin_si l'EXPRession est un OPERATEUR
    } ; # Fin_Si le mot est un oprateur pre (hirarchiquement le plus haut)

    $IndB++;
    if ($dbg_Hache==1) { print " Hache 0.2 : * $ExprG , $Op, $ExprD *\n" ; } ;

  } ; # Fin_Tant_Que l'OPrateur pre est vide et la fin du tableau n'est pas atteinte

  # Rcupration de l'EXPRession Droite

  if ($dbg_Hache==1) { print " Hache 1a : * $ExprG , $Op, $ExprD *\n" ; } ;
  while ($IndB <= $#TExpr) {
      $eltb = $TExpr[$IndB] ;
    if (($eltb eq "_PARENTEZOUVR_") or ($eltb eq "_PARENTEZFERM_")
    or (&PosMotDsPhraz($eltb, $Operateurs) > 0)) {
      $ExprD.=" ".$eltb." "; # ajout de l'espace avant et aprs
    } else {
      $ExprD.=$eltb;
    } ; # fin_si l'EXPRession est un OPERATEUR, PARENThsE OUVRante ou PARENThsE FERMante
    $IndB++;
  } ; # fin tant que


  if ($dbg_Hache==1) { print " Hache 1b : * $ExprG , $Op, $ExprD *\n" ; } ;

  $ExprG=~s/ _PARENTEZOUVR_ /( /g;
  $ExprG=~s/ _PARENTEZFERM_ / )/g;
  $ExprD=~s/ _PARENTEZOUVR_ /( /g;
  $ExprD=~s/ _PARENTEZFERM_ / )/g;

  if ($dbg_Hache==1) { print " Hache 2 : * $ExprG , $Op, $ExprD *\n" ; } ;
  # on laisse un seul espace aprs ( et devant )

  $ExprG=~s/\(/( /g;
  $ExprG=~s/\)/ ) /g;
  $ExprD=~s/\(/( /g;
  $ExprD=~s/\)/ ) /g;

  if ($dbg_Hache==1) { print " Hache * : * $ExprG , * $Op *, $ExprD *\n" ; } ;
  if ($dbg_Hache==1) { &attends() ; } ;
  return(" $ExprG", " $Op ", "$ExprD ") ;

} ; # FIN sub HacheExpression


##########################################################################
##########################################################################


##########################################################################
#                                                                        #
#                                                                        #
#        Fonctions d'information indiquant la nature du paramtre :      #
#        variable, fonction...                                           #
#                                                                        #
#                                                                        #
##########################################################################


##########################################################################
##########################################################################


sub EstFonction {

  my $Expr;
  $Expr=$_[0];
  my $PosParenthez; # POSition de la PARENTHEse ouvrante
  my $rdEf ;


  $PosParenthez=index($_[0], "(") ;
  if ($PosParenthez>-1) { $Expr=substr($Expr, 0, $PosParenthez) ; } ;

  $rdEf = &PosMotDsPhraz($Expr, $::LModules) > -1 ;
  return($rdEf) ;

} ; # FIN sub EstFonction

##########################################################################

sub EstVariable {

  return(&EstVarSimple($_[0]) or &EstVarTableau($_[0])) ;

} ; # FIN sub EstVariable

##########################################################################

sub EstVarSimple {

  return((&PosMotDsPhraz($_[0], $main::LVar) > -1)) ;

} ; # FIN sub EstVarSimple

##########################################################################

sub EstVarTableau {

  my $Expr;
  my $PosCrochet; # POSition du CROCHET ouvrant

  $Expr=$_[0];

  $PosCrochet=index($_[0], "[") ;
  $Expr=substr($Expr, 0, $PosCrochet) ;

  return((&PosMotDsPhraz($Expr, $::LTab) > -1)) ;

} ; # FIN sub EstVarTableau

##########################################################################

sub EstChaine {

  # pour savoir si le paramtre pass est une chaine, il ne suffit pas
  # de tester s'il y a un guillemet car sinon copies(" ",10) qui N'EST PAS
  # une chaine serait considr comme une chaine


#  old : return(index($_[0], "\"") > -1) ;
  my $retPgv = &PremGuilValide($_[0]) > -1 ;
  return($retPgv) ;

} ; # FIN sub EstChaine

##########################################################################
##########################################################################

##########################################################################
#                                                                        #
#   Fonctions pour inclusion de ligne ou de fichier                      #
#                                                                        #
##########################################################################

##########################################################################
##########################################################################

sub  cmtInclusionLigne  { my $dbg_CmtIncLigne = 0 ; # 0 pour normal, 1 pour dbug

  # ce sous-programme renvoie 1 s'il faut inclure un fichier

  my $ligneCand = $_[0] ; # ligne candidate pour l'inclusion de fichier
  my $retIncLig = 0     ; # rsultat renvoy

  $ligneCand = sansEspaceDebutEtFin($ligneCand) ;

  if ($dbg_CmtIncLigne == 1) { print " test de $ligneCand \n" }  ;

  if (length($ligneCand)>1) {
     if (substr($ligneCand,0,2) eq "#:") { $retIncLig = 1 } ;
  } ; # fin de si plus de 2 caractres

  if ($dbg_CmtIncLigne == 1) { print "    ===> on renvoie $retIncl \n"  ; }  ;

  return($retIncLig) ;

} ; # fin sub cmtInclusionLigne

##########################################################################

sub  inclusionLigne  { my $dbg_incLigne = 0 ; # 0 pour normal, 1 pour dbug

  # ce sous-programme vient inclure le fichier dont le nom est
  # dans la ligne passe en paramtre aprs les caractres "#>"

  if ($dbg_incLigne == 1) { print " inclusion par $ligneIncl \n" ; }  ;

  my $ligneIncl = $_[0] ; # ligne d'inclusion
  my $nomFicInc = ""    ; # nom du fichier  inclure

  $ligneIncl = sansEspaceDebutEtFin(substr($ligneIncl,2)) ;

  if ($dbg_incLigne == 1) { print " soit  rajouter $ligneIncl \n" ; &attends() ; }  ;

   &{"Commentaire_".$Lang}("#-#  La ligne suivante provient d'un ajout via le code #: ") ;
   print  $::SymbFLang "\n" ;

   print  $::SymbFLang $ligneIncl ;
   print  $::SymbFLang "\n" ;

} ; # fin sub inclusionLigne

##########################################################################

sub  cmtInclusionFichier  { my $dbg_CmtIncl = 0 ; # 0 pour normal, 1 pour dbug

  # ce sous-programme renvoie 1 s'il faut inclure un fichier

  my $ligneCand = $_[0] ; # ligne candidate pour l'inclusion de fichier
  my $retIncl   = 0     ; # rsultat renvoy

  $ligneCand = sansEspaceDebutEtFin($ligneCand) ;

  if ($dbg_CmtIncl == 1) { print " test de $ligneCand \n" }  ;
  if (length($ligneCand)>1) {
     if (substr($ligneCand,0,2) eq "#>") { $retIncl = 1 } ;
  } ; # fin de si plus de 2 caractres

  if ($dbg_CmtIncl == 1) { print "    ===> on renvoie $retIncl \n"  ; }  ;

  return($retIncl) ;

} ; # fin sub cmtInclusionFichier

##########################################################################

sub  inclusionFichier  { my $dbg_inclFichier = 0 ; # 0 pour normal, 1 pour dbug

  # ce sous-programme vient inclure le fichier dont le nom est
  # dans la ligne passe en paramtre aprs les caractres "#>"

  my $ligneIncl = $_[0] ; # ligne d'inclusion
  my $nomFicInc = ""    ; # nom du fichier  inclure

  $ligneIncl = sansEspaceDebutEtFin($ligneIncl) ;

  if ($dbg_inclFichier == 1) { print " test de $ligneIncl \n" ; &attends() ; }  ;

  $nomFicInc = sansEspaceDebutEtFin(substr($ligneIncl,2)) ;
  if (not(-r $nomFicInc)) {
     die ("          Erreur ! Impossible de lire dans $nomFicInc\n\n") ;
  } else {
    if ($dbg_inclFichier == 1) { print " on vient donc inclure $nomFicInc \n" }  ;
    &{"Commentaire_".$Lang}("#-#  Ajout de $nomFicInc via le code #> ") ;
    print  $::SymbFLang "\n" ;
    print  $::SymbFLang "\n" ;
    open(FINC,"<$nomFicInc") or die ("          Erreur ! Impossible de lire dans $nomFicInc\n\n") ;
    while (<FINC>) {
      print  $::SymbFLang $_ ;
    } ; # fin tant que on lit sur FINC
    close(FINC) ;
    print  $::SymbFLang "\n" ;
    &{"Commentaire_".$Lang}("#-#  Fin d'ajout de $nomFicInc via le code #> ") ;
    print  $::SymbFLang "\n" ;
  } ; # fin de si fichier vu

} ; # fin sub inclusionFichier

##########################################################################
##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
