#  TimeStamp  (dos) : 25 Juillet 03 20:27  --  x:\galg\galgvars.pm
# galgvars.pm

package galgvars  ;
require Exporter ;
@ISA    = qw(Exporter) ;
@EXPORT = (
'testeIdentificateur',
'proposeDimension',
'proposeArite',
'ajouteVar',
'ajouteVarFic',
'ajouteVarEnpartiegauche',
'ajouteModule',
'ajouteTableau',
'afficheListeModules',
'afficheListeVariables',
'afficheListeVarFichiers',
'afficheListeTableaux',
'testeHomonymie'
) ;

  use lib $ENV{"PERL_MACROS"} ; # rpertoire des modules perl personnels

  use galgfncs ; # Bibliothque de fonctions utiles sur chaines

 #########################################################################################


#########################################################################################
##                                                                                      #
##      sous-programmes de gestion des identificateurs                                  #
##                                                                                      #
#########################################################################################

#########################################################################################
#########################################################################################

sub testeIdentificateur  { my $dbg_Tei = 0 ; # 0 en mode normal, 1 pour debug

  # identificateur valide : une lettre puis une rptition (ventuellement vide)
  # de lettres, chiffres ou symbole _
  # mais : ce ne doit pas etre un mot-clef
  # renvoie 0 si ok, 1 si invalide


  $idv = 0 ;
  $lidentf = $_[0] ;
  $lidentf = &sansEspaceDebutEtFin($lidentf) ;

  if ($dbg_Tei==1) { print "    TEST DE L'IDENTIFICATEUR '$lidentf'\n" ; } ;

  if (length($lidentf)>0) {
     if ($dbg_Tei==1) { print "    TEST DE L'IDENTIFICATEUR '$lidentf' AVEC $main::masqI\n" ; } ;

     if ($lidentf !~ $main::masqI) {
        $idv = 1 ;
        if ($dbg_Tei==1) { print "    L'IDENTIFICATEUR '$lidentf' NE CORRESPOND PAS A $mmain::asqI\n" ; } ;
        $ligneIdent = " $lidentf " ;
        # old : if ($c_err eq "   ") { &galgerr::erreur("020") } ;
        &galgerr::erreur("020") ;
     } ; # fin si l'identificateur n'est pas valide

     $lidentf = " ".uc($lidentf)." " ;
     if ($dbg_Tei==1) { print "    TEST DE L'IDENTIFICATEUR '$lidentf'\n" ; } ;
     if ( (index($galganl::ldpmV,$lidentf)>-1) and (&chaineVide($lidentf)==0) ) {
        $idv = 1 ;
        if ($dbg_Tei==1) { print "    L'IDENTIFICATEUR '$lidentf' EST HOMONYME D'UN MOT CLEF\n" ; } ;
        &galgerr::erreur("035") ;
     } ; # fin si identificateur homonyme d'un mot-clef

     $jidentf = " ".uc(&sansEspaceDebutEtFin($lidentf))." " ;
     if ( ($jidentf eq " A ") or ($jidentf eq " DE ") ) { $idv = 1 ; &galgerr::erreur("009") ; } ;

  } ; # fin si identificateur non vide

  if ($dbg_Tei==1) { print "    POUR L'IDENTIFICATEUR '$lidentf' on renvoie $idv\n" ;  } ;

  return $idv ;

} ; # fin sub testeIdentificateur

#########################################################################################

sub  proposeArite  {

  # ce sous-programme prend deux paramtres : le nom d'un module et
  # son arit possible ; si l'arit n'existe pas, on la prend comme
  # rfrence ; si elle existe, on vrifie que c'est la meme que
  # celle propose ; sinon, on dit que c'est l'erreur 53 ;

  my $nomDeMod = &sansEspaceDebutEtFin($_[0]) ; # nom du module
  my $ariPro   = $_[1] ; # arit propose

  if (length($arite{$nomDeMod})==0) {
     $arite{$nomDeMod} =  $ariPro ;
  } else {
    if ($arite{$nomDeMod} !=  $ariPro) { &galgerr::erreur("053") } ;
  } ; # fin de si pas d'arit connue

} ; # fin sub proposeArite

#########################################################################################

sub  proposeDimension  {

  # ce sous-programme prend deux paramtres : le nom d'un tableau et
  # ses dimensions possibles ; si les dimensions n'existent pas, on les prend comme
  # rfrences ; si elles existent, on vrifient que ce sont les memes que
  # celles proposes ; sinon, on dit que c'est l'erreur 54 ;

  my $nomDeTab = &sansEspaceDebutEtFin($_[0]) ; # nom du tableau
  my $dimTab   = $_[1] ; # arit propose

  if (length($dimen{$nomDeTab})==0) {
     $dimen{$nomDeTab} =  $dimTab ;
  } else {
    if ($dimen{$nomDeTab} !=  $dimTab) { &galgerr::erreur("054") } ;
  } ; # fin de si pas d'arit connue

} ; # fin sub proposeDimension


#########################################################################################
#########################################################################################


#########################################################################################
##                                                                                      #
##      sous-programmes de gestion des liste de variables, tableaux, modules            #
##                                                                                      #
#########################################################################################

# les 4 sous-programmes qui suivent fonctionnent sur le m\^eme principe :
# on garde le mot associ au premier paramtre et on vrifie qu'il constitue un
# identificateur valide. le deuxime paramtre est le numro de la ligne en cours
# dans le fichier-algorithme.
#
# si c'est le cas, :
#
#   - on le rajoute  la liste correspondante s'il n'y est pas dja prsent ;
#   - on compte une rfrence de plus
#   - on enregistre le numro de ligne pour la premire occurence
#
# chaque sous-programme ne teste pas l'homonymie (le meme nom pour une
# variable et un tableau ou un module) car les appels de modules ne savent
# pas distinguer variables et tableaux. l'homonymie est teste en fin de
# programme, lorsqu'on affiche les listes de variables, modules et tableaux.


#########################################################################################
#########################################################################################


sub ajouteVar  { # renvoie 0 si ok, 1 si invalide

# on ajoute la variable dont l'identificateur est pass en paramtre
#  la variable globale main::lstVars

    my $lavar     = &sansEspaceDebutEtFin($_[0]) ;

    if (length($lavar)>0) {

       my $indLigneA = $_[1] ; # numro de la ligne incrimine dans l'algorithme
       my $retTestId = &testeIdentificateur($lavar) ;

       if ($retTestId == 0) {
          if (index($main::lstVars," $lavar ") == -1) { $main::lstVars .= " $lavar " ; } ;
          if (length($refLigneVar{$lavar})     ==  0) { $refLigneVar{$lavar} = $indLigneA ; } ;
          $refVarCnt{$lavar}++ ;
       } ; # fin de si identificateur valide

    } ; # fin de si identificateur non vide

    return $retTestId ;

} ; # fin sub ajouteVar

#########################################################################################

sub ajouteVarEnpartiegauche  { # renvoie  0 si ok, 1 si invalide

# on ajoute la variable dont l'identificateur est pass en paramtre
#  la variable globale main::lstVarsGauche

    my $lavar     = &sansEspaceDebutEtFin($_[0]) ;

    if (length($lavar)>0) {

       my $indLigneA = $_[1] ; # numro de la ligne incrimine dans l'algorithme
       my $retTestId = &testeIdentificateur($lavar) ;

       if ($retTestId == 0) {
          &ajouteVar($lavar) ;
          if (index($main::lstVarsGauche," $lavar ") == -1) { $main::lstVarsGauche .= " $lavar " ; } ;
          if (length($refLigneVar{$lavar})           ==  0) { $refLigneVar{$lavar}  = $indLigneA ; } ;
       } ; # fin si identificateur valide

    } ; # fin de si identificateur non vide

    return $retTestId ;

} ; # fin sub ajouteVarEnpartiegauche


#########################################################################################

sub ajouteVarFic  { # renvoie 0 si ok, 1 si invalide

# on ajoute la variable dont l'identificateur est pass en paramtre
#  la variable globale main::lstFic

    my $lavar     = &sansEspaceDebutEtFin($_[0]) ;

    if (length($lavar)>0) {

       my $indLigneA = $_[1] ; # numro de la ligne incrimine dans l'algorithme
       my $retTestId = &testeIdentificateur($lavar) ;

       if ($retTestId == 0) {
          if (index($main::lstFic," $lavar ") == -1) { $main::lstFic .= " $lavar " ; } ;
          if (length($refLigneVarFic{$lavar}) ==  0) { $refLigneVarFic{$lavar} = $indLigneA ; } ;
          $refVarFicCnt{$lavar}++ ;
       } ; # fin de si identificateur valide

    } ; # fin de si identificateur non vide

    return $retTestId ;

} ; # fin sub ajouteVarFic


#########################################################################################

sub ajouteModule  { # renvoie 0 si ok, 1 si invalide

# on ajoute le module dont l'identificateur est pass en paramtre
#  la variable globale main::lstModules

    my $lemodule  = &sansEspaceDebutEtFin($_[0]) ;

    if (length($lemodule)>0) {

       my $indLigneA = $_[1] ; # numro de la ligne incrimin dans l'algorithme
       my $retTestId = &testeIdentificateur($lemodule) ;

       if ($retTestId == 0) {
          if (index($main::lstModules," $lemodule ") == -1) { $main::lstModules .= " $lemodule " ; } ;
          if (length($refLigneMod{$lemodule})        ==  0) { $refLigneMod{$lemodule} = $indLigneA ; } ;
          $refModCnt{$lemodule}++ ;
       } ; # fin si identificateur valide

    } ; # fin de si identificateur non vide

    return $retTestId ;

} ; # fin sub ajouteModule

###########################################################################

sub ajouteTableau  { # renvoie 0 si ok, 1 si invalide

# on ajoute le tableau dont l'identificateur est pass en paramtre
#  la variable globale main::lstTableaux

    my $letableau = &sansEspaceDebutEtFin($_[0]) ;

    if (length($letableau)>0) {

       my $indLigneA = $_[1] ; # numro de la ligne incrimin dans l'algorithme
       my $retTestId = &testeIdentificateur($letableau) ;

       if ($retTestId == 0) {
          if (index($main::lstTableaux," $letableau ")  == -1) { $main::lstTableaux .= " $letableau " ; } ;
          if (length($refLigneTab{$letableau})          ==  0) { $refLigneTab{$letableau} = $indLigneA ; } ;
          $refTabCnt{$letableau}++ ;
       } ; # fin si identificateur valide

    } ; # fin de si identificateur non vide

    return $retTestId ;

} ; # fin sub ajouteTableau


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programme d'affichage des listes                            #
#                                                                         #
#             - de variables                                              #
#             - de tableaux                                               #
#             - de modules                                                #
#                                                                         #
#        On y range aussi la fonction de test d'homonymie                 #
#        avec affichage ventuel des variables homonymes.                 #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################

sub afficheListeVariables  {

 open(FLVM,">>".$_[0]) or die ("          Erreur ! Impossible d'crire dans $_[0]\n\n") ;

 # pour chaque variable, on affiche son nom, la premire ligne o elle
 # apparait et le nombre de fois o elle est utilise

 my @ldv = split(" ",$main::lstVars) ;
 my $nbVar = 0 ;

 foreach $lavar (sort @ldv) {
   $nbVar++ ;
   if ($nbVar==1) {
      print FLVM "\n * Liste des variables (par ordre alphabtique)\n\n" ;
      print      "\n * Liste des variables (par ordre alphabtique)\n\n" ;
      print FLVM " Variable                             Ligne de premire     Nombre de   \n" ;
      print      " Variable                             Ligne de premire     Nombre de   \n" ;
      print FLVM "                                         utilisation        rfrences\n" ;
      print      "                                         utilisation        rfrences\n" ;
   } ; # fin si premire variable

   my $cadrage = " " x 19 ;

   print FLVM "  #  ".sprintf("%-20s",$lavar).$cadrage.sprintf("%4d",$refLigneVar{$lavar}) ;
   print      "  #  ".sprintf("%-20s",$lavar).$cadrage.sprintf("%4d",$refLigneVar{$lavar}) ;
   print FLVM   sprintf("             %4d",$refVarCnt{$lavar})."\n" ;
   print        sprintf("             %4d",$refVarCnt{$lavar})."\n" ;
 } ; # fin pour chaque variable

 if ($nbVar==0) {
      print FLVM "\n * Aucune variable dans cet algorithme.\n\n" ;
      # print      "\n * Aucune variable dans cet algorithme.\n\n" ;
 } ;  # fin si aucune variable

 close(FLVM) ;

} ; # fin sub afficheListeVariables


#########################################################################################

sub afficheListeVarFic  {

 open(FLVM,">>".$_[0]) or die ("          Erreur ! Impossible d'crire dans $_[0]\n\n") ;

 # pour chaque variable de fichier, on affiche son nom, la premire ligne o elle
 # apparait et le nombre de fois o elle est utilise

 my @ldv = split(" ",$main::lstFic) ;
 my $nbVar = 0 ;

 foreach $lavar (sort @ldv) {
   $nbVar++ ;
   if ($nbVar==1) {
      print FLVM "\n ** Liste des variables de fichier (par ordre alphabtique)\n\n" ;
      print      "\n ** Liste des variables de fichier (par ordre alphabtique)\n\n" ;
      print FLVM " Variable                             Ligne de premire     Nombre de   \n" ;
      print      " Variable                             Ligne de premire     Nombre de   \n" ;
      print FLVM "                                         utilisation        rfrences\n" ;
      print      "                                         utilisation        rfrences\n" ;
   } ; # fin si premire variable

   my $cadrage = " " x 19 ;

   print FLVM "  #  ".sprintf("%-20s",$lavar).$cadrage.sprintf("%4d",$refLigneVarFic{$lavar}) ;
   print      "  #  ".sprintf("%-20s",$lavar).$cadrage.sprintf("%4d",$refLigneVarFic{$lavar}) ;
   print FLVM   sprintf("             %4d",$refVarFicCnt{$lavar})."\n" ;
   print        sprintf("             %4d",$refVarFicCnt{$lavar})."\n" ;
 } ; # fin pour chaque variable

 if ($nbVar==0) {
      print FLVM "\n ** Aucune variable de fichier dans cet algorithme.\n\n" ;
      #    print      "\n ** Aucune variable de fichier dans cet algorithme.\n\n" ;
 } ;  # fin si aucune variable

 close(FLVM) ;

} ; # fin sub afficheListeVarFic


#########################################################################################


sub afficheListeTableaux  {


 open(FLVM,">>".$_[0]) or die ("          Erreur ! Impossible d'crire dans $_[0]\n\n") ;

 # pour chaque tableau, on affiche son nom, la premire ligne o il
 # apparait et le nombre de fois o il est utilis

 my @ldt = split(" ",$main::lstTableaux) ;
 my $nbTableaux = 0 ;

 foreach $letableau (sort @ldt) {
   $nbTableaux++ ;
   if ($nbTableaux==1) {
      print FLVM "\n *** Liste des tableaux (par ordre alphabtique)\n\n" ;
      print      "\n *** Liste des tableaux (par ordre alphabtique) \n\n" ;
      print FLVM " Tableau                 Dims.        Ligne de premire     Nombre de   \n" ;
      print      " Tableau                 Dims.        Ligne de premire     Nombre de   \n" ;
      print FLVM "                                         utilisation        rfrences\n" ;
      print      "                                         utilisation        rfrences\n" ;
   } ; # fin si premier tableau
   my $cadrage = " " x 15 ;
   print FLVM   "  #  ".sprintf("%-20s",$letableau)."   ".$dimen{$letableau}.$cadrage.sprintf("%4d",$refLigneTab{$letableau}) ;
   print        "  #  ".sprintf("%-20s",$letableau)."   ".$dimen{$letableau}.$cadrage.sprintf("%4d",$refLigneTab{$letableau}) ;
   print FLVM   sprintf("             %4d",$refTabCnt{$letableau})."\n" ;
   print        sprintf("             %4d",$refTabCnt{$letableau})."\n" ;
 } ; # fin pour chaque tableau

 if ($nbTableaux==0) {
     print FLVM "\n *** Aucun tableau dans cet algorithme.\n\n" ;
     # print      "\n *** Aucun tableau dans cet algorithme.\n\n" ;
 } ; # fin si aucun tableau

 close(FLVM) ;

} ; # fin sub afficheListeTableaux


#########################################################################################


sub afficheListeModules  {

 open(FLVM,">>".$_[0]) or die ("          Erreur ! Impossible d'crire dans $_[0]\n\n") ;

 # pour chaque module, on affiche son nom, la premire ligne o il
 # apparait et le nombre de fois o il est utilis

 my @ldm = split(" ",$main::lstModules) ;
 my $nbModules = 0 ;

 foreach $lemodule (sort @ldm) {
   $nbModules++ ;
   if ($nbModules==1) {
      print FLVM "\n **** Liste des modules (par ordre alphabtique)\n\n" ;
      print      "\n **** Liste des modules (par ordre alphabtique)\n\n" ;
      print FLVM " Module                  Arit        Ligne de premire     Nombre de   \n" ;
      print      " Module                  Arit        Ligne de premire     Nombre de   \n" ;
      print FLVM "                                         utilisation        rfrences\n" ;
      print      "                                         utilisation        rfrences\n" ;
   } ; # fin si premier module
   my $cadrage = " " x 15 ;
   print FLVM    "  #  ".sprintf("%-20s",$lemodule)."   ".$arite{$lemodule}.$cadrage.sprintf("%4d",$refLigneMod{$lemodule}) ;
   print         "  #  ".sprintf("%-20s",$lemodule)."   ".$arite{$lemodule}.$cadrage.sprintf("%4d",$refLigneMod{$lemodule}) ;
   print FLVM    sprintf("             %4d",$refModCnt{$lemodule})."\n" ;
   print         sprintf("             %4d",$refModCnt{$lemodule})."\n" ;
 } ; # fin pour chaque module

 if ($nbModules==0) {
     print FLVM "\n **** Aucun module dans cet algorithme.\n\n" ;
     #    print      "\n **** Aucun module dans cet algorithme.\n\n" ;
 } ; # fin si aucun module

 close(FLVM) ;

} ; # fin sub afficheListeModules


#########################################################################################



sub  testeHomonymie  {  my $dbg_Homony = 0 ; # 0 pour ok, 1 pour debug

  # un identificateur est en homonymie s'il est  la fois employ
  #   -    comme variable et comme module
  #   - ou comme variable et comme tableau
  #   - ou comme module   et comme tableau

  open(FLVM,">>".$_[0]) or die ("          Erreur ! Impossible d'crire dans $_[0]\n\n") ;

  my $nbHomonymes =0 ; # nombre d'homonymes

  my @ldm = split(" ",$main::lstModules) ;
  my @ldv = split(" ",$main::lstVars) ;
  my @ldt = split(" ",$main::lstTableaux) ;

  foreach $letableau (sort @ldt) {
     $letableau = &sansEspaceDebutEtFin($letableau) ;
     if (length($letableau)>0) { $refVar{$letableau}++ ;
        if ($dbg_Homony==1) { print " * variable '$letableau' compte $refVar{$letableau} Tableau\n" ; } ;
     } ; # fin si
  } ; # fin pour chaque tableau

  foreach $lemodule (sort @ldm) {
    $lemodule = &sansEspaceDebutEtFin($lemodule) ;
    if (length($lemodule)>0) { $refVar{$lemodule} += 2 ;
       if ($dbg_Homony==1) { print " ** variable '$lemodule' compte $refVar{$lemodule} Module\n" ; } ;
     } ; # fin si
  } ; # fin pour chaque module

  foreach $lavariable (sort @ldv) {
    $lavariable = &sansEspaceDebutEtFin($lavariable) ;
    if (length($lavariable)>0) { $refVar{$lavariable} += 4 ;
       if ($dbg_Homony==1) { print " *** variable '$lavariable'  ".length($lavariable)."compte $refVar{$lavariable} Variable\n" ; } ;
     } ; # fin si
  } ; # fin pour chaque variable

  foreach $variable (sort keys %refVar) {
    if ($dbg_Homony==1) { print " AU FINAL : variable $variable  compte $refVar{$variable}\n" ; } ;
    if ($refVar{$variable} == 3) {
        $nbHomonymes++ ;
        $varHomonymes{$variable} = " Tableau et Module " ;
    } ; # fin de si

    if ($refVar{$variable} == 5) {
        $nbHomonymes++ ;
        $varHomonymes{$variable} = " Tableau et Variable " ;
    } ; # fin de si

    if ($refVar{$variable} == 6) {
        $nbHomonymes++ ;
        $varHomonymes{$variable} = " Module et Variable " ;
    } ; # fin de si

    if ($refVar{$variable} == 7) {
        $nbHomonymes++ ;
        $varHomonymes{$variable} = " Module et Variable et Tableau" ;
    } ; # fin de si

  } ; # fin pour chaque variable

  if ($nbHomonymes>0) {
     if ($nbHomonymes==1) {
         print FLVM "\n Il y a un identificateur en homonymie  savoir : \n\n" ;
         print      "\n Il y a un identificateur en homonymie  savoir : \n\n" ;
     } else {
         print FLVM "\n Il y a $nbHomonymes identificateurs en homonymie  savoir : \n\n" ;
         print      "\n Il y a $nbHomonymes identificateurs en homonymie  savoir : \n\n" ;
     } ; # fin de si
     foreach $variable (sort keys %varHomonymes) {
         print FLVM sprintf("    %-15s",$variable)." ".sprintf("    %-15s",$varHomonymes{$variable})."\n" ;
         print      sprintf("    %-15s",$variable)." ".sprintf("    %-15s",$varHomonymes{$variable})."\n" ;
     } ; # fin pour chaque variable
  } ; # fin si

  close(FLVM) ;

  return ;

} ; # fin sub testeHomonymie

#########################################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
